/*
TASK:x1
LANG:C
*/

#include <stdio.h>
#include <memory.h>

#define MAXN 64
#define MAXL 64
#define BASE 1000000000

struct big_num {
	int m[MAXL];
};

int N;
struct big_num C[MAXN];
struct big_num dp[MAXN];

void prnt_big_num (const struct big_num *a);

void init_big_num (struct big_num *a) {
	memset (a->m, 0, sizeof (a->m));
}

void mul_big_num (struct big_num *a, const struct big_num *b) {
	long long m[MAXL] = {0};
	int i, j;
	for (i = 0; i < MAXL; ++i)
		for (j = 0; i+j+1 < MAXL; ++j) {
			m[i+j] += (long long)a->m[i] * b->m[j];
			m[i+j+1] += m[i+j] / BASE;
			m[i+j] %= BASE;
		}
	for (i = 0; i < MAXL; ++i)
		a->m[i] = m[i];
}

void pow2_big_num (struct big_num *a, int pow) {
	init_big_num (a);
	a->m[0] = 1;
	int i, pr = 0;
	while (pow--) {
		for (i = 0; i < MAXL; ++i) {
			a->m[i] *= 2;
			a->m[i] += pr;
			pr = a->m[i] >= BASE;
			a->m[i] -= pr * BASE;
		}
//		prnt_big_num (a);
	}
}

void copy_big_num (struct big_num *a, const struct big_num *b) {
	memcpy (a->m, b->m, sizeof (a->m));
}

void add_big_num (struct big_num *a, const struct big_num *b) {
	int i;
	for (i = 0; i + 1 < MAXL; ++i) {
		a->m[i] += b->m[i];
		a->m[i+1] += a->m[i] / BASE;
		a->m[i] %= BASE;
	}
}

void sub_big_num (struct big_num *a, const struct big_num *b) {
	int i;
	for (i = 0; i + 1 < MAXL; ++i) {
		if (a->m[i] < b->m[i]) {
			--a->m[i+1];
			a->m[i] += BASE;
		}
		a->m[i] -= b->m[i];
	}
}

void prnt_big_num (const struct big_num *a) {
	int i;
	for (i = MAXL-1; i > 0 && !a->m[i]; --i);
	printf ("%d", a->m[i]);
	for (--i; i >= 0; --i)
		printf ("%09d", a->m[i]);
	puts ("");
}

int main () {
	int i, j;
	scanf ("%d", &N);

	for (i = 0; i < MAXN; ++i)
		init_big_num (C + i);
	init_big_num (dp);

	C[0].m[0] = 1;
	dp[0].m[0] = 1;
	struct big_num tmp;
	for (i = 1; i <= N; ++i) {
		pow2_big_num (dp + i, i * (i-1) / 2);
//		prnt_big_num (dp + i);
//		printf ("init %d\n", i); prnt_big_num (dp + i);
		for (j = i; j; --j) {
			add_big_num (C + j, C + j - 1);
//			printf ("C[%d] == ", j); prnt_big_num (C + j);
//			C[j] += C[j-1];
//			printf ("\tsub %d %lld\n", C[j], dp[i-j]);

//			dp[i] -= C[j] * dp[i-j];
			copy_big_num (&tmp, C + j);
//			printf ("tmp == "); prnt_big_num (&tmp);
			mul_big_num (&tmp, dp + i - j);
//			printf ("dp[%d-%d _ %d]", i, j, i-j); prnt_big_num (dp + i - j);
//			printf ("tmp * dp[%d] == ", i - j); prnt_big_num (&tmp);
			sub_big_num (dp + i, &tmp);
//			printf ("AFTER SUB dp[%d] = ", i); prnt_big_num (dp + i);
		}
//		printf ("%d - %lld\n", i, dp[i]);
		//printf ("%d - ", i); 
		if (i==N) prnt_big_num (dp + i);
	}


/*
	struct big_num x;
	init_big_num (&x);
	x.m[0] = 123456789;
	prnt_big_num (&x);
	mul_big_num (&x, &x);
	prnt_big_num (&x);
	mul_big_num (&x, &x);
	prnt_big_num (&x);
	mul_big_num (&x, &x);
	prnt_big_num (&x);
	mul_big_num (&x, &x);
	prnt_big_num (&x);*/

	return 0;
}
