/*
TASK: economics
LANG: C++
*/

#include <cstdio>
#include <string>
#include <iostream>
#include <queue>

using namespace std;

const int MAXN		= 16;


double d[MAXN][MAXN];
char str[MAXN][MAXN];
int n, m;


struct P {
	int x, y;
	double r;
	P ( int t1=0, int t2=0, double t3=0.0) : x(t1), y(t2), r(t3) {}
	bool valid() {
		return !( y < 1 || y > m );
	}
};

void bfs (int pos) {

	queue<P> q; q.push( P(1, pos, 1.0 / (double) m) );
	
	while ( !q.empty() ) {
		P pp = q.front(); q.pop();
		if ( !pp.valid() ) continue ;
		d[pp.x][pp.y] += pp.r;
		int x = pp.x;
		int y = pp.y;
		if ( str[pp.x][pp.y] == '\\' ) {
			q.push ( P(x+1, y+1, pp.r) );
		}
		if ( str[pp.x][pp.y] == '/' ) {
			q.push ( P(x+1, y-1, pp.r) );
		}
		if ( str[pp.x][pp.y] == '|' ) {
			q.push ( P(x+1, y, pp.r ) );
		}
		if ( str[pp.x][pp.y] == '*' ) {
			if ( pp.r / 5.0 < 0.001 ) continue ;
			q.push ( P(x, y-1, pp.r / 5.0 ));
			q.push ( P(x, y+1, pp.r / 5.0 ));
			q.push ( P(x+1, y-1, pp.r / 5.0 ));
			q.push ( P(x+1, y+1, pp.r / 5.0 ));
			q.push ( P(x+1, y, pp.r / 5.0 ));
		}

//		if ( str[pp.x][pp.y] == 'v' ) continue ;

	}

}

int main () {

	scanf ("%d %d\n", &n, &m);
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= m; ++j)
			scanf ("%c\n", &str[i][j]);
//		scanf ("\n");
	}
/*
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= m; ++j)
			printf ("%c", str[i][j]);
		puts("");
	}
*/
	for (int i = 1; i <= m; ++i) bfs(i);
	
	double total = 0.0;
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j)
			if ( str[i][j] == 'v' ) total += d[i][j];
/*
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= m; ++j)
			printf ("%lf ", d[i][j]);
		puts("");
	}
*/
	printf ("%.3lf\n", total);

	return 0;
}
