/*
TASK: billiard
LANG: C++
*/

#include <cstdio>
#include <cmath>

struct point {
  double x, y;
  point() { }
  point(double _x, double _y) : x(_x), y(_y) { }
  point(point a, point b) : x(b.x-a.x), y(b.y-a.y) { }
  double length() { return sqrt(x*x+y*y); }
  void resize(double target) { double coef = target / length(); x *= coef; y *= coef; }
  void lperp() { double z = x; x = -y; y = z; }
  void rperp() { double z = x; x = y; y = -z; }
  double angle() { return atan2(y, x); }
};

double fixa(double a) { return a >= 0 ? a : a+2*M_PI; }
double raddeg(double a) { return a / M_PI * 180; }

bool checka(double a) {
  double fmod = fabs(a);
  return fmod >= M_PI/2 && fmod <= 3*M_PI/2;
}

double sc(point a, point b, point c) {
  point p1(a, b);
  point p2(b, c);
  return p1.x*p2.y - p1.y*p2.x;
}

int main() {
  point w, b, h;
  scanf("%lf%lf%lf%lf%lf%lf", &w.x, &w.y, &b.x, &b.y, &h.x, &h.y);
  point v1(w, b);
  point v2(b, h);
  point sv3 = v2; sv3.lperp(); sv3.resize(1);
  point sv4 = v2; sv4.rperp(); sv4.resize(1);
  
  point v3(b, point(h.x+sv3.x, h.y+sv3.y));
  point v4(b, point(h.x+sv4.x, h.y+sv4.y));
  
  point v1rp = point(v1, v2); v1rp.rperp();
  point v1lp = point(v1, v2); v1lp.lperp();
  
  point t1(v1.x+v1rp.x, v1.y+v1rp.y);
  point t2(v1.x+v1lp.x, v1.y+v1lp.y);
  
  printf("%d\n", sc(v1, v2, t1) > 0 && sc(v1, v2, t2) < 0);
  
  return 0;
}
