/*
TASK: X2
LANG: C++
*/
#include <cstdio>
#include <string>

using namespace std;

int brace_match(string& s, int pos) {
    int cnt = 0;
    do {
        if(s[pos] == '(') ++cnt;
        if(s[pos] == ')') --cnt;
        ++pos;
    } while(cnt);
    return pos-1;
}

int read_arg(string& s, int start) {
    if(start >= s.length()) return 0;
    if(s[start] == '(') return brace_match(s, start)+1;
    if(s[start] == ')') return 0;
    return start+1;
}

bool sim_i(string& s, int pos) {
    int arg = read_arg(s, pos+1);
    if(arg) {
        s.erase(s.begin()+pos);
        return true;
    } else {
        return false;
    }
}

bool sim_k(string& s, int pos) {
    int arg1 = read_arg(s, pos+1);
    int arg2 = read_arg(s, arg1);
    if(arg1 && arg2) {
        s = s.substr(0, pos)+s.substr(pos+1, arg1-pos-1)+s.substr(arg2);
        return true;
    } else {
        return false;
    }
}

bool sim_s(string& s, int pos) {
    int arg1 = read_arg(s, pos+1);
    int arg2 = read_arg(s, arg1);
    int arg3 = read_arg(s, arg2);
    if(arg1 && arg2 && arg3) {
        s = s.substr(0, pos)+s.substr(pos+1, arg1-pos-1)+s.substr(arg2, arg3-arg2)+'('+s.substr(arg1, arg2-arg1)+s.substr(arg2, arg3-arg2)+')'+s.substr(arg3);
        return true;
    }
    return false;
}

bool sim_b(string& s, int pos) {
    int arg1 = read_arg(s, pos+1);
    int arg2 = read_arg(s, arg1);
    int arg3 = read_arg(s, arg2);
    if(arg1 && arg2 && arg3) {
        s = s.substr(0, pos)+s.substr(pos+1, arg1-pos-1)+'('+s.substr(arg1, arg2-arg1)+s.substr(arg2, arg3-arg2)+')'+s.substr(arg3);
        return true;
    }
    return false;
}

bool sim_c(string& s, int pos) {
    int arg1 = read_arg(s, pos+1);
    int arg2 = read_arg(s, arg1);
    int arg3 = read_arg(s, arg2);
    if(arg1 && arg2 && arg3) {
        s = s.substr(0, pos)+s.substr(pos+1, arg1-pos-1)+s.substr(arg2, arg3-arg2)+s.substr(arg1, arg2-arg1)+s.substr(arg3);
        return true;
    }
    return false;
}

bool sim_w(string& s, int pos) {
    int arg1 = read_arg(s, pos+1);
    int arg2 = read_arg(s, arg1);
    if(arg1 && arg2) {
        s = s.substr(0, pos)+s.substr(pos+1, arg1-pos-1)+s.substr(arg1, arg2-arg1)+s.substr(arg1, arg2-arg1)+s.substr(arg2);
        return true;
    }
    return false;
}

bool sim(string& s) {
    bool in_beg = true;
    for(int i = 0; i < s.length(); ++i) {
        char c = s[i];
        if(c == '(') {
            if(in_beg) {
                s.erase(s.begin()+brace_match(s, i));
                s.erase(s.begin()+i);
                return true;
            } else {
                in_beg = true;
            }
        } else {
            if(in_beg) {
                if(c == 'I') {
                    if(sim_i(s, i)) return true;
                } else if(c == 'K') {
                    if(sim_k(s, i)) return true;
                } else if(c == 'S') {
                    if(sim_s(s, i)) return true;
                } else if(c == 'B') {
                    if(sim_b(s, i)) return true;
                } else if(c == 'C') {
                    if(sim_c(s, i)) return true;
                } else if(c == 'W') {
                    if(sim_w(s, i)) return true;
                }
            }
            in_beg = false;
        }
    }
    return false;
}

char buf[1048576];
int main() {
    gets(buf);
    string s = buf;
    while(sim(s));
    printf("%s\n", s.c_str());
    return 0;
}
