/*
ID: espr1t
LANG: C++
TASK: jori
*/

#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <string>
#include <queue>
#include <map>
#include <set>

#define MAX 262144

using namespace std;
FILE *in; FILE *out;

struct Word
{
	int size;
	string repr;
	vector <int> ch;
	
	Word()
	{
		size = 0;
		repr = "";
		ch.resize(26, 0);
	}
};

char buff[MAX];
int position[MAX];
vector <Word> words;
int dyn[MAX][2];

bool cmpFunc(const Word& a, const Word& b)
{
	if (a.size != b.size) return a.size < b.size;
	else return a.ch < b.ch;
}

int recurse(int cur, int len)
{
	int i, c;
	int tmp, best = 1, with = -1;
	
	if (dyn[cur][0] != -1) return dyn[cur][0];
	
	for (i=position[len+1]; i<(int)words.size(); i++)
	{
		if (words[i].size > len + 1) break;
		
		int diff = 0;
		for (c=0; c<26; c++) diff += words[cur].ch[c] != words[i].ch[c];
		
		if (diff == 1)
		{
			tmp = recurse(i, len + 1) + 1;
			if (best < tmp)
			{
				best = tmp;
				with = i;
			}
		}
	}
	
	dyn[cur][0] = best;
	dyn[cur][1] = with;
	return best;
}

int main(void)
{
	int i;
	int ans = 0, from = -1;
	
	in = stdin; out = stdout;
//	in = fopen("jori.in", "rt"); out = fopen("jori.out", "wt");
	
	memset(dyn, -1, sizeof(dyn));
	memset(position, 11, sizeof(position));
	
	while(!feof(in))
	{
		Word word;
		buff[0] = 0;
		fscanf(in, "%s", buff);
		if (strlen(buff) == 0) break;
		
		word.size = strlen(buff);
		if (word.size < 3) continue;

		word.repr = buff;		
		for (i=0; i<(int)word.repr.size(); i++)
			word.ch[word.repr[i] - 'a']++;
		
		words.push_back(word);
	}
	
	sort(words.begin(), words.end(), cmpFunc);
	if (words[0].repr.size() != 3) return 0;
	
	int sz = 3;
	position[sz] = 0;
	for (i=1; i<(int)words.size(); i++)
	{
		if (words[i].size == words[i-1].size) continue;
		else
		{
			if (words[i].size == words[i-1].size + 1)
				position[++sz] = i;
			else break;
		}
	}
	
	for (i=0; i<(int)words.size(); i++)
	{
		if (words[i].repr.size() == 3)
		{
			int tmp = recurse(i, 3);
			if (ans < tmp)
			{
				ans = tmp;
				from = i;
			}
		}
		else break;
	}
	
	while (from != -1)
	{
		fprintf(out, "%s\n", words[from].repr.c_str());
		from = dyn[from][1];
	}
	
	return 0;
}
