/*
ID: espr1t
LANG: C++
TASK: Nobel
*/

#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <string>
#include <queue>
#include <map>
#include <set>

#define MAX 1024
using namespace std;


int tests;
long long b, n, k, ans;

long long fastPow(long long num, long long power, long long mod)
{
	long long mul = num, res = 1;
	
	while (power)
	{
		if (power & 1)
		{
			res *= mul; res %= mod;
		}
		mul = mul * mul; mul %= mod;
		power >>= 1;
	}
	
	return res;
}

int isPrime(int num)
{
	if (num == 1) return 0;
	for (int i=2; i*i <= num; i++)
		if (num % i == 0) return 0;
	
	return 1;
}

int phi(int num)
{
	int i;
	double ans = 1.0;
	
	ans = num;
	if (isPrime(num)) return num - 1;
	for (i=2; i*i<=num; i++)
	{
		if (num % i == 0)
		{
			if (isPrime(i))
				ans *= (1.0 - 1.0 / (double)i);

			if (num / i != i)
			if (isPrime(num / i))
				ans *= (1.0 - 1.0 / (double)(num / i));
		}
	}
	
	return (int)(ans + 0.001);
}

int main(void)
{
	int t;
	cin >> tests;
	
	for (t=0; t<tests; t++)
	{
		cin >> b >> n >> k;
		
		/*
		ans = 0;
		long long add = 1;
		for (int i=0; i<=n; i++)
		{
			ans += add; ans %= k;
			add *= b; add %= k;
		}
		fprintf(out, "%d\n", (int)ans);
		*/
		
		ans = fastPow(b, n + 1, k) - 1;		
		if (ans < 0) ans += k;

		long long div;
		ans = (ans * fastPow(b-1, phi(k)-1, k)) % k;
		
		cout << ans << endl;
	}
	
	return 0;
}
