/*
TASK:jori
LANG:C
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define mod1 666131313
#define mod2 779351713
#define maxn 4500
#define maxm maxn/4*maxn

 typedef long long LL;

 int hash1[maxn],hash2[maxn];

 int b[maxn],last;
 
 struct alabala{
  int v,next;
 };
 struct alabala e[maxm];
 
 int used[maxn];

 void hash(char *str, int i)
 {
  int h1=0,h2=0;
  int j,m;
  
  m=strlen(str);
  
  for(j=0;j<m;j++)
  {
   h1+=((int)str[j]-96)*26;
   h2+=((int)str[j]-96)*26;
   h1%=mod1;
   h2%=mod2;
  }
  
  hash1[i]=h1;
  hash2[i]=h2;
 }

 int bfs(int i)
 {
  int stack[maxn],B,E,C,l=0,v,j;
  B=0;
  C=0;
  E=1;
  stack[B]=i;
  used[i]=-1;
  while(B<E)
  {
   for(;B<C;B++)
   {
    v=stack[B];
//    printf("v= %d",v);
    for(j=b[v];j!=0;j=e[j].next)
    {
     if(!used[e[j].v]){
      used[e[j].v]=v;
//      printf("add to stack %d",e[j].v);
      stack[E++]=e[j].v;
     }
    }
   }
   l++;
   C=E;
  }
  l--;


  last=stack[E-1];
//  printf(" %d\n",last);
  return l;
 }

 char is_e(int i, int j, char **s, int *Hash, int mod) // checks if there should be an edge between i and j according to hash1
 {
  int dif;
  char p;
  dif=Hash[i]-Hash[j];
  if(dif<0){dif+=mod; }
  if(dif==0){printf("Identical words - impossible\n"); exit(1);}
  dif/=26;
  //printf("dif %d %d %d\n",dif,i,j);
  if(dif>26)return 0;
  p='a'+dif-1;
  //printf("%c %d %d \n",p,i,j);
  int l,r,m;
  l=0;
  r=strlen(s[i])-1;
  //printf("r=%d\n",r);
  while(l<=r)
  {
   m=(l+r)>>1;
   //printf("m.. %c\n",s[i][m]);
   //if(s[i][m]==p)break;
   if(s[i][m]>p)r=m-1;
    else l=m+1;
  }
  //printf("r=%d\n",r);
  
  if(s[i][r]==p && s[j][r]!=p)return 1;
  return 0;
 }

 void sortc(char *str) //sorts some string
 {
  int i, j,n=strlen(str);
  
  char fl=1, p;

  while(fl==1)
  {
   fl=0;
   for(i=0;i<n-1;i++)
    if(str[i]>str[i+1]){
     fl=1;
     p=str[i];
     str[i]=str[i+1];
     str[i+1]=p;
    }
  }
 }

 int main()
 {
  int i,n=0,j,br=1,max=0,otg[maxn];
  FILE *fi=stdin;
  char s[maxn][256];
  char **sorted;

  sorted=(char **)malloc(maxn*sizeof(char*));

  for(i=0;i<maxn;i++)
   sorted[i]=(char*)malloc(sizeof(char)*maxn);
   
//  printf("starting...\n");

  while(!feof(fi))
  {
   fscanf(fi,"%s",&s[n]);
   hash(s[n],n);
   strcpy(sorted[n],s[n]);
   sortc(sorted[n]);

   n++;
  }
/*  printf("----------HASH--------\n\n\n");
  for(i=0;i<n;i++)
   printf("%d %d\n",hash1[i],hash2[i]);
  
  printf("n=%d\nentering level 2 ...\n",n);*/
  for(i=0;i<n/4*n;i++)
   e[i].next=0;

  for(i=0;i<n;i++)b[i]=0;
  
  br=1;
  for(i=0;i<n-1;i++)
   for(j=i+1;j<n;j++)
   {
    if(is_e(i,j,sorted,hash1,(int)mod1) && is_e(i,j,sorted,hash2,(int)mod2)){
//     printf("adding edge %d->%d\n",j,i);
     e[br].next=b[j+1];
     b[j+1]=br;
     e[br].v=i+1;
     br++;
    }
    else
    if(is_e(j,i,sorted,hash1,(int)mod1) && is_e(j,i,sorted,hash2,(int)mod2)){
//     printf("adding edge %d->%d\n",i,j);
     e[br].next=b[i+1];
     b[i+1]=br;
     e[br].v=j+1;
     br++;
    }
   }

   for(i=0;i<n;i++)used[i]=0;

//     printf("entering level 3...\n");
   for(i=0;i<n;i++)
    if(!used[i] && strlen(s[i])==3){
//     printf("starting first bfs\n");
     j=bfs(i+1);
//     printf("finished first bfs %d\n",j);
     if(j>max){
      max=j;
      j=0;
      while(last>0)
      {
       otg[j]=last;
       last=used[last];
       j++;
      }
     }
    }

/*  printf("max=%d\n",max);
  for(i=0;i<max;i++)
   printf("%d",otg[i]);
  printf("\n");     */
    
  for(i=max-1;i>=0;i--)
   printf("%s\n",s[otg[i]-1]);
  
  return 0;
 }
