/*
TASK: jori
LANG: C++
*/
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

const int MAXN = 200000 + 5;
const int MAXLEN = 1 << 8;
const int mod = 1048573;

int primes[] = {23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97,101,103,107,109,113,127,131,137,139,149};

int n;
char s[MAXN][MAXLEN];

int len[MAXN];
int idx[MAXN];

int ans[MAXN];
int prev[MAXN];

int cnt[1 << 5];
int st[1 << 5][MAXLEN];
int used[mod + 1];

int res[MAXN];
int p;

void read() {
	while ( scanf ( "%s" , s[ ++ n ] ) != -1 ) ;
	-- n;
}

int cmp ( int q , int w ) {
	return len[q] < len[w];
}

void init() {
	int i , j;
	
	for (i = 0; i < 26; i++) {
		st[i][0] = 1;
		for (j = 1; j < MAXLEN; j++)
			st[i][j] = (int)(((long long)st[i][j - 1] * (long long)primes[i]) % (long long)mod);
	}
}

void printpath ( int pos ) {
	while ( pos ) {
		res[ ++ p ] = pos;
		pos = prev[pos];
	}
}

void solve() {
	int i , j , k;
	int code;
	int cur;
	int best;
	int pos;
	
	for (i = 1; i <= n; i++) {
		idx[i] = i;
		len[i] = (int)strlen ( s[i] );
	}
	
	sort ( idx + 1 , idx + n + 1 , cmp );
	
	for (i = 1; i <= n; i++) {
		memset ( cnt , 0 , sizeof cnt );
		cur = idx[i];
		
		if ( len[cur] < 3 ) continue;
		
		for (j = 0; j < (int)len[cur]; j++)
			++ cnt[ s[cur][j] - 'a' ];
		
		for (j = 0; j < 26; j++) {
			if ( !cnt[j] ) continue;
			
			code = 1;
			for (k = 0; k < 26; k ++)
				code = (int)(((long long)st[k][ cnt[k] - (k == j) ] * (long long)code) % (long long)mod);
			
			if ( used[code] > 0 && ans[ used[code] ] + 1 > ans[cur] ) {
				ans[cur] = ans[ used[code] ] + 1;
				prev[cur] = used[code];
			}
		}
		
		code = 1;
		for (k = 0; k < 26; k ++)
			code = (int)(((long long)st[k][ cnt[k] ] * (long long)code) % (long long)mod);
		
		if ( len[cur] == 3 ) {
			ans[cur] = 1;
			used[code] = cur;
		} else
			if ( ans[cur] > 1 )
				used[code] = cur;
	}
		
	best = 0;
	pos = 1;
	for (i = 1; i <= n; i++)
		if ( ans[i] > best ) {
			best = ans[i];
			pos = i;
		}
		
	printpath ( pos );
	
	for (i = p; i >= 1; i--)
		printf ( "%s\n" , s[ res[i] ] );
}

int main() {
	read();
	init();
	solve();
	
	return 0;
}
