/*
TASK: platforms
LANG: C++
*/
#include <queue>
#include <cstdio>
#include <algorithm>
using namespace std;

const int MAXN = 1 << 6;

inline int abs ( int x ) { return x < 0 ? -x : x; }

struct el {
	int x , y;
	int c;
	
	el () {}
	el ( int _x , int _y , int _c ) : x(_x) , y(_y) , c(_c) {}
	
	bool operator < ( el b ) const {
		return c > b.c;
	}
};

int n , m;
pair < int , int > row[MAXN];
pair < int , int > col[MAXN];
int sx , sy , fx , fy;
int sttime;

priority_queue < el , vector < el > > pq;
int d[MAXN][MAXN];

int get() {
	char c;
	
	scanf ( "%c" , &c );
	if ( c == 'F' ) return 1;
	if ( c == 'O' ) return 2;
	if ( c == 'S' ) return 3;
}

void read() {
	int i;
	int q , w;
	
	scanf ( "%d%d\n" , &n , &m );
	
	for (i = 1; i <= n; i++) {
		q = get();
		scanf ( "%d\n" , &w );
		
		row[i] = make_pair ( w , q );
	}
	
	for (i = 1; i <= m; i++) {
		q = get();
		scanf ( "%d\n" , &w );
		
		col[i] = make_pair ( w , q );
	}
	
	scanf ( "%d%d%d%d%d" , &sx , &sy , &sttime , &fx , &fy );
}

void psh ( int x , int y , int c ) {
	if ( d[x][y] == -1 || d[x][y] > c ) {
//		printf ( "%d %d\n" , x , y );
		d[x][y] = c;
		pq.push ( el ( x , y , c ) );
	}
}

int calc ( int from , int to , int time , pair < int , int > bus , int range ) {
	if ( from == to ) return time;
	int x = bus.first + (from - 1) * bus.second;
	int l , r;
	int mid;
	
//	printf ( "%d %d %d   %d %d  %d\n" , from , to , time , bus.first , bus.second , range );
	
	if ( to < from )
		x = x + 2 * (range - from) * bus.second;
	
	l = 0;
	r = MAXN;
	
	while ( l < r ) {
		mid = l + (r - l) / 2;
		
		if ( x + mid * 2 * (range - 1) * bus.second < time )
			l = mid + 1;
		else
			r = mid;
	}
	
	return x + l * 2 * (range - 1) * bus.second + abs ( from - to ) * bus.second;
}

void solve() {
	int i;
	int x , y , c;
	el t;
	
	memset ( d , -1 , sizeof d );
	psh ( sx , sy , sttime );
	
	while ( !pq.empty() ) {
		t = pq.top();
		pq.pop();
		
		x = t.x;		y = t.y;		c = t.c;
		
	//	printf ( "%d %d %d\n" , x , y , c );
		if ( c > d[x][y] ) continue;
		
		for (i = 1; i <= n; i++) 
			psh ( i , y , calc ( x , i , c , col[y] , n ) );
		
		for (i = 1; i <= m; i++)
			psh ( x , i , calc ( y , i , c , row[x] , m ) );
	}
	
	printf ( "%d\n" , d[fx][fy] );
}

int main() {
	read();
	solve();
	
	return 0;
}
