/*
TASK: platforms
LANG: C++
*/
// momtchil
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

#define MAXN 64
int N,M;
int rt[MAXN]; char rc[MAXN];
int ct[MAXN]; char cc[MAXN];
int st,sx,sy,ex,ey;

int spd[256];

int rat(int row,int st,bool &dir)
{
	dir=0;
	if (st<rt[row]) return -1;
	int x=(st-rt[row])/spd[rc[row]];
	x=x%(2*M-2); 
	if (x>=M) x-=M,x=M-x-2,dir=1;
	return x;
}

int cat(int col,int st,bool &dir)
{
	dir=0;
	if (st<ct[col]) return -1;
	int x=(st-ct[col])/spd[cc[col]];
	x=x%(2*N-2);
	if (x>=N) x-=N,x=N-x-2,dir=1;
	return x;
}

typedef pair<int,PI> state;
int mint[MAXN][MAXN];
bool used[MAXN][MAXN];
priority_queue<state,vector<state>,greater<state> > q;

int r,c,t;
void advance(int nr,int nc,int nt)
{
//	cout<<"     try from "<<r<<" "<<c<<" "<<t<<" to "<<nr<<" "<<nc<<" "<<nt<<endl;
	if (mint[nr][nc]<=nt) return;
	mint[nr][nc]=nt;
//	cout<<"                                                         succeeded!\n";
	q.push(MP(nt,MP(nr,nc)));
}





void rowplat()
{
			bool dir,ndir; int after;
			int rpos=rat(r,t,dir);
			if (rpos>=0)
			 {
			   if (!dir)
			    if (c>=rpos)
			     after=c-rpos,ndir=dir;
			    else
			     after=M-rpos+M-c-2,ndir=dir^1;
			   else
			    if (c<=rpos)
				 after=rpos-c,ndir=dir;
				else
				 after=rpos+c,ndir=dir^1;
			   after*=spd[rc[r]];
			 }
			else after=rt[r]-t+spd[rc[r]]*c,ndir=0;
			while (rat(r,t+after-1,dir)==c) after--;
			//cout<<"        row platform "<<rc[r]<<" "<<rt[r]<<" : at "<<rpos<<"    aft "<<after<<" ("<<dir<<" ; new "<<ndir<<")"<<endl;
			
			if (!ndir)
			 {
					for (int i=c+1,attime=t+after+spd[rc[r]] ; i<M ; i++,attime+=spd[rc[r]])
					 advance(r,i,attime);
					for (int i=c-1,attime=t+after+(M*2-c*2-1)*spd[rc[r]]; i>=0; i--,attime+=spd[rc[r]])
					 advance(r,i,attime);
			 }
			else
			 {
					for (int i=c-1,attime=t+after+spd[rc[r]] ; i>=0 ; i--,attime+=spd[rc[r]])
					 advance(r,i,attime);
					for (int i=c+1,attime=t+after+(c*2+1)*spd[rc[r]]; i<M; i++,attime+=spd[rc[r]])
					 advance(r,i,attime);
			 }
}




void colplat()
{
			bool dir,ndir; int after;
			int cpos=cat(c,t,dir);
			if (cpos>=0)
			 {
			   if (!dir)
			    if (r>=cpos)
			     after=r-cpos,ndir=dir;
			    else
			     after=N-cpos+N-r-2,ndir=dir^1;
			   else
			    if (r<=cpos)
				 after=cpos-r,ndir=dir;
				else
				 after=cpos+r,ndir=dir^1;
			   after*=spd[cc[c]];
			 }
			else after=ct[c]-t+spd[cc[c]]*r,ndir=0;
			while (cat(c,t+after-1,dir)==r) after--;
		//	cout<<"        col platform "<<cc[c]<<" "<<ct[c]<<" : at "<<cpos<<"    aft "<<after<<" ("<<dir<<" ; new "<<ndir<<")"<<endl;
			
			if (!ndir)
			 {
					for (int i=r+1,attime=t+after+spd[cc[c]] ; i<N ; i++,attime+=spd[cc[c]])
					 advance(i,c,attime);
					for (int i=r-1,attime=t+after+(N*2-r*2-1)*spd[cc[c]]; i>=0; i--,attime+=spd[cc[c]])
					 advance(i,c,attime);
			 }
			else
			 {
					for (int i=r-1,attime=t+after+spd[cc[c]] ; i>=0 ; i--,attime+=spd[cc[c]])
					 advance(i,c,attime);
					for (int i=r+1,attime=t+after+(r*2+1)*spd[cc[c]]; i<N; i++,attime+=spd[cc[c]])
					 advance(i,c,attime);
			 }
}

int main()
{
	spd['F']=1,spd['S']=3,spd['O']=2;
	scanf("%d%d\n",&N,&M);
	Repi(N)
	 scanf("%c %d\n",rc+i,rt+i);
	Repi(M)
	 scanf("%c %d\n",cc+i,ct+i);
	scanf("%d %d %d %d %d",&sx,&sy,&st,&ex,&ey);
	sx--; sy--; ex--; ey--;
	
	q.push(MP(st,MP(sx,sy)));
	state tmp;
	memset(mint,127,sizeof(mint));
	mint[sx][sy]=st;
	
	while (!q.empty())
	 {
			tmp=q.top(); q.pop();
			r=tmp.y.x,c=tmp.y.y,t=tmp.x;
			if (used[r][c]) continue;
			used[r][c]=1;
		//	cout<<" in "<<r<<" "<<c<<" at time "<<t<<endl;
			if (r==ex && c==ey) break;
			
			rowplat(); colplat();
	 }
	printf("%d\n",mint[ex][ey]);
	
    return 0;
}
