/*
TASK platforms
LANG: C++
*/

#include <iostream>
#include <queue>
#include <vector>

using namespace std;

struct state
{ int r,c;
  unsigned int time;
  state() {};
  state(const int &_x,const int &_y,const unsigned int &_time) {r=_x; c=_y; time=_time;}
};

int n,m;
long long used[52][52];
char R[52]; char C[52];
int rs[52]; int cs[52];
int sr,sc,st,fr,fc;

bool isIn(int r,int c)
{ return r>=0 && r<n && c>=0 && c<m;}

int speed(char c)
{ if(c=='F') return 1;
  if(c=='O') return 2;
  if(c=='S') return 3;
  return 0;
}

struct comp
{
 bool operator() (const state &a,const state &b)
 { if(a.time<b.time) return 0;
   if(a.time==b.time) return a.r>b.r;
   return 1;
 }
};


void bfs()
{
 priority_queue< state,vector<state>, comp > q;
 q.push(state(sr,sc,st));
 
 int tmpr,tmpc,time;
 int posBus,dirBus;
 
 while(!q.empty())
 {
  tmpr=(q.top()).r; tmpc=(q.top()).c; time=(q.top()).time; q.pop();
  
  if(used[tmpr][tmpc]<time) continue;
 
  if(tmpr==fr && tmpc==fc) { cout<<time<<endl; return; }
  
  used[tmpr][tmpc]=time;
  
  if(isIn(tmpr,tmpc+1))
  {
   if(rs[tmpr]>=time) q.push( state(tmpr,tmpc+1,rs[tmpr]+(tmpc+1)*speed(R[tmpr])));
   else {
         posBus=((time-rs[tmpr])/speed(R[tmpr]))%(m-1);
         dirBus=((time-rs[tmpr])/speed(R[tmpr]))/(m-1);
         if(dirBus&1) posBus=m-1-posBus;
         
         if(dirBus%2==0) {
                          if(posBus<=tmpc) q.push( state(tmpr,tmpc+1,time+(tmpc+1-posBus)*speed(R[tmpr])) );
                          if(posBus>=tmpc+1)q.push( state(tmpr,tmpc+1,time+(m-1-posBus+m-1+tmpc+1)*speed(R[tmpr])));
                         }
         if(dirBus%2==1) q.push( state(tmpr,tmpc+1,time+(posBus+tmpc+1)*speed(R[tmpr])));
        }
  }
  
  if(isIn(tmpr,tmpc-1))
  {
   if(rs[tmpr]>=time) q.push( state(tmpr,tmpc-1,rs[tmpr]+(m-1-tmpc+1+m-1)*speed(R[tmpr])));
   else 
      {posBus=((time-rs[tmpr])/speed(R[tmpr]))%(m-1);
       dirBus=((time-rs[tmpr])/speed(R[tmpr]))/(m-1);
       if(dirBus&1) posBus=m-1-posBus;
       
       if(dirBus%2==0) q.push( state(tmpr,tmpc-1,time+(m-1-posBus+m-1-tmpc+1)*speed(R[tmpr])));
       if(dirBus%2==1) {
                        if(posBus>=tmpc) q.push( state( tmpr,tmpc-1, time+(posBus-tmpc+1)*speed(R[tmpr])));
                        if(posBus<tmpc)  q.push( state( tmpr,tmpc-1, time+(posBus+m-1+m-1-tmpc+1)*speed(R[tmpr])));
                       }               
      }
  }
                    
  if(isIn(tmpr-1,tmpc) )
  {
   if(cs[tmpc]>=time) q.push( state(tmpr-1,tmpc, cs[tmpc] + (n-1+n-1-tmpr+1)*speed(C[tmpc])));
   else
      {posBus=((time-cs[tmpr])/speed(C[tmpc]))%(n-1);
       dirBus=((time-cs[tmpr])/speed(C[tmpc]))/(n-1);
       if(dirBus&1) posBus=n-1-posBus;
       
       if(dirBus%2==0) q.push( state(tmpr-1,tmpc,time+(n-1-posBus+n-1-tmpr+1)*speed(C[tmpc])));
       if(dirBus%2==1) {
                        if(posBus>=tmpr) q.push( state( tmpr-1,tmpc, time+(posBus-tmpr+1)*speed(C[tmpc])));
                        if(posBus<tmpc)  q.push( state( tmpr-1,tmpc, time+(posBus+n-1+n-1-tmpr+1)*speed(C[tmpc])));
                       }               
      }                    
  }
  
  if(isIn(tmpr+1,tmpc) )
  {
  if(cs[tmpc]>=time) q.push( state(tmpr+1,tmpc,cs[tmpr]+(tmpr+1)*speed(C[tmpc])));
   else {
         posBus=((time-cs[tmpr])/speed(C[tmpc]))%(n-1);
         dirBus=((time-cs[tmpr])/speed(C[tmpc]))/(n-1);
         if(dirBus&1) posBus=n-1-posBus;
         
         if(dirBus%2==0) {
                          if(posBus<tmpr+1) q.push( state(tmpr+1,tmpc,time+(tmpr+1-posBus)*speed(C[tmpc])) );
                          if(posBus>=tmpr+1)q.push( state(tmpr+1,tmpc,time+(n-1-posBus+n-1+tmpr+1)*speed(C[tmpc])));
                         }
         if(dirBus%2==1) q.push( state(tmpr+1,tmpc,time+(posBus+tmpr+1)*speed(C[tmpc])));
        }
  }                    
 }
}

int main()
{
 for(int i=0;i<51;i++) for(int j=0;j<51;j++) used[i][j]=1<<30;
 
 scanf("%d %d\n",&n,&m);
 
 for(int i=0;i<n;i++) scanf("%c %d\n",&R[i],&rs[i]); 
 for(int i=0;i<m;i++) scanf("%c %d\n",&C[i],&cs[i]); 
 scanf("%d %d %d %d %d",&sr,&sc,&st,&fr,&fc);
 sr--; sc--; fr--; fc--;

 bfs();
    
 return 0;   
}
