/*
TASK:nobel
LANG:C++
*/

#include <iostream>
using namespace std;

typedef long long ll;
ll Q, b, n, MOD;

ll fastPow(int x, int p) {
    if (p == 0) return 1;
    if (!(p % 2)) {
        ll tmp = fastPow(x, p / 2);
        return (tmp * tmp) % MOD;
    }
    return (x * fastPow(x, p - 1)) % MOD;
}

ll rec(int p) {
    if (p == 0) return 1;
    if (p % 2) {
        ll tmp = rec(p / 2);
        return (tmp + fastPow(b, p / 2 + 1) * tmp) % MOD;
    }
    return (fastPow(b, p) + rec(p - 1)) % MOD;
}

ll linear() {
    ll sum = 0;
    for (int i = 0; i <= n; i++) sum = (sum + fastPow(b, i)) % MOD;
    return sum;
}

void solve() {
    cin >> Q;
    while (Q-- > 0) {
        cin >> b >> n >> MOD;
        cout << rec(n) << "\n";
    }
}

int main() {
    solve();
    return 0;
}
