/*
TASK:platforms
LANG:C++
*/
#include <stdio.h>
#include <set>
#include <utility>
using namespace std;
#define MAXN 64
#define INF 1<<30
#define max(a, b) ((a)>(b)?(a):(b))

struct platform{int start, speed;};
struct point{int x, y;};

struct cmp
{
	bool operator()(pair<int, point> a, pair<int, point> b)
	{
		return a.first<b.first || (a.first == b.first && a.second.x<b.second.x) 
					|| (a.first == b.first && a.second.x == b.second.x && a.second.y < b.second.y);
	}
};

int N, M, T;
platform plt[3][MAXN];
point ST, EN;

int minTime[MAXN][MAXN];
set <pair<int, point>, cmp> pQ;


int dij();
int NextBusStop(int from, int to, int currTime, int speed, int start, int all);
void NewInQueue(int tm, int x, int y);

int main()
{
    int ret, a;
    char s[10];
    scanf("%d %d", &M, &N);
    for(int i=1; i<=M; i++)
    {
        scanf("%s %d", s, &a);
        
		plt[2][i].speed = ((s[0]=='F')?1:(s[0]=='O'?2:3));
		plt[2][i].start = a;
    }
    
    for(int i=1; i<=N; i++)
    {
        scanf("%s %d", s, &a);

		plt[1][i].speed = ((s[0]=='F')?1:(s[0]=='O'?2:3));
		plt[1][i].start = a;
    }
        
    scanf("%d %d %d %d %d", &ST.y, &ST.x, &T, &EN.y, &EN.x);
	ret=T;
    
    ret = dij();
    
    printf("%d\n", ret);
    return 0;
}

int dij()
{
	for(int i=1; i<=N; i++)
		for(int j=1; j<=M; j++)
			minTime[i][j] = INF;

	for(int i=0; i<=N; i++)
		minTime[i][0] = minTime[i][M+1] = 0;
	for(int j=0; j<=M; j++)
		minTime[0][j] = minTime[N+1][j] = 0;

	minTime[ST.x][ST.y] = T;
	pQ.insert(make_pair(T, ST));

	while(!pQ.empty())
	{
		pair<int, point> get = *pQ.begin();
		pQ.erase(pQ.begin());

		int currTime = get.first;
		point position = get.second;

		if(position.x == EN.x && position.y == EN.y)
			return currTime;

		int ToRight = NextBusStop(position.x, position.x+1, currTime, plt[2][position.y].speed, plt[2][position.y].start, N);
		int ToDown = NextBusStop(position.y, position.y+1, currTime, plt[1][position.x].speed, plt[1][position.x].start, M);
		int ToLeft = NextBusStop(position.x, position.x-1, currTime, plt[2][position.y].speed, plt[2][position.y].start, N);
		int ToUp =  NextBusStop(position.y, position.y-1, currTime, plt[1][position.x].speed, plt[1][position.x].start, M);

		if(ToRight < minTime[position.x + 1][position.y])
			NewInQueue(ToRight, position.x + 1, position.y);
		if(ToDown < minTime[position.x][position.y + 1])
			NewInQueue(ToDown, position.x, position.y + 1);
		if(ToLeft < minTime[position.x - 1][position.y])
			NewInQueue(ToLeft, position.x - 1, position.y);
		if(ToUp < minTime[position.x][position.y - 1])
			NewInQueue(ToUp, position.x, position.y - 1);
	}

	return minTime[EN.x][EN.y];
}

void NewInQueue(int tm, int x, int y)
{
	point pt;
	pt.x = x;
	pt.y = y;

	if(minTime[x][y] != INF)
		pQ.erase(make_pair(minTime[x][y], pt));

	minTime[x][y] = tm;
	pQ.insert(make_pair(tm, pt));
}

int NextBusStop(int from, int to, int currTime, int speed, int start, int all)
{
	if(to > all || to < 1)
		return INF;

	int steps = (currTime - start)/speed;
	int BetweenTime = (currTime - start)%speed;
	steps = max(0, steps);
	steps = steps % ((all-1)*2);

	int toStep = (from<to) ? to-1 : (all-1 + all-to)%((all-1)*2);
	int DriveTime = (toStep > steps ? (toStep-steps)*speed : (toStep+((all-1)*2)-steps)*speed);

	return currTime + DriveTime - BetweenTime + (currTime<start ? start-currTime : 0);
}