// Gabrovo4 - 1
#include <fstream>
#include <iomanip>
#include <cmath>
#include <cstring>

#define INF 10000000

struct point {
  double x,y;
};

struct triangle {
  point p1,p2,p3;
  point p[3];
};


int n,nn;
triangle t[20];
point p1,p2;
bool ia[20][3][20][3][20];
double d[20][3][20][3];
double a[64][64];


void goout(double r)
{
  ofstream fout("short.out");
  fout << setprecision(9) << r << endl;
  fout.close();
  exit(0);
}


double dist(point p1,point p2)
{
  double dx=p1.x-p2.x;
  double dy=p1.y-p2.y;
  return sqrt(dx*dx+dy*dy);
}


int ccw(point p0,point p1,point p2)
{
  double dx1=p1.x-p0.x;
  double dy1=p1.y-p0.y;
  double dx2=p2.x-p0.x;
  double dy2=p2.y-p0.y;
  if (dx1*dy2 > dx2*dy1) return +1;
  if (dx1*dy2 < dx2*dy1) return -1;
  if ((dx1*dx2<0)||(dy1*dy2<0)) return -1;
  if (dx1*dx1+dy1*dy1 > dx2*dx2+dy2*dy2) return +1;
  return 0;
}


bool intersect(point l11,point l12,point l21,point l22)
{
  return (ccw(l11,l21,l22)*ccw(l12,l21,l22)<0)&&
         (ccw(l21,l11,l12)*ccw(l22,l11,l12)<0);
}


void precalcpoint(int ind,point p)
{
  for (int i=0;i<n;i++)
    for (int i1=0;i1<3;i1++)
    {
      bool pathin=true;
      for (int k=0;k<n;k++)
      {
        pathin=pathin&&(!(intersect(p,t[i].p[i1],t[k].p[0],t[k].p[1])||
                          intersect(p,t[i].p[i1],t[k].p[1],t[k].p[2])||
                          intersect(p,t[i].p[i1],t[k].p[2],t[k].p[0])));
      }
      if (pathin)
      {
        double dt=dist(p,t[i].p[i1]);
        a[ind][i*3+i1+1]=dt;
        a[i*3+i1+1][ind]=dt;
      }
    }
}


void precalc(void)
{
  for (int i=0;i<n;i++)
    for (int i1=0;i1<3;i1++)
      for (int j=0;j<n;j++)
        for (int j1=0;j1<3;j1++)
        {
          double dt=dist(t[i].p[i1],t[j].p[j1]);
          d[i][i1][j][j1]=dt;
          d[j][j1][i][i1]=dt;
          bool pathin=true;
          if (i!=j)
            for (int k=0;k<n;k++)
            {
              ia[i][i1][j][j1][k]=intersect(t[i].p[i1],t[j].p[j1],t[k].p[0],t[k].p[1])||
                                  intersect(t[i].p[i1],t[j].p[j1],t[k].p[1],t[k].p[2])||
                                  intersect(t[i].p[i1],t[j].p[j1],t[k].p[2],t[k].p[0]);
              pathin=pathin&&(!ia[i][i1][j][j1][k]);
            }
          if (pathin)
          {
            a[i*3+i1+1][j*3+j1+1]=d[i][i1][j][j1];
            a[j*3+j1+1][i*3+i1+1]=d[j][j1][i][i1];
          }
        }
  precalcpoint(0    ,p1);
  precalcpoint(3*n+1,p2);
}


int main()
{
  ifstream fin("short.inp");
  fin >> n;
  for (int i=0;i<n;i++)
    fin >> t[i].p1.x >> t[i].p1.y >> t[i].p2.x >> t[i].p2.y >> t[i].p3.x >> t[i].p3.y;
  fin >> p1.x >> p1.y >> p2.x >> p2.y;

  for (int i=0;i<n;i++)
  {
    t[i].p[0]=t[i].p1;
    t[i].p[1]=t[i].p2;
    t[i].p[2]=t[i].p3;
  }

  if (n==0) goout(dist(p1,p2));
  
  memset(ia,0,sizeof(ia));
  memset(d,0,sizeof(d));
  memset(a,0,sizeof(a));
  precalc();

  nn=3*n+1;
  double dd[64];
  bool p[64];

  for (int i=0;i<=nn;i++) {dd[i]=INF;p[i]=false;}
  dd[0]=0.0;
  
  for (int k=0;k<=nn;k++)
  {
    int min=0;
    double minval=INF;
    for (int i=0;i<=nn;i++)
      if ((!p[i])&&(minval>dd[i])) {min=i;minval=dd[min];}
    if (abs(minval-INF)<=0.0001) break;
    for (int i=0;i<=nn;i++)
      if ((a[min][i]!=0.0)&&(dd[i]>dd[min]+a[min][i]))
        dd[i]=dd[min]+a[min][i];
    p[min]=true;
  }

  goout(dd[nn]);
  return 0;
}
