/*
NAME: Ivan Anev
SCHOOL: SMG
CITY: Sofia
CLASS: 11-12
PROBLEM: short
*/

#include <stdio.h>
#include <math.h>
#include <float.h>

#define MAXN 20

typedef struct Tri TTri;

struct Tri {
       double x1, y1, x2, y2, x3, y3;
};

int n;
TTri tri[MAXN];
double dist, pi;
int v[MAXN];

double sqr(double x) {
       return x * x;
}

int is_over(double x1, double y1, double x2, double y2, double x3, double y3) {
     double up;

     up = (x1*y2 + x2*y3 + x3*y1 - x1*y3 - x2*y1 - x3*y2) / 2;

     if (up > 0)
        return 1;
     else if (up < 0)
          return -1;
     else
         return 0;
}

int is_crossed(double x1, double y1, double x2, double y2, double x3, double y3,
     double x4, double y4) {
     
     int s1, s2, s3, s4;
     s1 = is_over(x1, y1, x3, y3, x4, y4);
     s2 = is_over(x2, y2, x3, y3, x4, y4);
     s3 = is_over(x3, y3, x1, y1, x2, y2);
     s4 = is_over(x4, y4, x1, y1, x2, y2);

     return (s1 == -s2 && s3 == - s4);
}

double angle(double x, double y) {
       double ac;

       ac = acos(y / sqrt(x*x + y*y));
       if (y < 0)
          ac = 2 * pi - ac;

       return ac;
}

double angle2(double x1, double y1, double x2, double y2) {
       return angle(x2 - x1, y2 - y1);
}

int is_crtri(double x1, double y1, double x2, double y2, int i) {
    return is_crossed(x1, y1, x2, y2, tri[i].x1, tri[i].y1, tri[i].x2, tri[i].y2) ||
           is_crossed(x1, y1, x2, y2, tri[i].x2, tri[i].y2, tri[i].x3, tri[i].y3) ||
           is_crossed(x1, y1, x2, y2, tri[i].x1, tri[i].y1, tri[i].x3, tri[i].y3);
}

double dis(double x1, double y1, double x2, double y2) {
       double ac, min, ac1, ac2, ac3, dd, dp;
       int i, p1, p2, crr, flag;

       ac = angle(x2 - x1, y2 - y1);
       min = DBL_MAX;

       crr = 0;
       for (i = 0; i < n; ++i)
           if (is_crtri(x1, y1, x2, y2, i)) {
              flag = 0;
              crr = 1;
              if (is_crossed(x1, y1, tri[i].x3, tri[i].y3, tri[i].x1, tri[i].y1, tri[i].x2, tri[i].y2)) {
                 ac1 = angle2(x1, y1, tri[i].x1, tri[i].y1);
                 ac2 = angle2(x1, y1, tri[i].x2, tri[i].y2);
                 p1 = 1;
                 p2 = 2;
              }
              else if (is_crossed(x1, y1, tri[i].x1, tri[i].y1, tri[i].x2, tri[i].y2, tri[i].x3, tri[i].y3)) {
                 ac1 = angle2(x1, y1, tri[i].x3, tri[i].y3);
                 ac2 = angle2(x1, y1, tri[i].x2, tri[i].y2);
                 p1 = 2;
                 p2 = 3;
              }
              else if (is_crossed(x1, y1, tri[i].x2, tri[i].y2, tri[i].x1, tri[i].y1, tri[i].x3, tri[i].y3)) {
                 ac1 = angle2(x1, y1, tri[i].x1, tri[i].y1);
                 ac2 = angle2(x1, y1, tri[i].x3, tri[i].y3);
                 p1 = 1;
                 p2 = 3;
              }
              else if (x1 == tri[i].x1 && y1 == tri[i].y1) {
                   dd = dis(tri[i].x2, tri[i].y2, x2, y2);
                   dp = sqrt(sqr(tri[i].x1 - tri[i].x2) + sqr(tri[i].y1 - tri[i].y2));
                   if (dd != DBL_MAX && dd + dp < min)
                      min = dp + dd;
                   dd = dis(tri[i].x3, tri[i].y3, x2, y2);
                   dp = sqrt(sqr(tri[i].x1 - tri[i].x3) + sqr(tri[i].y1 - tri[i].y3));
                   if (dd != DBL_MAX && dd + dp < min)
                      min = dp + dd;
                   flag = 1;
              }
              else if (x1 == tri[i].x2 && y1 == tri[i].y2) {
                   dd = dis(tri[i].x3, tri[i].y3, x2, y2);
                   dp = sqrt(sqr(tri[i].x3 - tri[i].x2) + sqr(tri[i].y3 - tri[i].y2));
                   if (dd != DBL_MAX && dd + dp < min)
                      min = dp + dd;
                   dd = dis(tri[i].x1, tri[i].y1, x2, y2);
                   dp = sqrt(sqr(tri[i].x1 - tri[i].x2) + sqr(tri[i].y1 - tri[i].y2));
                   if (dd != DBL_MAX && dd + dp < min)
                      min = dp + dd;
                   flag = 1;
              }
              else if (x1 == tri[i].x3 && y1 == tri[i].y3) {
                   dd = dis(tri[i].x1, tri[i].y1, x2, y2);
                   dp = sqrt(sqr(tri[i].x1 - tri[i].x3) + sqr(tri[i].y1 - tri[i].y3));
                   if (dd != DBL_MAX && dd + dp < min)
                      min = dp + dd;
                   dd = dis(tri[i].x2, tri[i].y2, x2, y2);
                   dp = sqrt(sqr(tri[i].x2 - tri[i].x3) + sqr(tri[i].y2 - tri[i].y3));
                   if (dd != DBL_MAX && dd + dp < min)
                      min = dp + dd;
                   flag = 1;
              }
              else {
                   ac1 = angle2(x1, y1, tri[i].x1, tri[i].y1);
                   ac2 = angle2(x1, y1, tri[i].x2, tri[i].y2);
                   ac3 = angle2(x1, y1, tri[i].x3, tri[i].y3);
                   if (ac3 >= ac1 && ac3 <= ac2 || ac3 <= ac1 && ac3 >= ac2) {
                      p1 = 1;
                      p2 = 2;
                   }
                   else if (ac1 >= ac2 && ac1 <= ac3 || ac1 <= ac2 && ac1 >= ac3) {
                        ac1 = ac3;
                        p1 = 3;
                        p2 = 2;
                   }
                   else if (ac2 >= ac1 && ac2 <= ac3 || ac2 <= ac1 && ac2 >= ac3) {
                        ac2 = ac3;
                        p1 = 1;
                        p2 = 3;
                   }
              }
              if (flag == 0 && fabs(ac - ac1) < pi) {
                 if (p1 == 1) {
                    dd = dis(tri[i].x1, tri[i].y1, x2, y2);
                    dp = sqrt(sqr(tri[i].x1 - x1) + sqr(tri[i].y1 - y1));
                 }
                 else if (p1 == 2) {
                      dd = dis(tri[i].x2, tri[i].y2, x2, y2);
                      dp = sqrt(sqr(tri[i].x2 - x1) + sqr(tri[i].y2 - y1));
                 }
                 else if (p1 == 3) {
                      dd = dis(tri[i].x1, tri[i].y1, x2, y2);
                      dp = sqrt(sqr(tri[i].x3 - x1) + sqr(tri[i].y3 - y1));
                 }
                 if (dd != DBL_MAX && dp + dd < min)
                    min = dd + dp;
              }
              if (flag == 0 && fabs(ac - ac2) < pi) {
                 if (p2 == 1) {
                    dd = dis(tri[i].x1, tri[i].y1, x2, y2);
                    dp = sqrt(sqr(tri[i].x1 - x1) + sqr(tri[i].y1 - y1));
                 }
                 else if (p2 == 2) {
                      dd = dis(tri[i].x2, tri[i].y2, x2, y2);
                      dp = sqrt(sqr(tri[i].x2 - x1) + sqr(tri[i].y2 - y1));
                 }
                 else if (p2 == 3) {
                      dd = dis(tri[i].x1, tri[i].y1, x2, y2);
                      dp = sqrt(sqr(tri[i].x3 - x1) + sqr(tri[i].y3 - y1));
                 }
                 if (dd != DBL_MAX && dp + dd < min)
                    min = dd + dp;
              }
           }

        if (crr) {
           return min;
        }
        else
            return sqrt(sqr(x1-x2) + sqr(y1-y2));
}

int main(void) {
    FILE *fin, *fout;
    int i;
    double x1, y1, x2, y2;

    fin = fopen("short.inp", "r");
    fout = fopen("short.out", "w");

    fscanf(fin, "%d\n", &n);
    for (i = 0; i < n; ++i)
        fscanf(fin, "%lf %lf %lf %lf %lf %lf\n", &tri[i].x1, &tri[i].y1,
                    &tri[i].x2, &tri[i].y2, &tri[i].x3, &tri[i].y3);
    fscanf(fin, "%lf %lf %lf %lf\n", &x1, &y1, &x2, &y2);

    pi = 2 * acos(0);

    dist = dis(x1, y1, x2, y2);
//    dist = sqrt(sqr(x1-x2) + sqr(y1-y2));

    fprintf(fout, "%.8f\n", dist);

    fclose(fin);
    fclose(fout);
    
    return 0;
}
