{Marin Nozhchev, StZagora}

const
 ifn = 'short.inp';
 ofn = 'short.out';
 eps = 1E-10;
 maxn = 30;
 maxv = 2 * maxn + 4;
 inf = 1E10;

type
 TVec =
  record
   x, y : double;
  end;

 TTrian =
  array [1 .. 3] of TVec;
var
 t : text;
 gr : array [1 .. maxv, 1 .. maxv] of double;
 tr : array [1 .. maxn] of TTrian;
 vs : array [1 .. maxv] of TVec;
 st, fi : TVec;
 v, n : longint;

procedure input;
var
 i, j : longint;
begin
 assign (t, ifn);
 reset (t);
 read (t, n);
 for i := 1 to n do
  for j := 1 to 3 do
   begin
    read (t, tr[i,j].x);
    read (t, tr[i,j].y);
   end;

 read (t, st.x, st.y);
 read (t, fi.x, fi.y);
 close (t);
end;

procedure output;
begin
 assign (t, ofn);
 rewrite (t);
 writeln (t, gr[1,2] : 0 :8);
 close (t);
end;

function eq (a, b : double) : boolean;
begin
 eq := abs (a - b) < eps;
end;

function cross (var a1, a2, b1, b2 : TVec) : boolean;
var
 va, vb : TVec;

 p, q, l, r : double;

begin
 cross := false;

 va.x := a2.x - a1.x;
 va.y := a2.y - a1.y;
 vb.x := b2.x - b1.x;
 vb.y := b2.y - b1.y;

 l := va.x * vb.y  -  va.y * vb.x;
 r := (b1.x - a1.x) * vb.y + (a1.y - b1.y) * vb.x;

 if eq (l, 0) then
  exit;

 p := r / l;
 if eq (vb.x, 0) then
  if not eq (vb.y, 0) then
   q := (a1.y - b1.y + p*va.y) / vb.y
  else
   q := 0
 else
  q := (a1.x - b1.x + p*va.x) / vb.x;

 if (p > eps) and (p + eps < 1) and
    (q > eps) and (q + eps < 1) then
   cross := true
  else
   cross := false;

end;

function dist (var a, b : TVec) : double;
begin
 dist := sqrt ( sqr (a.x - b.x) + sqr (a.y - b.y) );
end;

function try (var a, b : TVec) : boolean;
var
 t : TTrian;
 i : longint;

begin
 try := false;

 for i := 1 to n do
  begin
   t := tr[i];
   if cross (a, b, t[1], t[2]) then exit;
   if cross (a, b, t[2], t[3]) then exit;
   if cross (a, b, t[3], t[1]) then exit;
  end;

 try := true;
end;

procedure initgr;
var
 i, k, j : longint;

begin
 vs[1] := st;
 vs[2] := fi;
 v := 2;

 for i := 1 to n do
  for k := 1 to 3 do
   begin
    inc (v);
    vs[v] := tr[i, k];
   end;

 for i := 1 to v do
  for j := i+1 to v do
   if try (vs[i], vs[j]) then
    begin
     gr[i, j] := dist (vs[i], vs[j]);
     gr[j, i] := gr[i,j];
    end
   else
    begin
     gr[i, j] := inf;
     gr[j, i] := inf;
    end;
end;

procedure floyd;
var
 i, j, k : longint;
 x : double;

begin
 for k := 1 to v do
  for i := 1 to v do
   for j := 1 to v do
    begin
     x := gr[i, k] + gr[k, j];
     if x < gr[i, j] then
      gr[i, j] := x;
    end;
end;

begin
 input;
 initgr;
 floyd;
 output;
end.