/*
Peter Radoslavov Dimov - OMG "Akad. Kiril Popov" - Plovdiv
*/
#include <fstream>
#include <cstring>
#include <cstdlib>

using namespace std;

#define MAXN 1001

class palindrom{
  char pal[256];
  int direction;
public:
  palindrom() { pal[0] = 0; direction = 1; }
  void setpal(char* buff) { strcpy(pal, buff); }
  void setdir(int dir) { direction = dir; }
  int getdir() { return direction; }
  int valid(int index) { return 0 <= index && index < size(); }
  int size() { strlen(pal); }
  char operator[](int index);
};

void checkpal(palindrom& lpal, int lpos, palindrom& rpal, int rpos);
void printres();

int n;
palindrom pals[MAXN];
int used[MAXN] = {0};

int startpal = -1;
int lstack[MAXN] = {0};
int lstackind = -1;
int rstack[MAXN] = {0};
int rstackind = -1;

int main(){
    ifstream in("genom.inp");
//    ofstream out("genom.out");

    in >> n;
    {
      char buff[260];
      in.getline(buff, 260);
    }
    
    for(int i = 0; i < n; i++){
       char buff[260];
       in.getline(buff, 260);
       pals[i].setpal(buff);
    }

    for(int i = 0; i < n; i++){
       used[i] = 1;
       startpal = i+1;
       int j;
       for(j = 0; j < pals[i].size() - 2; j++){
          if(pals[i][j] == pals[i][j+1])
              checkpal(pals[i], j, pals[i], j+1);
          if(pals[i][j] == pals[i][j+2])
              checkpal(pals[i], j, pals[i], j+2);
       }
       if(pals[i][j] == pals[i][j+1])
          checkpal(pals[i], j, pals[i], j+1);
       used[i] = 0;
    }
    return 0;
}

char palindrom::operator[](int index){
  if(!valid(index)) return -1;
  if(direction)
    return pal[index];
  else
    return pal[size() - index - 1];
}

void checkpal(palindrom& lpal, int lpos, palindrom& rpal, int rpos){
  int tlpos = 1, trpos = 1;
  if(!rpal.valid(rpos)) tlpos=0;
  if(!lpal.valid(lpos)) trpos=0;
  if(tlpos && trpos)
    if(lpal[lpos] != rpal[rpos]) return;

  while(1){

    if(!lpal.valid(lpos-1)){
      int allvisited = 1;
      lstackind++;
      for(int i = 0; i < n; i++){
         if(!used[i]){
           allvisited = 0;
           used[i] = 1;
           pals[i].setdir(1);
           lstack[lstackind] = i+1;
           checkpal(pals[i], pals[i].size() - 1, rpal, rpos+trpos);
           pals[i].setdir(0);
           lstack[lstackind] = -i-1;
           checkpal(pals[i], pals[i].size() - 1, rpal, rpos+trpos);
           pals[i].setdir(1);
           used[i] = 0;
         }
      }
      lstackind--;
      if(allvisited && !rpal.valid(rpos+1)){
        printres();
        exit(0);
      }
      return;
    }
    else if(tlpos) lpos--;
    
    if(!rpal.valid(rpos+1)){
      int allvisited = 1;
      rstackind++;
      for(int i = 0; i < n; i++){
         if(!used[i]){
           allvisited = 0;
           used[i] = 1;
           pals[i].setdir(1);
           rstack[rstackind] = i+1;
           checkpal(lpal, lpos/*-tlpos*/, pals[i], 0);
           pals[i].setdir(0);
           rstack[rstackind] = -i-1;
           checkpal(lpal, lpos/*-tlpos*/, pals[i], 0);
           pals[i].setdir(1);
           used[i] = 0;
         }
      }
      rstackind--;
      if(allvisited && !lpal.valid(lpos)){
        printres();
        exit(0);
      }
      return;
    }
    else if(trpos) rpos++;

    if(lpal[lpos] != rpal[rpos]) return;

  }
}

void printres(){
  ofstream out("genom.out");

  for(;lstackind >= 0; lstackind--){
     out << lstack[lstackind] << endl;
  }
  out << startpal << endl;
  for(int i = 0; i <= rstackind; i++){
     out << rstack[i] << endl;
  }
}
