/*
Peter Radoslavov Dimov - OMG "Akad. Kiril Popov" - Plovdiv
*/

#include <fstream>
#include <cmath>
#include <cstdio>

using namespace std;

#define MAXN 20
#define PREC 0.0000001
#define INF 1000000
#define min(a,b) (((a)<(b))?(a):(b))
#define max(a,b) (((a)>(b))?(a):(b))

int zero(double a) { return fabs(a) < PREC; }

struct point{
  double x, y;
  point() { x = y = 0.; };
  point( double _x, double _y) { x = _x; y = _y; }
  istream& read(istream& in) { return in >> x >> y; }
  double dist(const point& p) const { return sqrt(fabs(p.x-x)*fabs(p.x-x) + fabs(p.y-y)*fabs(p.y-y)); }
};

struct line{
  point p1, p2;
  double a, b, c;
  void abc();
public:
  line() {}
  line(const point& _p1, const point& _p2) { p1 = _p1; p2 = _p2; abc(); }
  int paralell(const line& l);
  int crosses(const line& l, point& cpt);
  int inside(const point& p);
};

struct triangle{
  point p1, p2, p3;
  line l[3];
  void lines();
public:
   triangle() {}
   istream& read(istream& in);
};

double path(const point& dp1, const point& dp2);

int n;
triangle triang[MAXN];

int main(){
  ifstream in("short.inp");
  //ofstream out("short.out");

  in >> n;

  for(int i = 0; i < n; i++){
    triang[i].read(in);
  }

  point dp1, dp2;
  dp1.read(in); dp2.read(in);

  double res = 0;
  res = path(dp1, dp2);

  FILE *out = fopen("short.out", "w");
  fprintf(out, "%.8f\n", res);

  return 0;
}
void line::abc(){
  a = p2.y - p1.y;
  b = p1.x - p2.x;
  c = p2.x*p1.y - p1.x*p2.y;
}

int line::paralell(const line& l){
  return zero(l.a*b - l.b*a);
}

int line::crosses(const line& l, point& cpt){
  if(paralell(l)) return 0;

  double zn = a*l.b - b*l.a;
  cpt.x = -((c*l.b - b*l.c)/zn);
  cpt.y = (c*l.a - a*l.c)/zn;

  if(inside(cpt)) return 1;
  else return 0;
}

int line::inside(const point& p){
  int ins =  zero(p1.dist(p2) - (p1.dist(p) + p2.dist(p)));
  return ins && (p.x != p1.x && p.y != p1.y) && (p.x != p2.x && p.y != p2.y);
}

double path(const point& dp1, const point& dp2){

  line l(dp1, dp2);
  point cpt;
  double mdist = INF;
  int bi = -1, bj = -1;
  
  for(int i = 0; i < n; i++){
    for(int j = 0; j < 3; j++){
      if(((triang[i]).l[j]).crosses(l, cpt)){
        double dist = dp1.dist(cpt);
        if(dist < mdist){
          mdist = dist;
          bi = i;
          bj = j;
        }
      }
    }

  }
  
  if(bi == -1)
    return dp1.dist(dp2);

  double left = dp1.dist((triang[bi]).l[bj].p1) + path((triang[bi]).l[bj].p1, dp2);
  double right = dp1.dist((triang[bi]).l[bj].p2) + path((triang[bi]).l[bj].p2, dp2);
  return min(left, right);
}

istream& triangle::read(istream& in){
  p1.read(in);
  p2.read(in);
  p3.read(in);
  lines();
  return in;
}

void triangle::lines(){
  l[0] = line(p1, p2);
  l[1] = line(p2, p3);
  l[2] = line(p3, p1);
}

