/****************************************************************************
   name : Mihail Volen Mukov
   city : Pleven
   group: 4
 ****************************************************************************/
/* INCLUDES *****************************************************************/
   #include <fstream>
   #include <string>
   #include <cmath>
   #include <cstdlib>
 
   using namespace std;

/* CONSTANTS ****************************************************************/
   const int MAX = 202;
   const double MAX_VAL = 99999999.0;

/* CLASSES ******************************************************************/
   class point
   {
   public:
      point() {};
      point(double _x, double _y): x(_x), y(_y) {};

      double get_dist(point p)
      { return sqrt((x - p.x)*(x - p.x) + (y - p.y)*(y - p.y)); };
   
      double x;
      double y;
   };

   class line
   {
   public:
      line();
      line(point p1, point p2)
      {  a = p1.y - p2.y;
         b = p2.x - p1.x;
         c = p1.x * p2.y - p2.x * p1.y;
      };

      point get_inter_point(line);
   
      double a;
      double b;
      double c;
   };

   class triangle
   {
   public:
      bool is_inter(point, point);
    
      int p1;
      int p2;
      int p3;
     
   private:
      bool is_point_in_range(point, point, point);
   };

/* GLOBALS ******************************************************************/
   ifstream fin("short.inp");
   ofstream fout("short.out");

   double best = MAX_VAL;
   int c_ps;
   point ps[MAX];
   int c_ts;
   triangle ts[MAX];
   point p0;
   point p1;
   bool path[MAX];

   double p2p[MAX][MAX];

/* FUNCTIONS ****************************************************************/
/****************************************************************************/
   point line::get_inter_point(line l)
   {  double d = a * l.b - l.a * b;
   
      if (d == 0) return point(MAX_VAL, MAX_VAL);

      point p;
      p.x = (b * l.c - l.b * c) / d;
      p.y = (l.a * c - a * l.c) / d;
      return p;
   }
/****************************************************************************/
   inline double min(double a, double b)
   {  return (a < b) ? a : b;
   }
/****************************************************************************/
   inline double max(double a, double b)
   {  return (a > b) ? a : b;
   }
/****************************************************************************/
   bool triangle::is_point_in_range(point p, point r1, point r2)
   {  double xn = min(r1.x, r2.x);
      double xx = max(r1.x, r2.x);
      double yn = min(r1.y, r2.y);
      double yx = max(r1.y, r2.y);

      return (((p.x > xn) && (p.x < xx)) || ((p.y > yn) && (p.y < yx)) );
   }
/****************************************************************************/
   bool triangle::is_inter(point _p1, point _p2)
   {  line l(_p1, _p2);

      point p;
   
      p = line(ps[p1], ps[p2]).get_inter_point(l);
      if ( (is_point_in_range(p, ps[p1], ps[p2])) &&
           (is_point_in_range(p, _p1, _p2))
         ) return true;
         
      p = line(ps[p1], ps[p3]).get_inter_point(l);
      if ( (is_point_in_range(p, ps[p1], ps[p3])) &&
           (is_point_in_range(p, _p1, _p2))
         ) return true;
         
      p = line(ps[p3], ps[p2]).get_inter_point(l);
      if ( (is_point_in_range(p, ps[p3], ps[p2])) &&
           (is_point_in_range(p, _p1, _p2))
         ) return true;

      return false;
   }
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
   void init()
   {  fin >> c_ts;
      int i;
      for (i = 1; i <= c_ts; i++)
      {  double x1;
         double y1;
         double x2;
         double y2;
         double x3;
         double y3;
         
         fin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
         
         c_ps++;
         ps[c_ps].x = x1;
         ps[c_ps].y = y1;
         ts[i].p1 = c_ps;
         
         c_ps++;
         ps[c_ps].x = x2;
         ps[c_ps].y = y2;
         ts[i].p2 = c_ps;
         
         c_ps++;
         ps[c_ps].x = x3;
         ps[c_ps].y = y3;
         ts[i].p3 = c_ps;
      }

      fin >> p0.x >> p0.y >> p1.x >> p1.y;
      
   }

/****************************************************************************/
   void done()
   {
   
      fin.close();
      fout.close();
      exit(0);
   }
/****************************************************************************/
   bool ok(point p1, point p2)
   {  int i;
      for (i = 1; i <= c_ts; i++)
         if (ts[i].is_inter(p1, p2))
            return false;

      return true;
   }
/****************************************************************************/
   void run()
   {  ps[0].x = p0.x;
      ps[0].y = p0.y;
      c_ps++;
      ps[c_ps].x = p1.x;
      ps[c_ps].y = p1.y;

      int i;
      for (i = 0; i <= c_ps; i++)
      {  int j;
         for (j = 0; j <= c_ps; j++)
            p2p[i][j] = MAX_VAL;
      }
      
      for (i = 0; i < c_ps; i++)
      {  int j;
         for (j = i + 1; j <= c_ps; j++)
         {  if (ok(ps[i], ps[j]))
            {  p2p[i][j] = ps[i].get_dist(ps[j]);
               p2p[j][i] = p2p[i][j];
            }
         }
      }

      //int i;
      for (i = 0; i <= c_ps; i++)
      {  int j;
         for (j = 0; j <= c_ps; j++)
            if (i != j)
            {  int k;
               for (k = 0; k <= c_ps; k++)
                  if (k != i && k != j)
                     if ( (p2p[i][k]) + (p2p[k][j]) < (p2p[i][j])  )
                     {  p2p[i][j] = p2p[i][k] + p2p[k][j];
                     }
            }

      }
      
      fout.precision(9);
      fout << p2p[0][c_ps] << endl;
      

   }
/****************************************************************************/
   int main()
   {  init();
      run();
      done();

      return 0;
   }
/****************************************************************************/

