{Georgy Hristow Kadrew, 11 klas, Ruse, grupa IV, No.3}

const
 FIn  = 'SHORT.INP';
 FOut = 'SHORT.OUT';

 Eps = 1E-8;

type
 Point    = Record
             x,y : Real;
            End;

 Triangle = Record
             V : Array[1..3] Of Point;
            End;

var
 f1,f2 : Text;
 M,
 J,II,JJ,
 N,I   : Integer;
 G     : Array[1..60,1..60] Of Real; {1: src; 2: trg; i*3-1: i-th}
 A     : Array[1..20] Of Triangle;
 P1,P2 : Point;

 function Distance(SP,TP : Point) : Real;
 begin
  Distance := Sqrt(Sqr(Abs(1.0*SP.x-1.0*TP.x)) + Sqr(Abs(1.0*SP.y-1.0*TP.y)));
 end;

 function Min(R1,R2 : Real) : Real;
 begin
  If R1<R2
   Then Min := R1
   Else Min := R2;
 end;

 function Max(R1,R2 : Real) : Real;
 begin
  If R1>R2
   Then Max := R1
   Else Max := R2;
 end;

 function Eq(R1,R2 : Real) : Boolean;
 begin
  Eq := Abs(R1-R2) < Eps;
 end;

 function Crossed(slp1,slp2,tlp1,tlp2 : Point) : Boolean;
 var
  cx,cy,
  xch,ych,zn,
  sA,tA,sB,tB,sC,tC : Real;
 begin
  Crossed := True;
  sA := slp2.y-slp1.y;
  sB := slp1.x-slp2.x;
  sC := slp2.x*slp1.y - slp1.x*slp2.y;

  tA := tlp2.y-tlp1.y;
  tB := tlp1.x-tlp2.x;
  tC := tlp2.x*tlp1.y - tlp1.x*tlp2.y;

  xch := -sC*tB+sB*tC;
  ych := -sA*tC+tA*sC;
  zn := sA*tB-tA*sB;

  If Eq(zn,0) or (Eq(xch,0) and Eq(ych,0))
{  or Eq(Min(tlp1.x,tlp2.x),Min(slp1.x,slp2.x))
  or Eq(Max(tlp1.x,tlp2.x),Max(slp1.x,slp2.x))
  or Eq(Min(tlp1.y,tlp2.y),Min(slp1.y,slp2.y))
  or Eq(Max(tlp1.y,tlp2.y),Max(slp1.y,slp2.y))} Then
   Begin
    Crossed := False;
    Exit;
   End
  Else
   Begin
    cx := xch / zn;
    cy := ych / zn;
   End;

  If  (cx > Min(tlp1.x,tlp2.x)) and (cx > Min(slp1.x,slp2.x))
  and (cx < Max(tlp1.x,tlp2.x)) and (cx < Max(slp1.x,slp2.x))
  and (cy > Min(tlp1.y,tlp2.y)) and (cy > Min(slp1.y,slp2.y))
  and (cy < Max(tlp1.y,tlp2.y)) and (cy < Max(slp1.y,slp2.y))
  Then Crossed := True
  Else Crossed := False;
 end;

 function Can(SP,TP : Point) : Boolean;
 var
  Ind,Jnd : Integer;
 begin
  Can := True;
  For Ind:=1 To N Do
   For Jnd:=1 To 2 Do
    If Crossed(SP, TP, A[Ind].V[Jnd], A[Ind].V[Jnd+1]) Then
     Begin
      Can := False;
      Exit;
     End;

  If Crossed(SP, TP, A[Ind].V[1], A[Ind].V[3]) Then
   Begin
    Can := False;
    Exit;
   End;
 end;

 procedure Floyd;
 begin
  For I:=1 To N*3+2 Do
   G[I][I] := -1.0;

  For M:=1 To N*3+2 Do
   For I:=1 To N*3+2 Do
    For J:=1 To N*3+2 Do
     If (Eq(G[I][J], -1.0) or (G[I][J] > G[I][M] + G[M,J]))
     and (not Eq(G[I][M], -1.0)) and (not Eq(G[M][J], -1.0))
      Then G[I][J] := G[I][M] + G[M,J];
 end;

begin
 assign(f1, FIn);
 reset(f1);

 Readln(f1, N);

 For I:=1 To N Do
  For J:=1 To N Do
   G[I][J] := -1.0;

 For I:=1 To N Do Readln(f1, A[I].V[1].x, A[I].V[1].y,
                             A[I].V[2].x, A[I].V[2].y,
                             A[I].V[3].x, A[I].V[3].y);
 Readln(f1, P1.x, P1.y, P2.x, P2.y);

 close(f1);

 assign(f2, FOut);
 rewrite(f2);

 If Can(P1,P2) Then
  Begin
   Writeln(f2, Distance(P1,P2):0:8);
   Close(f2);
   Exit;
  End;

 For I:=1 To N Do
  For J:=1 To 3 Do
   For II:=1 To N Do
    If I<>II Then
    For JJ:=1 To 3 Do
     If Can(A[I].V[J], A[II].V[JJ]) Then
      Begin
       G[I*3-1+J][II*3-1+JJ] := Distance(A[I].V[J], A[II].V[JJ]);
       G[II*3-1+JJ][I*3-1+J] := G[I*3-1+J][II*3-1+JJ] ;
      End
     Else
      Begin
       G[I*3-1+J][II*3-1+JJ] := -1.0;
       G[II*3-1+JJ][I*3-1+J] := G[I*3-1+J][II*3-1+JJ];
      End;

 For I:=1 To N Do
  For J:=1 To 3 Do
   Begin
    If Can(A[I].V[J], P1) Then
     Begin
      G[I*3-1+J][1] := Distance(A[I].V[J], P1);
      G[1][I*3-1+J] := G[I*3-1+J][1];
     End
    Else
     Begin
      G[I*3-1+J][1] := -1.0;
      G[1][I*3-1+J] := G[I*3-1+J][1];
     End;

    If Can(A[I].V[J], P2) Then
     Begin
      G[I*3-1+J][2] := Distance(A[I].V[J], P2);
      G[2][I*3-1+J] := G[I*3-1+J][2];
     End
    Else
     Begin
      G[I*3-1+J][2] := -1.0;
      G[2][I*3-1+J] := G[I*3-1+J][2];
     End;
   End;

 For I:=1 To N Do
  Begin
   G[I*3][I*3+1] := Distance(A[I].V[1],A[I].V[2]);
   G[I*3][I*3+2] := Distance(A[I].V[1],A[I].V[3]);
   G[I*3+1][I*3] := Distance(A[2].V[1],A[I].V[1]);
   G[I*3+1][I*3+2] := Distance(A[I].V[2],A[I].V[3]);
   G[I*3+2][I*3] := Distance(A[I].V[3],A[I].V[1]);
   G[I*3+2][I*3+1] := Distance(A[I].V[3],A[I].V[2]);
  End;

 Floyd;

 Writeln(f2, G[1][2]:0:8);

 close(f2);
end.