/*
  George Tsankov, 11 star, SMG
*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>


#define MAXN 128
#define EPS (1e-10)

int N, n;
double shortest[MAXN];
double tr[MAXN][3][2];
double ots[MAXN][2][2];
int ots_ind[MAXN][2];
int next[MAXN];
double T1[2], T2[2];
double p[MAXN][2];
double P;


void read_all(void);
void do_all(void);
double getshortest(int ind);
double ORN(double *p1, double *p2, double *p3);
int ORNi(double *p1, double *p2, double *p3);
double getcp(double *p11, double *p12, double *p21, double *p22, double *x, double *y);
double dist(double *p1, double *p2);
void write_all(void);



int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  int i, j;
  
  FILE *f = fopen("short.inp", "rt");
  fscanf(f, "%d", &N);
  for (i = 0; i < N; i++) {
    for (j = 0; j < 3; j++) {
      fscanf(f, "%lf %lf", &tr[i][j][0], &tr[i][j][1]);
      p[n][0] = tr[i][j][0];
      p[n++][1] = tr[i][j][1];
    }
  }
  fscanf(f, "%lf %lf", &T1[0], &T1[1]);
  p[n][0] = T1[0];  p[n++][1] = T1[1];
  fscanf(f, "%lf %lf", &T2[0], &T2[1]);
  fclose(f);
}


void do_all(void)
{
  int i, j;

  for (i = 0; i < n; i++)  shortest[i] = -1;
  for (i = 0; i < N; i++) {
    for (j = 0; j < 3; j++) {
      ots[3*i+j][0][0] = tr[i][(j)%3][0];
      ots[3*i+j][0][1] = tr[i][(j)%3][1];
      ots[3*i+j][1][0] = tr[i][(j+1)%3][0];
      ots[3*i+j][1][1] = tr[i][(j+1)%3][1];
      ots_ind[3*i+j][0] = 3*i+j;
      ots_ind[3*i+j][1] = 3*i+(j+1)%3;
    }
  }
  N *= 3;
  P = getshortest(n-1);
}



double getshortest(int ind)
{
  int i, j;
  int o1, o2;
  int ft = 1;
  double cp1[2], res, res1, a, d, bdist = 1e+50;
  int bi = -1;

  if (shortest[ind] >= 0)  return shortest[ind];
  d = dist(p[ind], T2);
  for (i = 0; i < N; i++) {
    o1 = ORNi(p[ind], T2, ots[i][0]);
    o2 = ORNi(p[ind], T2, ots[i][1]);
    if (o1*o2 != -1)  continue;
    getcp(p[ind], T2, ots[i][0], ots[i][1], &cp1[0], &cp1[1]);
    a = dist(p[ind], cp1) + dist(cp1, T2);
    if (a-d > EPS)  continue;
    if (dist(p[ind], cp1) < bdist) {
      bdist = dist(p[ind], cp1);
      bi = i;
    }
    ft = 0;
  }
  if (bi == -1)  return shortest[ind] = d;
  res1 = 1e+50;
  for (i = 0; i < 2; i++) {
    res = dist(p[ind], ots[bi][i]) + getshortest(ots_ind[bi][i]);
    if (res < res1) {
      res1 = res;
      next[ind] = ots_ind[bi][i];
    }
  }
  return shortest[ind] = res1;
}



double dist(double *p1, double *p2)
{
  double res;

  res = sqrt((p1[0]-p2[0])*(p1[0]-p2[0])+(p1[1]-p2[1])*(p1[1]-p2[1]));
  return res;
}


double ORN(double *p1, double *p2, double *p3)
{
  return p1[0]*p2[1]+p2[0]*p3[1]+p3[0]*p1[1]-p1[0]*p3[1]-p2[0]*p1[1]-p3[0]*p2[1];
}


int ORNi(double *p1, double *p2, double *p3)
{
  double res = ORN(p1, p2, p3);
  if (res < -EPS)  return -1;
  if (res >  EPS)  return  1;
  return 0;
}


double getcp(double *p11, double *p12, double *p21, double *p22, double *x, double *y)
{
  double a1, b1, c1;
  double a2, b2, c2;

  a1 = p11[1]-p12[1];
  b1 = p12[0]-p11[0];
  c1 = -a1*p11[0]-b1*p11[1];

  a2 = p21[1]-p22[1];
  b2 = p22[0]-p21[0];
  c2 = -a2*p21[0]-b2*p21[1];

  *x = (c2*b1-c1*b2)/(a1*b2-a2*b1);
  *y = (c2*a1-c1*a2)/(b1*a2-b2*a1);
  return 0;
}


void write_all(void)
{
  FILE *f = fopen("short.out", "wt");
  fprintf(f, "%.8lf\n", P);
  fclose(f);
}


