/*
Nikola Momchev Momchev
SMG
11 klas
*/

#include <stdio.h>

#define MAX 1000000
#define ERR 0.000000001
#define N 25

#define min(a,b) ((a<b)?a:b)

struct ots
{
  double x1,y1,x2,y2;
  double a,b;
};

ots mass[3*N];
double x1,y1,x2,y2;
int n;

int arepres(ots a1, ots a2);
void scan(void);
double rast(double x1,double y1,double x2,double y2);
double dist(double x1,double y1,double x2,double y2);

int cmp(double a, double b)
{
  if(a-b<ERR && b-a<ERR)
    return 0;
    
  if((a-b)>0)
    return 1;
  else
    return -1;
}

void equation(ots &a)
{
  if(cmp(a.x1 , a.x2) == 0)
  {
    a.a=MAX;
    a.b=a.x1;
    return;
  }

  a.a = (a.y1-a.y2)/(a.x1-a.x2);
  a.b = a.y1-a.a*a.x1;
}

//**************************************************
//**************************************************
//**************************************************
int main(void)
{
  freopen("short.inp","r", stdin);
  freopen("short.out", "w", stdout);

  scan();
  printf("%.8lf\n",dist(x1,y1,x2,y2));

  fclose(stdin);
  fclose(stdout);
  return 0;
}
//**************************************************
//**************************************************
//**************************************************

double dist(double x1,double y1,double x2,double y2)
{
  double ret = MAX;
  ots ot = {x1,y1,x2,y2};
  equation(ot);

  for(int i=0; i<3*n; i++)
  {
    if(arepres(mass[i],ot))
    {
      ret = min( dist(x1,y1,mass[i].x1,mass[i].y1)+dist(x2,y2,mass[i].x1,mass[i].y1),ret);
      ret = min( dist(x1,y1,mass[i].x2,mass[i].y2)+dist(x2,y2,mass[i].x2,mass[i].y2),ret);
    }
  }

  if(cmp(ret,MAX)==0)
    return rast(x1,y1,x2,y2);
    
  return ret;
}
double rast(double x1,double y1,double x2,double y2)
{
  double r = sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
  return r;
}

void scan(void)
{
  scanf("%d\n", &n);
  double x[3],y[3];
  for(int i=0; i<n; i++)
  {
    scanf("%lf %lf %lf %lf %lf %lf\n", &x[0], &y[0], &x[1], &y[1], &x[2], &y[2]);
    mass[3*i].x1 = x[0];
    mass[3*i].x2 = x[1];
    mass[3*i].y1 = y[0];
    mass[3*i].y2 = y[1];
    
    equation(mass[3*i]);

    mass[3*i+1].x1 = x[0];
    mass[3*i+1].x2 = x[2];
    mass[3*i+1].y1 = y[0];
    mass[3*i+1].y2 = y[2];

    equation(mass[3*i+1]);
    
    mass[3*i+2].x1 = x[2];
    mass[3*i+2].x2 = x[1];
    mass[3*i+2].y1 = y[2];
    mass[3*i+2].y2 = y[1];
    
    equation(mass[3*i+2]);
  }
  scanf("%lf %lf %lf %lf",&x1,&y1,&x2,&y2);
}

int arepres(ots a1, ots a2)
{
  if(cmp(a1.a,a2.a)==0)
    return 0;

  double x,y;
  x = (a2.b-a1.b)/(a1.a-a2.a);
  y = a1.a*x+a1.b;

  if( ( cmp(x,a1.x1)>=0 && cmp(x,a1.x2)>=0 ) || ( cmp(x,a1.x1)<=0 && cmp(x,a1.x2)<=0 )
    ||( cmp(x,a2.x1)>=0 && cmp(x,a2.x2)>=0 ) || ( cmp(x,a2.x1)<=0 && cmp(x,a2.x2)<=0 ) )
    return 0;

  return 1;
}


