/************************************/
/** NAME : Slavi Marinov ************/
/** CLASS : 11-12        ************/
/** PROBLEM : SHORT      ************/
/************************************/
#include <fstream>
#include <iomanip>
#include <cmath>
using namespace std;
const int MAX = 100;
const int MAXP = 20*20;

ifstream fin("SHORT.INP");
ofstream fout("SHORT.OUT");

struct line {
 long double x1,y1,x2,y2;
} l[MAX];
struct point {
 long double x,y;
} points[MAX];

int lines,n,p;
long double mas[MAXP][MAXP];


void addline(long double xa,long double ya,long double xb,long double yb) {
 lines++;
 l[lines].x1=xa;
 l[lines].x2=xb;
 l[lines].y1=ya;
 l[lines].y2=yb;
}

void init() {
 fin>>n;
 for(int i=1;i<=n;i++) {
  long double x1,y1,x2,y2,x3,y3;
  fin>>x1>>y1;
  fin>>x2>>y2;
  fin>>x3>>y3;
  addline(x1,y1,x2,y2);
  addline(x2,y2,x3,y3);
  addline(x1,y1,x3,y3);
  p++; points[p].x=x1; points[p].y=y1;
  p++; points[p].x=x2; points[p].y=y2;
  p++; points[p].x=x3; points[p].y=y3;
 }
 fin>>points[0].x>>points[0].y;
 fin>>points[p+1].x>>points[p+1].y;
}

void run() {
 for (int k=0;k<=p+1;k++)
   for (int i=0;i<=p+1;i++)
     for (int j=0;j<=p+1;j++)
       if ((mas[i][k]!=0)&&(mas[k][j]!=0)&&(((mas[i][k]+mas[k][j])<mas[i][j])||(mas[i][j]==0)))
          mas[i][j]=mas[i][k]+mas[k][j];
}

long double nass(long double x1,long double y1,
                 long double x2,long double y2,
                 long double x3,long double y3) {
  return (x1-x2)*y3+(y2-y1)*x3+x2*y1-x1*y2;
}

int cross
(long double x1,long double y1,
long double x2, long double y2,
long double x3, long double y3,
long double x4, long double y4)
{
  long double d1=nass(x1,y1,x2,y2,x3,y3);
  long double d2=nass(x1,y1,x2,y2,x4,y4);
  long double d3=nass(x3,y3,x4,y4,x1,y1);
  long double d4=nass(x3,y3,x4,y4,x2,y2);
  if (((d1*d2)<0)&&((d3*d4)<0))
   return 1; else
                  return 0;
}

long double dist(long double x1,long double y1,long double x2, long double y2) {
 return sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
}

void build() {
 for (int i=0;i<=p+1;i++)
   for (int j=0;j<=p+1;j++) {
     int pos=1;
     for (int k=1;k<=lines;k++)
        if (cross(l[k].x1,l[k].y1,l[k].x2,l[k].y2,points[i].x,points[i].y,points[j].x,points[j].y))
           pos=0;
     if (pos)
       mas[i][j]=dist(points[i].x,points[i].y,points[j].x,points[j].y);
   }
}
/*
void print_mas() {
 cout<<"********************"<<endl;
 for (int i=0;i<=p+1;i++) {
    for (int j=0;j<=p+1;j++)
       cout<<setiosflags(ios::fixed)<<setprecision(4)<<mas[i][j]<<" ";
    cout<<endl;
 }
}
*/


int main() {
 init();
 build();
/* print_mas();*/
 run();
/* print_mas();*/
 fout<<setiosflags(ios::fixed)<<setprecision(8)<<mas[0][p+1]<<endl;
 return 0;
}
