{
Yambol-4
Nikolay Nikolov, 12 (11*) klas
}

{$MODE objfpc}

Type
  Float = Extended;
  TPoint = Record
    X, Y : Float;
  End;
  TTriangle = Record
    V1, V2, V3 : TPoint;
  End;

Var
  N : Integer;
  Triangle : Array[0..50] Of TTriangle;
  StartPoint, EndPoint : TPoint;
  NumPoints : Integer;
  Point : Array[0..200] Of TPoint;
  PathBest : Array[0..200] Of Float;
  G : Array[0..200, 0..255] Of Float;
  V : Array[0..200] Of Boolean;

Operator = (a, b : TPoint) Res : Boolean;

Begin
  Res := (a.X = b.X) And (a.Y = b.Y);
End;

Function dir(V1, V2, V3 : TPoint) : Integer;

Var
  d : Float;

Begin
  d := (V1.Y + V2.Y) * (V2.X - V1.X) +
       (V2.Y + V3.Y) * (V3.X - V2.X) +
       (V3.Y + V1.Y) * (V1.X - V3.X);
  If d > 0 Then
    Exit(1)
  Else
    If d < 0 Then
      Exit(-1)
    Else
      dir := 0;
End;

Procedure AlignTriangle(Var tri : TTriangle);

Var
  tmp : TPoint;
  q : Float;

Begin
  q := dir(tri.V1, tri.V2, tri.V3);
  If q = -1 Then
  Begin
    tmp := tri.V2;
    tri.V2 := tri.V3;
    tri.V3 := tmp;
  End;
  If q = 0 Then
  Begin
    tri.V1.X := 999999;
    tri.V1.Y := 999999;
    tri.V2.X := 999999;
    tri.V2.Y := 999999;
    tri.V3.X := 999999;
    tri.V3.Y := 999999;
  End;
End;

Function intersect(P1, P2, P3, P4 : TPoint) : Boolean;

Var
  A, B, C, D : Integer;
  abDif, cdDif : Boolean;

Begin
  A := dir(P1, P2, P3);
  B := dir(P1, P2, P4);
  If ((A = 1) And (B = 1)) Or ((A = -1) And (B = -1)) Then
    Exit(False);
  C := dir(P3, P4, P1);
  D := dir(P3, P4, P2);
  If ((C = 1) And (D = 1)) Or ((C = -1) And (D = -1)) Then
    Exit(False);
  abDif := ((A = 1) And (B = -1)) Or ((A = -1) And (B = 1));
  cdDif := ((C = 1) And (D = -1)) Or ((C = -1) And (D = 1));
  If abDif And cdDif Then
    Exit(True);
  intersect := False;
End;

Procedure SwapPoints(Var P1, P2 : TPoint);

Var
  tmp : TPoint;

Begin
  tmp := P1;
  P1 := P2;
  P2 := tmp;
End;

Function intersectLT(P1, P2 : TPoint; tri : TTriangle) : Boolean;

Var
  p1inside, p2inside : Boolean;
  p1outside, p2outside : Boolean;
  a, b, c : TPoint;
  s1, s2 : Integer;

Begin
  If tri.V1.X = 999999 Then
    Exit(False);
  p1inside := (dir(tri.V1, tri.V2, P1) = 1) And
              (dir(tri.V2, tri.V3, P1) = 1) And
              (dir(tri.V3, tri.V1, P1) = 1);
  p2inside := (dir(tri.V1, tri.V2, P2) = 1) And
              (dir(tri.V2, tri.V3, P2) = 1) And
              (dir(tri.V3, tri.V1, P2) = 1);
  If p1inside And p2inside Then
    Exit(True);
  If ((P1 = tri.V1) Or (P1 = tri.V2) Or (P1 = tri.V3)) And
     ((P2 = tri.V1) Or (P2 = tri.V2) Or (P2 = tri.V3)) Then
    Exit(False);
  If ((P1 = tri.V1) Or (P1 = tri.V2) Or (P1 = tri.V3)) Or
     ((P2 = tri.V1) Or (P2 = tri.V2) Or (P2 = tri.V3)) Then
  Begin
    If (P2 = tri.V1) Or (P2 = tri.V2) Or (P2 = tri.V3) Then
      SwapPoints(P1, P2);
    If P1 = tri.V1 Then
    Begin
      a := tri.V3;
      b := tri.V1;
      c := tri.V2;
    End;
    If P1 = tri.V2 Then
    Begin
      a := tri.V1;
      b := tri.V2;
      c := tri.V3;
    End;
    If P1 = tri.V3 Then
    Begin
      a := tri.V2;
      b := tri.V3;
      c := tri.V1;
    End;
    If (dir(a, b, P2) = 1) And (dir(b, c, P2) = 1) Then
      Exit(True)
    Else
      Exit(False);
  End;
  p1outside := (dir(tri.V1, tri.V2, P1) = -1) Or
               (dir(tri.V2, tri.V3, P1) = -1) Or
               (dir(tri.V3, tri.V1, P1) = -1);
  p2outside := (dir(tri.V1, tri.V2, P2) = -1) Or
               (dir(tri.V2, tri.V3, P2) = -1) Or
               (dir(tri.V3, tri.V1, P2) = -1);
  If (p1inside And p2outside) Or (p2inside And p1outside) Then
    Exit(True);
  If p1outside And p2outside Then
  Begin
    If intersect(P1, P2, tri.V1, tri.V2) Or
       intersect(P1, P2, tri.V2, tri.V3) Or
       intersect(P1, P2, tri.V3, tri.V1) Then
      Exit(True)
    Else
      Exit(False);
  End;
  If p1inside Or p2inside Then
    Exit(True);
  If p1outside Or p2outside Then
    Exit(False);
  If dir(tri.V1, tri.V2, P1) = 0 Then
    s1 := 12;
  If dir(tri.V2, tri.V3, P1) = 0 Then
    s1 := 23;
  If dir(tri.V3, tri.V1, P1) = 0 Then
    s1 := 31;
  If dir(tri.V1, tri.V2, P2) = 0 Then
    s2 := 12;
  If dir(tri.V2, tri.V3, P2) = 0 Then
    s2 := 23;
  If dir(tri.V3, tri.V1, P2) = 0 Then
    s2 := 31;
  Exit(s1 <> s2);
End;

Function Edge(A, B : TPoint) : Extended;

Var
  I : Integer;

Begin
  For I := 1 To N Do
    If intersectLT(A, B, Triangle[I]) Then
    Begin
      Edge := -1.0;
      Exit;
    End;
  Edge := Sqrt(Sqr(A.X - B.X) + Sqr(A.Y - B.Y));
End;

Procedure ReadIn;

Var
  F : Text;
  I : Integer;

Begin
  ASSign(F, 'SHORT.INP');
  Reset(F);
  Readln(F, N);
  For I := 1 To N Do
  Begin
    Readln(F, Triangle[I].V1.X, Triangle[I].V1.Y,
              Triangle[I].V2.X, Triangle[I].V2.Y,
              Triangle[I].V3.X, Triangle[I].V3.Y);
    AlignTriangle(Triangle[I]);
  End;
  Readln(F, StartPoint.X, StartPoint.Y, EndPoint.X, EndPoint.Y);
  Close(F);
End;

Procedure Bahur;

Var
  I, J : Integer;
  tmp : Float;
  min : Float;
  Imin : Integer;

Begin
  NumPoints := 2;
  Point[1] := StartPoint;
  Point[2] := EndPoint;
  For I := 1 To N Do
  Begin
    Inc(NumPoints);
    Point[NumPoints] := Triangle[I].V1;
    Inc(NumPoints);
    Point[NumPoints] := Triangle[I].V2;
    Inc(NumPoints);
    Point[NumPoints] := Triangle[I].V3;
  End;
  For I := 1 To NumPoints Do
    PathBest[I] := 100000000;
  PathBest[1] := 0;
  FillChar(V, SizeOf(V), 0);
  For I := 1 To NumPoints Do
    For J := I To NumPoints Do
    Begin
      tmp := Edge(Point[I], Point[J]);
      G[I, J] := tmp;
      G[J, I] := tmp;
    End;
  For I := 1 To NumPoints Do
  Begin
    min := 100000000;
    For J := 1 To NumPoints Do
      If (Not V[J]) And (PathBest[J] < min) Then
      Begin
        min := PathBest[J];
        Imin := J;
      End;
    V[Imin] := True;
    For J := 1 To NumPoints Do
    Begin
      If G[Imin, J] <> -1 Then
      Begin
        tmp := PathBest[Imin] + G[Imin, J];
        If tmp < PathBest[J] Then
          PathBest[J] := tmp;
      End;
    End;
  End;
End;

Procedure WriteOut;

Var
  F : Text;

Begin
  ASSign(F, 'SHORT.OUT');
  Rewrite(F);
  Writeln(F, PathBest[2]:0:8);
  Close(F);
End;

Begin
  ReadIn;
  Bahur;
  WriteOut;
End.
