                        (* Nikolay Georgiev Semov *)
                        (* Zala 1 - PC 5          *)
                        (* PMG - Haskovo          *)

Program Cover;

Const   NMax = 9;
        CMax = 36;  (* = 8 + 7 + 6 + 5 + 4 + 3 + 2 + 1 *)

Type    TAP = Array[1..NMax] Of Byte;
        TC  = Record P1, P2 : Byte; End;
        TAC = Array[1..CMax] Of TC;
        TDM = Set Of Byte;

Var      N : Integer;
        CC : Integer;  C : TAC;
         R : Integer; RP : TAP;
         T : Integer; TP : TAP;

Procedure InputData;
Var F : Text;
    i : Integer;
Begin
   Assign(F, 'COVER.INP');
   Reset(F);
   Read(F, N); ReadLn(F, CC);
   For i := 1 To CC Do Begin
      Read(F, C[i].P1);
      ReadLn(F, C[i].P2);
   End;
   Close(F);
End;

Function GetPos(Num : Integer) : Integer;
Var i : Integer;
Begin
   For i := 1 To N Do
      If Num = TP[i] Then Begin
         GetPos := i;
         Exit;
      End;
End;

Function IsInLeft(What, Rel : Integer) : Boolean;
Var i : Integer;
Begin
   IsInLeft := False;
   For i := 1 To Rel Do
      If GetPos(What) < GetPos(Rel) Then IsInLeft := True;
End;

Function CalcLineCover(lNum : Integer) : Integer;
Var FR : Integer;
    i  : Integer;
Begin
   FR := 0;
   For i := 1 To CC Do
      If ( (IsInLeft(C[i].P1, lNum + 1)) And (Not IsInLeft(C[i].P2, lNum + 1)) )
      Or ( (Not IsInLeft(C[i].P1, lNum + 1)) And (IsInLeft(C[i].P2, lNum + 1)) ) Then
         FR := FR + 1;
   CalcLineCover := FR;
End;

Function CalcCover : Integer;
Var FR : Integer;
    FT : Integer;
    i  : Integer;
Begin
   FR := 1;
   For i := 1 To N - 1 Do Begin
      FT := CalcLineCover(i);
      If FT > FR Then FR := FT;
   End;
   CalcCover := FR;
End;

Procedure Generate(AtPos : Integer; DM : TDM);
Var i : Integer;
Begin
   For i := 1 To N Do
      If i In DM Then Begin
         TP[AtPos] := i;
         DM := DM - [i];
         If AtPos = N Then Begin
            T := CalcCover;
            If T < R Then Begin
               R := T;
               RP := TP;
            End;
         End Else Generate(AtPos + 1, DM);
         DM := DM + [i];
      End;
End;

Procedure ProceedData;
Var K : TDM;
    i : Integer;
Begin
   K := [];
   For i := 1 To N Do K := K + [i];
   R := 100;
   Generate(1, K);
End;

Procedure OutputData;
Var F : Text;
    i : Integer;
Begin
   Assign(F, 'COVER.OUT');
   ReWrite(F);
   WriteLn(F, R);
   For i := 1 To N Do
      Write(F, RP[i], ' ');
   Close(F);
End;

BEGIN
   InputData;
   ProceedData;
   OutputData;
END.
