#include <stdio.h>
#include <time.h>
#include <stdlib.h>

#define MAXN 210
#define MAXK 10
#define INF 2000000000

int time_pass[MAXN];
int mat[MAXN][MAXN];
unsigned char conn[MAXN][MAXN];
// -1  -> no path
// >=0 -> j is in the value-th list of intersections for i
int a[MAXN][MAXK];	//street pass-time
char u[MAXN][MAXK];	//usable

int n;//number of junctions
int m;//number of streets
int k;

int main()
{
	int i, j;
	int source, target, v, v1, v2;
	int fl, ei, efl;
	int min;
	FILE * f = fopen("lights.inp", "r");
	FILE * fo = fopen("lights.out", "w");
	fscanf(f, "%d%d%d", & n, & m, & k);

	for (i = 1; i <= n; i++)
		for (j = 1; j <= n; j++)
			conn[i][j] = -1;
	for (i = 1; i <= n; i++)
	{
		fscanf(f, "%d", time_pass + i);
		for (j = 0; j < k; j++)
            while (1)
			{
				fscanf(f, "%d", & v);
				if (v == -1)
					break;
				conn[i][v] = j;
			}
	}
	for (i = 1; i <= n; i++)
		for (j = 1; j <= n; j++)
			mat[i][j]=INF;
	for (i = 0; i < m; i++)
	{
		fscanf(f, "%d%d%d", & v1, & v2, & v);
		mat[v1][v2] = mat[v2][v1] = v;
	}
	while (1)
	{
		if (fscanf(f, "%d%d", & source, & target) == -1)
			break;
		if (source == -1 || target == -1)
			break;
		for (i = 1; i <= n; i++)
			for ( j = 0; j < k; j++)
			{
				a[i][j] = INF;
				u[i][j] = 1;
			}
		for (j = 0; j < k; j++)
		{
			a[0][j] = INF;
			u[0][j] = 0;
		}
		a[source][0] = 0;
		while (1)
		{
			ei = 0;
			efl = 0;
			for (i = 1; i <= n; i++)
				for (fl = 0; fl < k; fl++)
					if (u[i][fl] && a[ei][efl] > a[i][fl])
					{
						ei = i;
						efl = fl;
					}
			if (ei == 0 || a[ei][efl] == INF)
				break;
			u[ei][efl] = 0;

			for (i = 1; i <= n; i++)
				if (conn[i][ei] != -1)
					if (conn[i][ei] == (efl + 1) % k)
					{
						if (mat[i][ei] + a[ei][efl] < a[i][(efl + 1) % k])
						{
							a[i][(efl + 1) % k] = mat[i][ei] + a[ei][efl];
						}
					}
					else
					{
						if (mat[i][ei] + time_pass[i] + a[ei][efl] < a[i][(efl + 1) % k])
						{
							a[i][(efl + 1) % k] = mat[i][ei] + a[ei][efl] + time_pass[i];
						}
					}
		}
		min = INF;
		for (j = 0; j < k; j++)
			if (min > a[target][j])
			{
				min = a[target][j];
			}
		if (min < INF)
            fprintf(fo, "%d\n", min);
		else
			fprintf(fo, "No route\n");
	}
	fclose(f);
	fclose(fo);
	return 0;
}