/*
NAME   : Valentin Stoianov Mihov
CUTY   : Varna
GROUP  : A
NUMBER : A9
*/

#include <stdio.h>
#include <string.h>
#define INPF "lights.in"
#define MAXN 201
#define MAXK 11
#define INF 2000000000

typedef struct
  {
    int z;
    short k[MAXK][MAXN];
    short len[MAXK];
  } Vertex;

int n,k,m;
Vertex vrs[MAXN];
int gr[MAXN][MAXN];
int ras[MAXN][MAXN];

int Zab(int a,int b,int s)
  {
    int r=s%k,i;
    for(i=0;i<vrs[b].len[r];i++)
      if(vrs[b].k[r][i]==a) return 0;
    return vrs[b].z;
  }

void Solve(int s,int d)
  {
    int dist[MAXN];
    int visited[MAXN];
    int S[MAXN];
    int min,sum,i;
    memset(visited,0,sizeof(visited));
    memset(S,0,sizeof(S));
    for(i=0;i<=n;i++) dist[i]=INF;
    dist[s]=0;
    S[s]=0;
    while(1)
      {
        min=-1;
        for(i=1;i<=n;i++)
          if(!visited[i] && (min==-1 || dist[min]>dist[i])) min=i;
        if(min==-1) break;
        visited[min]=1;
        for(i=1;i<=n;i++)
          if(gr[min][i])
            {
              sum=dist[min]+gr[min][i]+Zab(min,i,S[min]+1);
              if(sum<dist[i]) {dist[i]=sum;S[i]=S[min]+1;}
            }
      }
    if(dist[d]==INF) printf("No route\n");
    else printf("%d\n",dist[d]);
    for(i=1;i<=n;i++)
      ras[s][i]=dist[i];
  }

void Init()
  {
    FILE *f=/*fopen(INPF,"rt")*/ stdin;
    int tmp,a,b,c,i,j;
    memset(vrs,0,sizeof(vrs));
    fscanf(f,"%d%d%d",&n,&m,&k);
    for(i=1;i<=n;i++)
      {
        fscanf(f,"%d",&vrs[i].z);
        for(j=0;j<k;j++)
          {
            fscanf(f,"%d",&tmp);
            while(tmp!=-1)
              {
                vrs[i].k[j][vrs[i].len[j]++]=tmp;
                fscanf(f,"%d",&tmp);
              }
          }
      }
    for(i=0;i<m;i++)
      {
        fscanf(f,"%d%d%d",&a,&b,&c);
        gr[a][b]=gr[b][a]=c;
      }

    for(i=1;i<=n;i++)
      for(j=1;j<=n;j++)
        ras[i][j]=-1;
    while(!feof(f))
      {
        fscanf(f," %d %d ",&a,&b);
        if(ras[a][b]==-1) Solve(a,b);
        else
          {
            if(ras[a][b]!=INF) printf("%d\n",ras[a][b]);
            else printf("No route\n");
          }
      }
//    fclose(f);
  }

int main()
  {
    Init();
    return 0;
  }
