program worch( input, output );
const
  NMax = 2500;
type
  TN = 0..NMAx;
  Str20 = string[ 20 ];
  TOgr  = Byte;
  TLTable = array[ TN ] of record
                             Wrd : Str20;
                             Parent : TN;
                             Len   : TN;
                             Vis   : Boolean;
                           end;
  TGraph = record
             LTable : TLTable;
             ETable : array[ TN, TN ] of Boolean;
           end;
var
  MaxWords : TN;
  Graph : TGraph;

function Can( a, b : String ): Boolean;
var
  i,j : Integer;
  Source, Target : Str20;
  diff : Integer;
  isThere : Boolean;
begin
  Diff := 0;
  if Length( a ) = Length( b ) - 1 then
  begin
    Source := a;
    Target := b;
  end
  else
  begin
    Can := false;
    Exit;
  end;
  for i := 1 to Length( Target ) do
  begin
    IsThere := false;
    for j := 1 to Length( Source ) do
     if Target[ i ] = Source[ j ] then
     begin
       IsThere := true;
       Break;
     end;
    if not IsThere and ( Diff = 0 ) then
      Inc( Diff )
    else
    if not IsThere and ( Diff > 0 ) then
    begin
      Can := false;
      Exit;
    end;
  end;
  Can:= true;
end;
var cc : String;
procedure ReadInp;
var
  Ans : Str20;f: text;
begin
  {$I-}
  Assign( f, 'worch.inp' );
  ReSet( f );
  cc := 'worch.out';
  if IOREsult <> 0 then
  begin
    Assign( f, 'worch.ou' );
    ReSet( f );
    cc := 'worch.ou';
    if IOResult <> 0 then
    begin
      Assign( f, '' );
      ReSet( f );
      cc := '';
    end;
  end;
  MaxWords := 0;
  while not eof( f ) do
  begin
    ReadLn( f, Ans );
    if Ans <> '' then
    begin
      Inc( MaxWords );
      Graph.LTable[ MaxWords ].Wrd := Ans;
    end;
  end;
end;
procedure CreateETable;
var
  Curr, Node : 0..NMax;
begin
  for Node := 1 to MaxWords do
    for Curr := 1 to MaxWords do
      if Node <> Curr then
        with Graph do
        if Can( LTable[ Node ].Wrd, LTable[ Curr ].Wrd ) then
          ETable[ Node, Curr ] := True
        else
          ETable[ Node, Curr ] := False
      else
        Graph.ETAble[ Node, Curr ] := False;
end;
type
  TQu = array[ 1..NMAx ] of TN;
  TQueue = object
             Data : TQu;
             count : TN;
             constructor Create;
             procedure Push( What : TN );
             function  Pop: TN;
             function  IsEmpty : Boolean;
           end;
constructor TQueue.Create;
begin
  Count := 0;
end;
procedure TQueue.Push( What: TN );
begin
  Inc( Count );
  Data[ Count ] := What;
end;
function TQueue.Pop: TN;
begin
  if Count > 0 then
  begin
    Dec( Count );
    Pop := Data[ Count + 1 ];
  end
  else
  Pop := 0;
end;
function TQueue.IsEmpty : Boolean;
begin
  IsEmpty := Count = 0;
end;
var
  Qu : TQueue;
function Next3( Old : TN ): TN;
var
  i : TN; Res : Boolean;
begin
  Res := false;
  for i := Old + 1 to MaxWords do
    if Length( Graph.LTable[ i ].Wrd ) = 3 then
    begin
      Res := true;
      Break;
    end;
  if Res then
    Next3 := i
  else
    Next3 := 0;
end;
function NextE( Node, Old : TN ): TN;
var
  i : Integer;
  Res : Boolean;
begin
  Res := false;
  for i := Old + 1 to MaxWords do
    if Graph.ETable[ Node, i ] then
    begin
      Res := true;
      Break;
    end;
  if Res then
    NextE := i
  else
    NextE := 0;
end;
procedure Breadth( Elem : TN );
var
  Ed : TN; Way : TN;
begin
  Qu.Create;
  with graph do
  begin
    LTable[ Elem ].Vis := true;
    Qu.Push( Elem );
    while not Qu.IsEmpty do
    begin
      Elem := Qu.Pop;
      Way := LTable[ Elem ].Len + 1;
      Ed := NextE( Elem, 0 );
      while Ed <> 0 do
      begin
        if LTable[ Ed ].Len < Way then
        begin
          LTable[ Ed ].Len := Way;
          LTable[ Ed ].Parent := Elem;
        end;
        if not LTable[ Ed ].Vis then
        begin
          Qu.Push( Ed );
          LTable[ Ed ].Vis := true
        end;

        Ed := NextE( Elem, Ed );
      end;
    end;
  end;
end;
procedure Find;
var
  El : TN;
begin
  El := Next3( 0 );
  while El <> 0 do
  begin
    Breadth( El );
    El := Next3( El );
  end;
end;
var f : Text;
procedure FollowPath( i : TN );
begin
  if i > 0 then
  begin
    FollowPath( Graph.LTable[ i ].Parent );
    WriteLn( f, Graph.LTable[ i ].Wrd );
  end;
end;
procedure FindPrintMAx;
var
  i : TN;
  Max : TN;
  ii : TN;
begin
  Max := 0;ii := 0;
  for i := 1 to MAxWords do
    if Graph.LTable[ i ].Len > Max then
    begin
      Max:= Graph.LTable[ i ].Len;
      ii := i;
    end;
  FollowPath( ii );
end;
var

  i : TN;
begin
  ReadInp;
  CreateETable;
  Find;
  assign(f, cc );
  rewrite( f );
  FindPrintMax;
  close( f );
end.
