/* INCLUDES *****************************************************************/
   #include <iostream>
   #include <cstdlib>

   using namespace std;

/* CONSTANTS ****************************************************************/
   const int MAXN = 202;
   const int MAXK = 12;
   const int MAXVAL = 2000000000;

   const int NOROUTE = 1999999999;
   const char* CNOROUTE = "No route";

/* CLASSES ******************************************************************/
/* GLOBALS ******************************************************************/
   int n;
   int k;

   bool v[MAXN][MAXK][MAXN];

   int e[MAXN][MAXN];

   //
   int w[MAXN];
   int p[MAXN][MAXK];
   bool flag[MAXN][MAXN];

   //
   int res[MAXN][MAXN];

   int v1;

/* FUNCTIONS ****************************************************************/
/****************************************************************************/
   void done()
   {
      exit(0);
   }
/****************************************************************************/
   void init()
   {
      int m;

      cin >> n >> m >> k;

      for (int i = 1; i <= n; ++i)
      {
         cin >> w[i];
         for (int j = 0; j < k; ++j)
         {
            while (true)
            {
               int no;
               cin >> no;
               if (no < 0) break;
               v[i][j][no] = true;
            }
         }
      }

      for (int i = 0; i < m; ++i)
      {
         int a;
         int b;
         int c;

         cin >> a >> b >> c;

         e[a][b] = c;
         e[b][a] = c;
      }

      //cout << "Finished(input);" << endl << flush;
   }
/****************************************************************************/
   void print(int v1, int v2)
   {
      if (res[v1][v2] == NOROUTE)
         cout << CNOROUTE << endl << flush;
      else
         cout << res[v1][v2] << endl << flush;
   }
/****************************************************************************/
   void run()
   {
      for (int i = 1; i < MAXN; ++i)
         for (int j = 1; j < MAXN; ++j)
            res[i][j] = MAXVAL;


      //cout << "Finished(run.1);" << endl << flush;
      while (true)
      {
         int v2;
         cin >> v1 >> v2;
         //cout << "Begin(run.2):" << v1 << " " << v2 << endl << flush;
         if (cin.eof()) break;

         if (res[v1][v2] != MAXVAL)
         {
            print(v1, v2);
            continue;
         }

         // CAN BE OPTIMIZED (out of cycle)
         for (int i = 1; i <= n; ++i)
            for (int j = 0; j < k; ++j)
            {
               p[i][j] = MAXVAL;
               // this CAN NOT BE OPTIMIZED
               flag[i][j] = false;
            }

         //

         p[v1][0] = 0;
         int vmin = v1;
         int kmin = 0;

         while (flag[vmin][kmin] != true)
         {
            for (int i = 1; i <= n; ++i)
               if (e[vmin][i] != 0)
               {
                  int newk = kmin + 1;
                  if (newk >= k) newk = 0;

                  int newc = p[vmin][kmin] + e[vmin][i];
                  if (!v[i][newk][vmin]) newc += w[i];

                  if (newc < p[i][newk])
                  {
                     p[i][newk] = newc;
                     //cout << newc << endl << flush;
                  }
               }

            if (p[vmin][kmin] < res[v1][vmin]) res[v1][vmin] = p[vmin][kmin];
            flag[vmin][kmin] = true;

         // find new one
            int minimum = MAXVAL;
            for (int i = 1; i <= n; ++i)
               for (int j = 0; j < k; ++j)
                  if (p[i][j] < minimum && flag[i][j] == false)
                  {
                     vmin = i;
                     kmin = j;
                     minimum = p[vmin][kmin];
                  }
         }

         for (int i = 1; i <= n; ++i)
            if (res[v1][i] == MAXVAL)
               res[v1][i] = NOROUTE;

         print(v1, v2);
         //cout << "Finished(run.2):" << v1 << " " << v2 << endl << flush;
      }
   }
/****************************************************************************/
   int main()
   {
      init();
      run();
      done();
      /**/
      //cout << MAXVAL << endl << flush;

      return 0;
   }
/****************************************************************************/

