#include <stdio.h>

#define MAX_NODES	200

int adj[10][MAX_NODES][MAX_NODES];
int a[10][MAX_NODES][MAX_NODES];
int n, k;
int x, y;

void read() {
	int delay[MAX_NODES];
	int m;
	int i, j, n1, n2, x;

	scanf("%i %i %i", &n, &m, &k);
	for (i = 0; i < n; i++) {
		scanf("%i", delay + i);
		for (j = 0; j < k; j++)
			while (1) {
				scanf("%i", &x);
				if (x == -1)
					break;
				a[j][x - 1][i] = 1;
			}
	}

	while (m-- > 0) {
		scanf("%i %i %i", &n1, &n2, &x);
		n1--; n2--;
		for (i = 0; i < k; i++) {
			adj[i][n1][n2] = x + (!a[i][n1][n2] ? delay[n2] : 0);
			adj[i][n2][n1] = x + (!a[i][n2][n1] ? delay[n1] : 0);
		}
	}
}

int best;


int visited2[10][MAX_NODES];
int DFS(int node, int depth, int dist) {
	int i;

	if (node == y) {
		best = dist;
		return;
	}
	if (visited2[depth%k][node] || dist > best)
		return;
	visited2[depth%k][node] = 1;
	for (i = 0; i < n; i++)
		if (adj[depth%k][node][i])
			DFS(i, depth + 1, dist + adj[depth%k][node][i]);
}

int visited[MAX_NODES];

void DFS_vis(int node) {
	int i;

	visited[node] = 1;
	for (i = 0; i < n; i++)
		if (!visited[i] && adj[0][node][i])
			DFS_vis(i);
}

int main() {
	int i, j;

	read();
	while (scanf("%i %i", &x, &y) == 2) {
		best = 0x7FFFFFFF;
		x--; y--;
		for (i = 0; i < n; i++)
			visited[i] = 0;
		DFS_vis(x);
		if (visited[y]) {
			for (i = 0; i < n; i++)
				for (j = 0; j < k; j++)
					visited2[j][i] = 0;
			DFS(x, 1, 0);
			printf("%i\n", best);
		}
		else
			printf("No route\n");
	}
	return 0;
}

