#include <stdio.h>
#include <string.h>

#define MAX_WORDS	250000
#define MAX_LET		20

#define ABS(x) (((x) > 0) ? (x) : -(x))

typedef struct {
	char len;
	char word[MAX_LET + 1];
	char lets[26];
	char can_prod;
	int parent;
} SWord;

SWord words[MAX_WORDS];
int n;
int ind[32];
int last[32];

int fcmp(const void *e1, const void *e2) {
	SWord *s1, *s2;
	int i;

	s1 = (SWord *)e1;
	s2 = (SWord *)e2;

	if (s1->len != s2->len)
		return s1->len - s2->len;

	for (i = 0; i <	26; i++)
		if (s1->lets[i] != s2->lets[i])
			return s1->lets[i] - s2->lets[i];

	return 0;
}

int Parse(char *word) {
	int i, sz;

	sz = strlen(word) - 1;
	if (sz < 3)
		return 0;

	for (i = 0; i < 26; i++)
		words[n].lets[i] = 0;

	for (i = 0; i < sz; i++) {
		words[n].word[i] = word[i];
		words[n].lets[word[i] - 'a']++;
	}
	words[n].len = sz;
	words[n].word[sz] = 0;
	if (sz == 3) {
		words[n].can_prod = 1;
		last[3] = n;
	}
	else
		words[n].can_prod = 0;

	return 1;
}

int transform(SWord *x, SWord *y) {
	int i;

	for (i = 0; i < 26; i++)
		if (x->lets[i] != y->lets[i])
			return x->lets[i] - y->lets[i];
	return 0;
}

void traceback(SWord *x) {
	if (x->len != 3)
		traceback(words + x->parent);
	printf("%s\n", x->word);
}

int search(int l, int r, SWord *x) {
	int t, mid, i;

	while (l <= r) {
		mid = (l + r)/2;
		t = transform(x, words + mid);
		if (!t)
			return mid;
		if (t > 0)
			l = mid + 1;
		else
			r = mid - 1;
	}
	return -1;
}

int main() {
	char line[32];
	int i, j, k, t;
	SWord temp;

	for (i = 0; i < MAX_LET; i++)
		last[i] = 0;

	n = 0;
	while (fgets(line, 32, stdin))
		if (Parse(line))
			n++;

	qsort(words, n, sizeof(SWord), fcmp);

	j = 3; i = 0;
	ind[j] = 0;
	while (i < n)
		if (words[i].len != j) {
			j++;
			ind[j] = i;
		}
		else
			i++;

	ind[j + 1] = n;

	for (i = 4; i <= MAX_LET; i++)
		for (j = ind[i]; j < ind[i + 1]; j++)
			for (k = 0; k < 26; k++)
				if (words[j].lets[k]) {
					words[j].lets[k]--;
					t = search(ind[i - 1], ind[i] - 1, words + j);
					words[j].lets[k]++;
					if (t >= 0 && words[t].can_prod) {
						words[j].parent = t;
						words[j].can_prod = 1;
						last[i] = j;
						break;
					}
				}

	for (i = MAX_LET - 1; i >= 3; i--)
		if (last[i])
			break;

	traceback(words + last[i]);

	return 0;
}

