#include <stdio.h>
#include <stdlib.h>

#define MAX_WORDS                       250010l
#define MAX_LEN				21

char dictionary[MAX_WORDS][MAX_LEN];
int count_len[MAX_LEN];
int start[MAX_LEN];
int longest;

int curr_seq[MAX_LEN];
int best_seq[MAX_LEN];
int best_len;

int mycmp(const void *a, const void *b) {
	if (strlen(a) < strlen(b))
		return -1;

	if (strlen(b) < strlen(a))
		return 1;

	return 0;
}

int isgood(int prev, int curr) {
	int i;
	int diffs = 0;
	int letters[26] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					   0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					   0, 0, 0, 0, 0, 0};

	for (i = 0; i < strlen(dictionary[curr]); i++) {
		letters[dictionary[prev][i] - 'a']--;
		letters[dictionary[curr][i] - 'a']++;
	}

	for (i = 0; i < 26; i++)
		diffs += abs(letters[i]);

	return diffs == 1;
}

void find_next(int last_word, int len) {
	int i;

	curr_seq[len] = last_word;

	if (len > best_len) {
		memcpy(best_seq, curr_seq, sizeof(int)*MAX_LEN);
		best_len = len;
	}

	for (i = start[len]; i < start[len + 1]; i++) {
		if (isgood(last_word, i))
			find_next(i, len + 1);
	}
}

int main() {
	int i;
	int word_count;

	FILE *input;

	input = fopen("worch.in", "r");

	word_count = 0;
//	while (scanf("%s\n", dictionary[word_count]) == 1) {
	while (fgets(dictionary[word_count], MAX_LEN, stdin) != NULL) {
		dictionary[word_count][strlen(dictionary[word_count]) - 1] = 0;
		if (strlen(dictionary[word_count]) > longest)
			longest = strlen(dictionary[word_count]);

		count_len[strlen(dictionary[word_count])]++;

		if (strlen(dictionary[word_count]) > 2)
			word_count++;
	}
	fclose(input);

	for (i = 1; i < MAX_LEN; i++)
		start[i] = start[i - 1] + count_len[i - 1];

	qsort(dictionary, word_count, sizeof(char) * MAX_LEN, mycmp);

	for (i = 0; i < count_len[3]; i++)
		find_next(i, 4);

	for (i = 4; i <= best_len; i++)
		printf("%s\n", dictionary[best_seq[i]]);

	return 0;
}

