{Georgi Kadrev, Ruse}
Const
 MaxN = 200;
 MaxK = 10;

 None = 'No route';

Type
 VSet = Set Of Byte;

 LightRec  = Record
              Time : LongInt;
              Adv  : Array[0..MaxK-1] Of VSet;
             End;

 WantedRec = Record
              Src,Trg : LongInt;
              Dst     : LongInt;
             End;

 DArr = Array[1..MaxN] Of LongInt;

Var
 G      : Array[1..MaxN,1..MaxN] Of LongInt;
 D,Cnt  : Array[1..MaxN] Of DArr;
 L      : Array[1..MaxN] Of LightRec;
 Wanted : Array[1..MaxN] Of WantedRec;
 LVal,
 ACount,
 X,Y,I,J,
 N,M,K  : LongInt;
 Bx     : Byte;
 S      : String;

 Procedure FindMins(V : Integer; var Dist : DArr);
 Var
  NewD,
  MinJ,
  CUSed,
  JJ,II : LongInt;
  Used  : Array[1..MaxN] Of Boolean;
  Flag : Boolean;
 Begin
  FillChar(Used, SizeOf(Used), False);
  Dist[V] := 0;
  Used[V] := True;
  CUsed := 1;

  For II:=1 To N Do If G[V,II] <> -1 Then
   Begin
    Cnt[V,II] := 1;
    Dist[II] := G[V,II];
    If not (V in L[II].Adv[1]) Then Dist[II] := Dist[II] + L[II].Time;
   End;

   Repeat
     MinJ := 0;
     Repeat
      Inc(MinJ);
     Until (Dist[MinJ] <> -1) and (not Used[MinJ]);

     For JJ:=1 To N Do
      If not Used[JJ] Then
       If Dist[JJ] <> -1 Then
        If Dist[JJ] < Dist[MinJ] Then MinJ := JJ;
     Used[MinJ] := True;
     Inc(CUsed);
     Flag := False;

     For II:=1 To N Do
      If not Used[II] Then
       If G[MinJ,II] <> -1 Then
        Begin
         Flag := True;
         NewD := Dist[MinJ] + G[MinJ,II];
         If not(MinJ in L[II].Adv[(Cnt[V,MinJ] + 1) mod K]) Then
          NewD := NewD + L[II].Time;

         If (NewD < Dist[II]) or (Dist[II] = -1) Then
          Begin
           Dist[II] := NewD;
           Cnt[V,II] := Cnt[V,MinJ] + 1;
          End;
        End;
   Until (CUsed >= N) or (not Flag);
 End;

 Procedure ExtractInts(St : String; var Int1,Int2 : LongInt);
 Var
  SI1,SI2,
  Stn  : String;
  P    : Byte;
  Code : Integer;
 Begin
  Stn := St;
  While Stn[1] = ' ' Do Delete(Stn,1,1);
  While Stn[Length(Stn)] = ' ' Do Delete(Stn,Length(Stn),1);
  P := Pos(' ',Stn);

  SI1 := Copy(Stn, 1, P-1);
  While SI1[1] = ' ' Do Delete(SI1,1,1);
  While SI1[Length(SI1)] = ' ' Do Delete(SI1,Length(SI1),1);

  SI2 := Copy(Stn, P+1, Length(Stn)-P);
  While SI2[1] = ' ' Do Delete(SI2,1,1);
  While SI2[Length(SI2)] = ' ' Do Delete(SI2,Length(SI2),1);

  Val(SI1, Int1, Code);
  Val(SI2, Int2, Code);
 End;

Begin
 Readln(N, M, K);

 For I:=1 To N Do
  For J:=1 To N Do
   Begin
   G[I,J] := -1;
   D[I][J] := -1;
   End;

 For I:=1 To N Do
  Begin
   Readln(L[I].Time);
   For J:=0 To K-1 Do
    Begin
     L[I].Adv[J] := [];
     Repeat
      Read(X);
      If X < 0 Then Break;

      Bx := X;
      L[I].Adv[J] := L[I].Adv[J] + [Bx];
     Until X = -1;
    End;
  End;

 For I:=1 To M Do
  Begin
   Readln(X,Y,LVal);
   G[X,Y] := LVal;
   G[Y,X] := G[X,Y];
  End;

 ACount := 0;
 Repeat
  Inc(ACount);
  Readln(S);
  If Length(S) < 1 Then
   Begin
    Dec(ACount);
    Break;
   End;
  ExtractInts(S, X, Y);
  Wanted[ACount].Src := X;
  Wanted[ACount].Trg := Y;
 Until Length(S)<1;

{Solution : Dejkstra modification for each vertex O(n^3)}

 For I:=1 To N Do
  Begin
   For J:=1 To N Do
    D[I][J] := -1;

   FindMins(I,D[I]);

   For X:=1 To ACount Do
    If Wanted[X].Src = I Then
     Wanted[X].Dst := D[I, Wanted[X].Trg];
  End;

 For I:=1 To ACount Do
  Begin
  If D[Wanted[I].Src][Wanted[I].Trg] <> -1 Then
    Writeln(D[Wanted[I].Src][Wanted[I].Trg])
   Else
    Writeln(None);
  End;

End.
