/*
NAME: Ivan Iliev Anev
SCHOOL: SMG
GROUP: A
NUMBER: 50
PROG: lights
LANG: C
*/

#include <stdio.h>
#include <limits.h>

#define MAXN 256
#define MAXK 16

typedef struct Vex TVex;
typedef struct Edge TEdge;

struct Vex {
       int slow;
       int a[MAXK][MAXN];
       TEdge *edges;
};

struct Edge {
       int v, w;
       TEdge *next;
};

typedef struct SVex TSVex;
struct SVex {
       int k, h;
};

int n, m, k;
TVex vs[MAXN];
int ans[MAXN][MAXN];
int v[MAXN];

TSVex spvs[MAXN*MAXK];

int heap[MAXN*MAXK];
int heapsize;

void readf(void);
void solve(void);
void writef(void);

int main(void) {
    readf();
    solve();
    writef();

    return 0;
}

void readf(void) {
     int i, j, r, a, b, w;

     void add_edge(int a, int b, int w);

//     freopen("lights.in", "r", stdin);

     scanf("%d%d%d", &n, &m, &k);
     for (i = 0; i < n; ++i) {
         scanf("%d", &vs[i].slow);
         for (j = 0; j < k; ++j)
             while (1) {
                   scanf("%d", &r);
                   if (r == -1)
                      break;
                   vs[i].a[j][r-1] = 1;
             }
     }

     for (i = 0; i < m; ++i) {
         scanf("%d%d%d", &a, &b, &w);
         --a;
         --b;
         add_edge(a, b, w);
         add_edge(b, a, w);
     }
}

void solve(void) {
     int i, j;

     void dijkstra(int s);

     for (i = 0; i < n; ++i)
         for (j = 0; j < n; ++j)
             ans[i][j] = INT_MAX;

     for (i =  0; i < n ; ++i)
         dijkstra(i);
}

void writef(void) {
     int a, b;

     void dijkstra(int s);

     while (scanf("%d%d", &a, &b) != -1) {
//           if (v[a-1] == 0) {
  //            dijkstra(a-1);
    //          v[a-1] = 1;
      //     }
           if (ans[a-1][b-1] != INT_MAX)
               printf("%d\n", ans[a-1][b-1]);
           else
               printf("No route\n");
     }
}

void add_edge(int a, int b, int w) {
     TEdge *e;

     e = (TEdge*)malloc(sizeof(TEdge));
     e->v = b;
     e->w = w;
     e->next = vs[a].edges;
     vs[a].edges = e;
}

void dijkstra(int s) {
     int i, j, cv, ck, nv, sv, onv, t, nk;
     TEdge *e;

     void add(int v);
     void top(void);
     void move_up(int x);

     for (i = 0; i < n; ++i)
         for (j = 0; j < k; ++j) {
             spvs[i * MAXK + j].k = INT_MAX;
             spvs[i * MAXK + j].h = -1;
         }

     spvs[s * MAXK].k = 0;
     add(s * MAXK);

     while (heapsize > 0) {
           sv = heap[0];
           cv = sv / MAXK;
           ck = sv % MAXK;
           if (ans[s][cv] > spvs[sv].k)
              ans[s][cv] = spvs[sv].k;
           top();
           for (e = vs[cv].edges; e; e = e->next) {
               onv = e->v;
               nk = (ck + 1) % k;
               nv = onv * MAXK + nk;
               if (spvs[nv].k > (t = spvs[sv].k + e->w + ((vs[onv].a[nk][cv]) ? 0 : vs[onv].slow))) {
                  spvs[nv].k = t;
                  if (spvs[nv].h == -1)
                     add(nv);
                  else
                      move_up(spvs[nv].h);
               }
           }
     }
}

void move_up(int x) {
     int p, key;

     key = heap[x];
     while (x > 0 && (p = (x - 1) / 2) >= 0) {
           if (spvs[key].k < spvs[heap[p]].k) {
              heap[x] = heap[p];
              spvs[heap[p]].h = x;
              x = p;
           }
           else
               break;
     }
     heap[x] = key;
     spvs[key].h = x;
}

void move_down(int x) {
     int key, c;

     key = heap[x];
     while ((c = 2 * x + 1) < heapsize) {
           if (c + 1 < heapsize && spvs[heap[c+1]].k < spvs[heap[c]].k)
              ++c;
           if (spvs[key].k > spvs[heap[c]].k) {
              spvs[heap[c]].h = x;
              heap[x] = heap[c];
              x = c;
           }
           else
               break;
     }
     heap[x] = key;
     spvs[key].h = x;
}

void add(int v) {
     heap[heapsize] = v;
     spvs[v].h = heapsize++;
     move_up(heapsize-1);
}

void top(void) {
     heap[0] = heap[--heapsize];
     spvs[heap[0]].h = 0;
     move_down(0);
}

