/*
PROG : game
NAME : vladimir nedev
*/

#include <stdio.h>
#include <time.h>

//#define DEBUG

#define IN      "game.in"
#define OUT     "game.out"
#define MAXN    210
#define MAXS    20010
#define MAXD    1000

struct BIG
{
   long digits;
   char num[MAXD];
};

long n, s;
struct BIG res[2][MAXS], *prev_res, *cur_res, *tmp;
struct BIG sum[2][MAXS], *prev_sum, *cur_sum, *tmp;
long a[MAXN], b[MAXN];

void BIG_long(struct BIG *x, long n);
void BIG_copy(struct BIG *x, struct BIG *y);
void BIG_add(struct BIG *x, struct BIG *y);
void BIG_sub(struct BIG *x, struct BIG *y);

int main()
{
   long i, j, k, l, r;

#ifdef DEBUG
   clock();
   freopen(IN, "r", stdin);
#endif
   scanf("%ld%ld", &n, &s);
   for(i=1; i<=n; i++)
      scanf("%ld%ld", a+i, b+i);
#ifdef DEBUG
   fclose(stdin);
#endif

   BIG_long(&(res[0][i]), 0);
   BIG_long(&(sum[0][i]), 0);

   for(i=1; i<=s; i++)
   {
      if(i>=a[1] && i<=b[1])
        BIG_long(&(res[0][i]), 1);
      else
        BIG_long(&(res[0][i]), 0);

      BIG_copy(&(sum[0][i]), &(sum[0][i-1]));
      BIG_add(&(sum[0][i]), &(res[0][i]));
   }

   prev_res=res[0];
   cur_res=res[1];

   prev_sum=sum[0];
   cur_sum=sum[1];

   for(i=2; i<=n; i++)
   {
      BIG_long(&(cur_sum[0]), 0);
      
      for(j=1; j<=s; j++)
      {
         l=j-b[i]-1;
         if(l<0) l=0;
         
         r=j-a[i];
         if(r<0) r=0;

         BIG_copy(&(cur_res[j]), &(prev_sum[r]));
         BIG_sub(&(cur_res[j]), &(prev_sum[l]));

         BIG_copy(&(cur_sum[j]), &(cur_sum[j-1]));
         BIG_add(&(cur_sum[j]), &(cur_res[j]));
      }

      tmp=prev_res;
      prev_res=cur_res;
      cur_res=tmp;

      tmp=prev_sum;
      prev_sum=cur_sum;
      cur_sum=tmp;
   }

   if(s==0 || prev_res[s].digits==0)
   {
     prev_res[s].digits=1;
     prev_res[s].num[0]=0;
   }

#ifdef DEBUG
   freopen(OUT, "w", stdout);
#endif
   for(i=prev_res[s].digits-1; i>=0; i--)
      printf("%c", prev_res[s].num[i]+'0');
   printf("\n");
#ifdef DEBUG
   printf("Time : %lfs.", clock()/(double)CLOCKS_PER_SEC);
   fclose(stdout);
#endif

   return 0;
}

void BIG_long(struct BIG *x, long n)
{
   x->digits=0;
   
   while(n)
   {
     x->num[x->digits++]=n%10;
     n/=10;
   }
}

void BIG_copy(struct BIG *x, struct BIG *y)
{
   long i;

   for(i=0; i<y->digits; i++)
      x->num[i]=y->num[i];

   x->digits=y->digits;
}

void BIG_add(struct BIG *x, struct BIG *y)
{
   long i, l1, l2;
   char cur, ost;

   l1=x->digits;
   l2=y->digits;

   ost=0;

   for(i=0; i<l1 || i<l2; i++)
   {
      cur=0;
      if(i<l1) cur+=x->num[i];
      if(i<l2) cur+=y->num[i];
      cur+=ost;

      x->num[i]=cur%10;
      ost=cur/10;
   }

   x->digits=i;

   if(ost)
     x->num[x->digits++]=ost;
}

void BIG_sub(struct BIG *x, struct BIG *y)
{
   long i, l1, l2;
   char cur, ost;

   ost=0;

   l1=x->digits;
   l2=y->digits;

   for(i=0; i<l1 || i<l2; i++)
   {
      if(i<l1) cur=x->num[i];
      if(i<l2) cur-=y->num[i];
      cur-=ost;

      if(cur<0)
      {
        cur+=10;
        ost=1;
      }
      else
        ost=0;

      x->num[i]=cur;
   }

   for(i=l1-1; i>=0; i--)
      if(x->num[i]!=0) break;

   x->digits=i+1;
}

