/*
PROG : mono
NAME : vladimir nedev
*/

//#define DEBUG

#include <stdio.h>

#define IN      "mono.in"
#define OUT     "mono.out"
#define MAXD    200

struct BIG
{
   long digits;
   char num[MAXD];
};

struct BIG pass;
struct BIG comb_big[30][30];

long n;
char res[30];

long long fac[30];
long long comb[30][30];

void BIG_zero(struct BIG *x);
void BIG_reverse(struct BIG *x);
void BIG_long(struct BIG *x, long n);
void BIG_long_long(struct BIG *x, long long n);
void BIG_copy(struct BIG *x, struct BIG *y);
void BIG_add(struct BIG *x, struct BIG *y);
void BIG_sub(struct BIG *x, struct BIG *y);
int BIG_cmp(struct BIG *x, struct BIG *y);


int main()
{
   long i, j, k, l, t, cur;
   char c;

#ifdef DEBUG
   freopen(IN, "r", stdin);
#endif

   c=getc(stdin);
   while(c>='0' && c<='9')
   {
      pass.num[pass.digits++]=c-'0';
      c=getc(stdin);
   }

#ifdef DEBUG
   fclose(stdin);
#endif

   BIG_reverse(&pass);

   fac[0]=1;
   for(i=1; i<=13; i++)
      fac[i]=fac[i-1]*i;

   for(i=0; i<=26; i++)
      BIG_long(&(comb_big[i][0]), 1);

   for(i=1; i<=26; i++)
      for(j=1; j<=i; j++)
      {
         if(j<i-j)
         {
           comb[i][j]=1;
           
           for(k=i-j+1; k<=i; k++)
              comb[i][j]*=k;
              
           comb[i][j]/=fac[j];
         }
         else
         {
           comb[i][j]=1;
           
           for(k=j+1; k<=i; k++)
              comb[i][j]*=k;
              
           comb[i][j]/=fac[i-j];
         }

         BIG_long_long(&(comb_big[i][j]), comb[i][j]);
      }

   for(n=1; ; n++)
      if(BIG_cmp(&pass, &(comb_big[26][n])) <=0) break;
      else
      {
        BIG_sub(&pass, &(comb_big[26][n]));
      }

   res[0]='a'-1;
   for(i=1; i<=n; i++)
   {
      for(j=res[i-1]+1; j<='z'; j++)
         if(BIG_cmp(&pass, &(comb_big['z'-j][n-i])) <=0)
           break;
         else
         {
           BIG_sub(&pass, &(comb_big['z'-j][n-i]));
         }

      res[i]=j;
   }

#ifdef DEBUG
   freopen(OUT, "w", stdout);
#endif

   for(i=1; i<=n; i++)
      printf("%c", res[i]);

   printf("\n");

#ifdef DEBUG
   fclose(stdout);
#endif

   return 0;
}

void BIG_zero(struct BIG *x)
{
   x->digits=0;
}

void BIG_reverse(struct BIG *x)
{
    long i,j;
    char t;

    for(i=0, j=x->digits-1; i<j; i++, j--)
    {
       t=x->num[i];
       x->num[i]=x->num[j];
       x->num[j]=t;
    }
}

void BIG_long(struct BIG *x, long n)
{
   x->digits=0;
   
   while(n)
   {
     x->num[x->digits++]=n%10;
     n/=10;
   }
}

void BIG_long_long(struct BIG *x, long long n)
{
   x->digits=0;
   
   while(n)
   {
     x->num[x->digits++]=n%10;
     n/=10;
   }
}

void BIG_copy(struct BIG *x, struct BIG *y)
{
   long i;

   for(i=0; i<y->digits; i++)
      x->num[i]=y->num[i];

   x->digits=y->digits;
}

void BIG_add(struct BIG *x, struct BIG *y)
{
   long i, l1, l2;
   char cur, ost;

   l1=x->digits;
   l2=y->digits;

   ost=0;

   for(i=0; i<l1 || i<l2; i++)
   {
      cur=0;
      if(i<l1) cur+=x->num[i];
      if(i<l2) cur+=y->num[i];
      cur+=ost;

      x->num[i]=cur%10;
      ost=cur/10;
   }

   x->digits=i;

   if(ost)
     x->num[x->digits++]=ost;
}

void BIG_sub(struct BIG *x, struct BIG *y)
{
   long i, l1, l2;
   char cur, ost;

   ost=0;

   l1=x->digits;
   l2=y->digits;

   for(i=0; i<l1 || i<l2; i++)
   {
      if(i<l1) cur=x->num[i];
      if(i<l2) cur-=y->num[i];
      cur-=ost;

      if(cur<0)
      {
        cur+=10;
        ost=1;
      }
      else
        ost=0;

      x->num[i]=cur;
   }

   for(i=l1-1; i>=0; i--)
      if(x->num[i]!=0) break;

   x->digits=i+1;
}

int BIG_cmp(struct BIG *x, struct BIG *y)
{
   long i, l1, l2;

   l1=x->digits;
   l2=y->digits;

   if(l1<l2) return -1;
   else
     if(l1>l2) return 1;
     else
     {
       for(i=l1-1; i>=0; i--)
          if(x->num[i] < y->num[i])
            return -1;
          else
            if(x->num[i] > y->num[i])
              return 1;

       return 0;
     }
}

