#include <stdio.h>
#include <string.h>

#define MAXN	256
#define MAXS	32768
#define LNL	124

int n, s;
int a[MAXN];
int b[MAXN];

typedef struct lnum {
	int l;
	char d[LNL];
} lnum;

lnum t[MAXS];

void print(lnum *a) {
	int i;

        if (a->l == 0) {
           printf("0\n");
           return;
        }
	for (i = a->l - 1; i >= 0; i--)
		printf("%c", a->d[i] + '0');
	printf("\n");
}

void copy(lnum *a, lnum *b) {
	a->l = b->l;
	memcpy(a->d, b->d, LNL);
}

void set1(lnum *a) {
	a->l = 1;
	a->d[0] = 1;
}

void set0(lnum *a) {
	a->l = 0;
	memset(a->d, 0, LNL);
}

void add(lnum *a, lnum *b) {
	int i;
	int c;
	int lm;

	c = 0;
	if (a->l > b->l)
		lm = a->l;
	else
		lm = b->l;
		
	for (i = 0; i < lm; i++) {
		a->d[i] += b->d[i] + c;
		c = a->d[i]/10;
		a->d[i] %= 10;
	}
	if (c) {
		a->d[i] = 1;
		i++;
	}
	a->l = i;
}

void sub(lnum *a, lnum *b) {
	int i;
	int j;

	for (i = b->l - 1; i >= 0; i--) {
		if (a->d[i] < b->d[i]) {
			for (j = i + 1; ; j++)
				if (a->d[j] > 0)
					break;
			a->d[j]--;
			if ((a->d[j] == 0) && (j == a->l - 1))
				a->l--;
				
			for (j--; j > i; j--)
				a->d[j] = 9;
			a->d[i] += 10;
		}
		a->d[i] -= b->d[i];
	}
}

int main() {
	int i, j, k;
	int ms;
	lnum ts;
	
	scanf("%d%d", &n, &s);
	for (i = 0; i < n; i++)
		scanf("%d%d", &a[i], &b[i]);

	for (i = a[0]; i <= b[0]; i++)
		set1(&t[i]);

	ms = a[0];
	for (i = 1; i < n; i++) {
		set0(&ts);
		for (k = a[i]; k <= b[i]; k++)
			if (s - k >= ms)
				add(&ts, &t[s - k]);
		copy(&t[s], &ts);
		for (j = s-1; j >= ms + a[i]; j--) {
			sub(&ts, &t[j+1 - a[i]]);
			if (j - b[i] >= ms)
				add(&ts, &t[j - b[i]]);
			copy(&t[j], &ts);
		}
		ms += a[i];
	}

	print(&t[s]);

	return 0;
}
