#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define VIRUSES 20

int LEN[VIRUSES];
char lines[VIRUSES][1024*1024];
int N;

char insert[1024*1024];
void insert_at_pos(int len, int *pos) {
	int i;
	char x;
	
	for (i = 0; i < len; i++) {
		x = rand()%16;
		insert[i] = x >= 10 ? x - 10 + 'A' : x + '0';
	}

	for (i = 0; i < N; i++)
		if (len + pos[i] > LEN[i]) {
			printf("Insert cannot fit in line %i(pos: %i, len: %i, line len: %i)\n", i, pos[i], len, LEN[i]);
			return;
		}
	for (i = 0; i < N; i++)
		memcpy(lines[i] + pos[i], insert, len);
	printf("Done.\n");
}

void init_strings(int seed, int n, int *len) {
	int i, j;
	char x;

	N = n;
	srand(seed);
	for (i = 0; i < n; i++) {
		LEN[i] = len[i];
		for (j = 0; j < len[i]; j++) {
			x = rand()%16;
			lines[i][j] = x >= 10 ? x - 10 + 'A' : x + '0';
		}
		lines[i][len[i]] = 0;
	}
	printf("Done.\n");
}

void show() {
	int i;

	printf("%i\n", N);
	for (i = 0; i < N; i++)
		printf("%s\n", lines[i]);
}

void write_file(int n) {
	char filename[32];
	int i;
	FILE *f;

	sprintf(filename, "virus.in%i", n);
	f = fopen(filename, "wt");
	fprintf(f, "%i\n", N);
	for (i = 0; i < N; i++)
		fprintf(f, "%s\n", lines[i]);
	fclose(f);
	printf("%s written.\n", filename);
}

typedef struct {
	unsigned int hash;
	int pos;
} SHash;

typedef SHash SHashed[1024*1024];

#define SIZE	16
#define CONVERT(x) (((x) >= 'A' && (x) <= 'F') ? (x) - 'A' + 10 : (x) - '0')
#define PRIME	((1 << 25) - 39)
int n;
SHashed first, second;
int first_ptr = 0;
int second_ptr = 0;

int fcmp(const void *e1, const void *e2) {
	SHash *s1, *s2;

	s1 = (SHash *)e1;
	s2 = (SHash *)e2;
	return s1->hash - s2->hash;
}

int hash_prog(SHashed temp, char *prog, int len) {
	int i, sum = 0;
	int mul = 1;
	
	for (i = 0; i < len; i++) {
		if (prog[i] == 0)
			return 0;
		sum = (sum*SIZE + CONVERT(prog[i]))%PRIME;
		if (i > 0) 
			mul = (mul*SIZE)%PRIME;
	}
	
	i = 0;
	while (1) {
		temp[i].pos = i;
		temp[i].hash = sum;
		if (prog[i + len] == 0)
			break;
		sum = (SIZE*(PRIME + sum - (mul*CONVERT(prog[i]))%PRIME) + CONVERT(prog[i + len]))%PRIME;
		i++;
	}

	i++;
	qsort(temp, i, sizeof(SHash), fcmp);
	return i;
}

void check_virus(int l) {
	int k, i, j, i2, j2, wr, t;
	
	first_ptr = hash_prog(first, lines[0], l);
	for (k = 1; k < n; k++) {
		second_ptr = hash_prog(second, lines[k], l);
		i = j = wr = 0;
		while (i < first_ptr && j < second_ptr) {
			while (i < first_ptr && first[i].hash < second[j].hash)
				i++;
			while (j < second_ptr && first[i].hash > second[j].hash)
				j++;
			if (i < first_ptr && j < second_ptr && 
					first[i].hash == second[j].hash) {
				t = first[i].hash;
				for (i2 = i; i2 < first_ptr && first[i2].hash == t; i2++)
					for (j2 = j; j2 < second_ptr && second[j2].hash == t; j2++) 
						if (!strncmp(lines[0] + first[i2].pos, 
									 lines[k] + second[j2].pos, l)) {
							first[wr].hash = t;
							first[wr++].pos = first[i2].pos;
							break;
						}
				i++;
				while (i < first_ptr && first[i].hash == t)
					i++;

				j++;
				while (j < second_ptr && second[j].hash == t)
					j++;
			}
		}
		first_ptr = wr;
		if (!wr)
			break;
	}
}

void run_prog() {
	int i, j, l, h;
	
	n = N;
	h = 1024*1024;
	for (i = 0; i < n; i++) {
		l = LEN[i];
		if (l < h)
			h = l;
	}
	
	l = h/10 - 1;
	h = h/3 + 1;
	printf("Searching range: (%i, %i)\n", l, h);

	while (l + 1 < h) {
		i = (l + h)/2;
		printf("Checking %i\n", i);
		check_virus(i);
		if (first_ptr < 1)
			h = i;
		if (first_ptr == 1)
			break;
		if (first_ptr > 1)
			l = i;
	}

	if (first_ptr != 1) {
		check_virus(l);
		if (first_ptr > 1)
			printf("Too many(%i) solutions of size %i.\n", first_ptr, l);
		else
			printf("No solution in the selected region.\n");
	}
	else {
		printf("Solution: ");
		for (j = 0; j < i; j++)
			printf("%c", lines[0][j + first[0].pos]);
		printf(" (%i)\n", i);
	}
}

int show_cmd() {
	int param1, param2;
	int param3[VIRUSES];
	int i;

	printf("(I)nsert I(n)it (R)un (S)how (W)rite (Q)uit\n");
g1:
	switch (getchar()) {
		case 'i':
		case 'I':
			printf("Length: ");
			scanf("%i", &param1);
			for (i = 0; i < N; i++) {
				printf("Pos %i(%i): ", i, LEN[i]);
				scanf("%i", param3 + i);
			}
			insert_at_pos(param1, param3);
		break;

		case 'n':
		case 'N':
			do {
				printf("N (2-%i): ", VIRUSES);
				scanf("%i", &param1);
			} while (param1 < 2 || param1 > VIRUSES);
			printf("Seed: ");
			scanf("%i", &param2);
			for (i = 0; i < param1; i++) {
				printf("Length %i: ", i);
				scanf("%i", param3 + i);
			}
			init_strings(param2, param1, param3);
		break;

		case 'r':
		case 'R':
			run_prog();
		break;

		case 's':
		case 'S':
			show();
		break;

		case 'w':
		case 'W':
			printf("Test nr: ");
			scanf("%i", &param1);
			write_file(param1);
		break;

		case 'q':
		case 'Q':
			return 0;
		default:
			goto g1;
	}
	return 1;
}

int main() {
	while (show_cmd())
		;
	printf("Bye.\n");
	return 0;
}

