#include <stdio.h>
#include <math.h>
#include <assert.h>
#include <iostream>
//using namespace std;
/*
#define bool char
#define true 1
#define false 2
*/
struct point{
	double x;
	double y;
};

point location[1000];
double dist[1000][1000];
bool fixed[1000];

int gun, fix, n;

void Input();
void Output();
void Solve();

int main(){
        Input();
        Solve();
	Output();
	return 0;
}

void Input(){
        scanf("%d %d %d", &n, &gun, &fix);
        int i, j, k, p;
        --gun;
        --fix;

        for (i = 0; i < n; ++i){
                fixed[i] = false;
                for (j = 0; j < n; ++j){
                        if (i == j)
                                dist[i][j] = dist[j][i] = 0;
                        else
                                dist[i][j] = dist[j][i] = -1;
                }
        }

        fixed[gun] = true;
        fixed[fix] = true;
        location[gun].x = 0;
        location[gun].y = 0;
        location[fix].y = 0;

        int got = 3;
        while (got == 3){
                got = scanf("%d %d", &k, &p);
                if (got == 2){
                        got += scanf("%lf", &dist[k - 1][p - 1]);
                        if (got == 3)
                                dist[p - 1][k - 1] = dist[k - 1][p - 1];
                }
        }

        location[fix].x = dist[fix][gun];
        //assert(dist[fix][gun] > 0);
}

void Output(){
        int i;
        std::cout.precision(2);
        std::cout.setf(std::ios_base::showpoint | std::ios_base::fixed);
        for (i = 0; i < n; ++i){
                std::cout << dist[gun][i] << '\n';
                //printf("%.2lf\n", &dist[gun][i]);
        }
}

double Dist2(const point &a, const point &b){
        double x = a.x - b.x;
        double y = a.y - b.y;
        return (x * x) + (y * y);
}

double Dist(const point &a, const point &b){
        return sqrt(Dist2(a, b));
}

//a^2 = b^2 + c^2 - 2*b*c*cos(alpha)
double cos(double a, double b, double c){
        return (b * b + c * c - a * a) / (2 * b * c);
}

void FindElementary(){
        int i;
        for (i = 0; i < n; ++i){
                if (i == gun || i == fix)
                        continue;

                if (dist[gun][i] <= 0 || dist[fix][i] <= 0 || fixed[i])
                        continue;
                                        
                double cosine = cos(dist[fix][i], dist[gun][i], dist[gun][fix]);
                double left_dst = cosine * dist[gun][i];
                double h = sqrt(dist[gun][i] * dist[gun][i] - left_dst * left_dst);
                location[i].x = left_dst;
                location[i].y = h;
                fixed[i] = true;
        }
}

point Dekart(double angle, double rad){
        point ret;
        ret.x = cos(angle) * rad;
        ret.y = sin(angle) * rad;
        return ret;        
}

double absd(double a){
        if (a < 0)
                return -a;
        return a;
}

bool InRange(double a, double b, double error){
        return (a < b + error && a > b - error);
}

void FindComplex(){
        int unfixed = n;
        int i, j, k;
        int p[3];//1, p2, p3;
        for (i = 0; i < n; ++i){
                if (fixed[i]) --unfixed;
        }
        double hPI = M_PI / 2.0;
        while (unfixed > 0){
                for (i = 0; i < n; ++i){
                        if (fixed[i])
                                continue;

                        k = 0;
                        for (j = 0; j < n && k < 3; ++j){
                                if (j == i)
                                        continue;
                                if (fixed[j] && dist[i][j] > 0)
                                        p[k++] = j;
                        }

                        --unfixed;
                        //first we use two of the points to set two possible locations for the third
                        double cosine = cos(dist[i][p[1]], dist[i][p[0]], dist[p[0]][p[1]]);
                        double cosine2 = absd(location[p[0]].x - location[p[1]].x) / dist[p[0]][p[1]];
                        double lft_sde = cosine * dist[i][p[0]];
                        double rad = sqrt(dist[i][p[0]] * dist[i][p[0]] * (1 - cosine2));
                        double angle = acos(cosine2) + hPI;
                        point vec = Dekart(angle, rad);
                        point vec2;
                        vec2.x = -(location[p[0]].x - location[p[1]].x) * lft_sde / dist[p[0]][p[1]];
                        vec2.y = -(location[p[0]].y - location[p[1]].y) * lft_sde / dist[p[0]][p[1]];
                        location[i].x = location[p[0]].x + vec.x + vec2.x;
                        location[i].y = location[p[0]].y + vec.y + vec2.y;
                        //now this is really getting hairy.
                        //we may have got just two points.
                        //this means we'll have to shoot in the dark
                        //the point must not be the gun, fix, or have a less-than-0 y
                        //but we allow a 0.003 error
                        if (k < 3){
                                if (location[i].y < -0.003){
                                        location[i].x = location[p[0]].x + vec2.x - vec.x;
                                        location[i].y = location[p[0]].y + vec2.y - vec.y;
                                        continue;
                                }

                                if (InRange(location[i].x, location[gun].x, 0.003) && InRange(location[i].y, location[gun].y, 0.003)){
                                        location[i].x = location[p[0]].x + vec2.x - vec.x;
                                        location[i].y = location[p[0]].y + vec2.y - vec.y;
                                        continue;
                                }

                                if (InRange(location[i].x, location[fix].x, 0.003) && InRange(location[i].y, location[fix].y, 0.003)){
                                        location[i].x = location[p[0]].x + vec2.x - vec.x;
                                        location[i].y = location[p[0]].y + vec2.y - vec.y;
                                        continue;
                                }
                                continue;
                        }
                        //we have three points.
                        double distt = Dist(location[i], location[p[2]]);
                        if (!(distt < dist[i][p[2]] + 0.003 && distt > dist[i][p[2]] - 0.003)){
                                location[i].x = location[p[0]].x + vec2.x - vec.x;
                                location[i].y = location[p[0]].y + vec2.y - vec.y;
                        }
                        fixed[i] = true;
                }
        }
}

void Solve(){
        FindElementary();
        FindComplex();
        for (int i = 0; i < n; ++i){
                if (!(dist[gun][i] <= 0 && i != gun))
                        continue;

                dist[gun][i] = dist[i][gun] = Dist(location[i], location[gun]);
        }
}