#include <stdio.h>
#include <math.h>

#define N 1<<10

#define ORAREA(x1,y1,x2,y2,x3,y3) ((x1-x3)*(y2-y3)-(x2-x3)*(y2-y3))
#define ORAREA2(p1,p2,p3) ORAREA(p1.x,p1.y,p2.x,p2.y,p3.x,p3.y)

typedef double fract;

struct Point
{
  fract x,y;
};

int n,m;
int f1,f2;
int nn[N];
int nl[N][N];
char fix[N];
Point pnt[N];
fract dist[N][N];
int stack[4*N][3],r,w;



   
Point v31,v32;
fract A,B,C;
fract D,E;
fract a,b,c;

Point findPointC(Point v1, Point v2, Point bv, fract d1, fract d2)
{
  A=2*(v2.x-v1.x);
  B=2*(v2.y-v1.y);
  C=v1.x*v1.x+v1.y*v1.y+d1*d1 - (v2.x*v2.x+v2.y*v2.y+d2*d2);
  D= -B/A;
  E= -C/A;
  a=D*D+1;
  b=2*D*(E-v1.x)-2*v1.y;
  c=(E-v1.x)*(E-v1.x)+v1.y*v1.y-d2*d2;

  v31.y= (-b+sqrt(b*b-4*a*c))/(2*a);
  v31.x= D*v31.y + E;    

  v32.y= (-b-sqrt(b*b-4*a*c))/(2*a);
  v32.x= D*v32.y + E;

  if((ORAREA2(v1,v2,v31)>0) == (ORAREA2(v1,v2,bv)>0))
    return v32;
  return v31;
}

void init()
{
  fix[f1]=1;
  fix[f2]=1;

  pnt[f2].x=dist[f1][f2];
  //printf("%f\n",dist[f1][f2]);
  pnt[0].x=(pnt[f1].x+pnt[f2].x);
  pnt[0].y= -1;

  stack[0][0]=f1;
  stack[0][1]=f2;
  w=1;
}

void readf()
{
  int i,j,k;
  scanf("%d %d %d",&n,&f1,&f2);
  while(scanf("%d %d",&j,&k)!=EOF)
  {
    m++;
    scanf("%lf",&dist[j][k]);
    //printf("%lf\n",dist[j][k]);
    dist[k][j]=dist[j][k];
    nl[j][nn[j]++]=k;
    nl[k][nn[k]++]=j;
  }
} 

void fixPoint(int pid, int c1, int c2, int c3)
{
  //printf("fix pnt: %d add1: %d %d add2: %d %d\n",pid,pid,c1,pid,c2);
  fix[pid]=1;

  stack[w][0]=pid;
  stack[w][1]=c1;
  stack[w][2]=c2;
  w++;            
  stack[w][0]=pid;
  stack[w][1]=c2;
  stack[w][2]=c1;
  w++;

  pnt[pid]=findPointC(pnt[c1],pnt[c2],pnt[c3],dist[c2][pid],dist[c1][pid]);
}

void solve()
{
  int i,c1,c2;

  while(r<w)
  {
    c1=stack[r][0];
    c2=stack[r][1];

    if(nn[c1]>nn[c2])
    {
      i=c1;
      c1=c2;
      c2=i;
    }

    for(i=0; i<nn[c1]; i++)
      if(!fix[nl[c1][i]]&&dist[c2][nl[c1][i]])
      {
        fixPoint(nl[c1][i],c1,c2,stack[r][2]);
      }

    r++;
  }
}

void writef()
{
  int i;
  for(i=1; i<=n; i++)
  {
    printf("%.2lf\n",hypot(pnt[i].x,pnt[i].y));
  }
}

int main()
{
  readf();
  init();
  solve();
  writef();
  return 0;
}

