#include <stdio.h>
#include <string.h>
#include <math.h>
#define EPS 0.0001

 struct point
  {
   double x,y;
  }a[1024];

 struct side
  {
   long v1,v2;
  }q[16384];

 long n,s,e;
 long marked[1024][1024];
 long used[1024];
 long g[1024][1024][2];
 double dist[1024][1024];
 FILE *f;
 
 double distance (struct point a,struct point b)
  {
   return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
  }

 long orient (struct point a,struct point b,struct point c)
  {
   double pom;
   pom=a.x*(b.y-c.y)+a.y*(c.x-b.x)+b.x*c.y-b.y*c.x;
   if (pom<0) return 0;
   if (pom>0) return 1;
   return 2;
  }

 struct point make_triangle (long i,long j,long k,double sgn)
  {
   double cx,cy,aa,bb,cc,A,B,C,d,sgn;
   struct point tmp;
// prawq centyr
   cx=a[i].x;
   cy=a[i].y;
   a[i].x-=cx;
   a[i].y-=cy;
   a[j].x-=cx;
   a[j].y-=cy;
// dylvinite na stranite na i,j,k
   cc=dist[i][j];
   aa=dist[i][k];
   bb=dist[j][k];
// prawa usporedna na dadenata
   A=a[i].y-a[j].y;
   B=a[j].x-a[i].x;
   C=a[i].x*a[j].y-a[i].y*a[j].x;
   d=sin(acos((aa*aa+cc*cc-bb*bb)/(2*aa*cc)))*aa;
   C=C-d*sgn;
// koq wizmovnost
   d=dist[i][k]*dist[i][k];
   aa=A*A+B*B;
   bb=B*C;
   cc=C*C-d*A*A;
   
   tmp.y=(-bb-sqrt(bb*bb-aa*cc))/aa;
   tmp.x=sqrt(d-tmp.y*tmp.y);
   if (fabs(distance(tmp,a[j])-dist[j][k])<EPS) goto skip;

   tmp.y=(-bb+sqrt(bb*bb-aa*cc))/aa;
   tmp.x=sqrt(d-tmp.y*tmp.y);
   if (fabs(distance(tmp,a[j])-dist[j][k])<EPS) goto skip;
// skip
   skip:
    {
     a[i].x+=cx;
     a[i].y+=cy;
     a[j].x+=cx;
     a[j].y+=cy;
     tmp.x+=cx;
     tmp.y+=cy;
     return tmp;
    }
   fprintf(stderr,"error\n");
   exit (0);
  }

 void make_triple (long i,long j,long k)
  {
   g[i][j][orient(a[i],a[j],a[k])]=1;
   g[j][i][orient(a[j],a[i],a[k])]=1;

   g[i][k][orient(a[i],a[k],a[j])]=1;
   g[k][i][orient(a[k],a[i],a[j])]=1;

   g[j][k][orient(a[j],a[k],a[i])]=1;
   g[k][j][orient(a[k],a[j],a[i])]=1;
   
//
   marked[i][j]=marked[j][i]=1;
   if (marked[i][k]==0)
    {
     marked[i][k]=marked[k][i]=1;
     e++;
     q[e].v1=i;
     q[e].v2=k;
    }
   if (marked[j][k]==0)
    {
     marked[j][k]=marked[k][j]=1;
     e++;
     q[e].v1=j;
     q[e].v2=k;
    }
  }

 int main ()
  {
   long i,j,v,u;
   double o;
   struct side tmp;
   struct point h;
   f=fopen("d.in","r");
   fscanf(f,"%ld%ld%ld",&n,&i,&j);
   s=e=1;
   q[1].v1=i;
   q[1].v2=j;
   marked[i][j]=marked[j][i]=1;
   while (fscanf(f,"%ld%ld%lf",&v,&u,&o)==3)
    dist[v][u]=dist[u][v]=o;
   a[j].x=dist[i][j];
   while (s<=e)
    {
     tmp=q[s];
     memset(used,0,sizeof(used));
     for (i=1;i<=n;i++)
      if (dist[tmp.v1][i]!=0)
       used[i]++;
     for (i=1;i<=n;i++)
      if (dist[tmp.v2][i]!=0)
       used[i]++;
     for (i=1;i<=n;i++)
      if (used[i]==2)
       {
        h=make_triangle(tmp.v1,tmp.v2,i,1);
        a[i]=h;
        if (g[tmp.v1][tmp.v2][orient(a[tmp.v1],a[tmp.v2],a[i])]==0)
         make_triple(tmp.v1,tmp.v2,i);
          else
           {
            h=make_triangle(tmp.v1,tmp.v2,i,-1);
            a[i]=h;
            make_triple(tmp.v1,tmp.v2,i);
           }
       }
     s++;
    }
   for (i=1;i<=n;i++)
    printf("%.2lf\n",distance(a[0],a[i]));
   return 0;
  }
  
