
#include <stdio.h>
#include <string.h>

#define MAX_N 1024

char v[256];       // Values are between 0 and 100
char d[256][256];  // Values are between 0 and 100
char alpha[MAX_N]; // No need for "unsigned char" - acceptable chars have ascii codes less than 128
char beta[MAX_N];
int t[MAX_N][MAX_N];

int min3(int x, int y, int z) {
    return (x < y)
        ? ((x < z) ? x : z)
        : ((y < z) ? y : z);
}

void main() {
     int i,j;
    // Input: visibility
    memset(v, 100, sizeof(v));
    int p;
    scanf("%d", &p);
    for (i = 0; i < p; i++) {
        unsigned char s[1];
        int x;
        scanf("%s%d", s, &x);
        int ch = s[0];
        v[ch] = x;
    }

    // Input: difference
    memset(d, 100, sizeof(d));
    for (i = 0; i < (sizeof(d) / sizeof(d[0])); i++) {
        d[i][i] = 0;
    }
    int q;
    scanf("%d", &q);
    for (i = 0; i < q; i++) {
        unsigned char s1[1];
        unsigned char s2[1];
        int x;
        scanf("%s%s%d", s1, s2, &x);
        int ch1 = s1[0];
        int ch2 = s2[0];
        d[ch1][ch2] = d[ch2][ch1] = x;
    }

    // Input: alpha and beta
    scanf("%s%s", alpha, beta);
    int nAlpha = strlen(alpha);
    int nBeta = strlen(beta);

    // Calculate distance
    t[0][0] = 0;
    for (i = 1; i <= nAlpha; i++) {
        t[i][0] = t[i - 1][0] + v[alpha[i - 1]];
    }
    for (j = 1; j <= nBeta; j++) {
        t[0][j] = t[0][j - 1] + v[beta[j - 1]];
    }
    for (i = 1; i <= nAlpha; i++) {
        for (j = 1; j <= nBeta; j++) {
            int a = alpha[i - 1];
            int b = beta[j - 1];
            t[i][j] = min3(
                    t[i - 1][j - 1] + d[a][b],  // update
                    t[i][j - 1] + v[b],         // insert
                    t[i - 1][j] + v[a]          // delete
            );
        }
    }

    // Output
    printf("%d\n", t[nAlpha][nBeta]);
}
