/*
TASK: guard
LANG: C++
*/

#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

struct point
{
 int x,y;
 point() {};
 point(int _x,int _y) { x=_x; y=_y; }
 bool operator!=(const point &a)
 { return a.x!=x || a.y!=y; }
};

struct guard
{
 point a,b;
 guard() {};
 guard(point _a,point _b) { a=_a; b=_b; }    
 void show()
 { cout<<a.x<<" "<<a.y<<" --- "<<b.x<<" "<<b.y<<endl; }  
};

point center,tmp1,tmp2;
vector<guard> A;

int cross(point a,point b,point c)
{ return (a.x-b.x)*(c.y-b.y)-(a.y-b.y)*(c.x-b.x); } 

double d(point a,point b)
{ return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y)); }

bool comp(const guard &a,const guard &b)
{
 double anglea1=asin(cross(point(center.x+1,center.y),center,a.a)/d(center,a.a))*180.0/M_PI;
 double angleb1=asin(cross(point(center.x+1,center.y),center,a.b)/d(center,a.b))*180.0/M_PI;
 double anglea2=asin(cross(point(center.x+1,center.y),center,b.a)/d(center,b.a))*180.0/M_PI;
 double angleb2=asin(cross(point(center.x+1,center.y),center,b.b)/d(center,b.b))*180.0/M_PI;
 
 return ((anglea1<anglea2) || (anglea1==anglea2 && angleb1<angleb2));
}

bool cm(point a,point b)
{ return a.x<b.x || (a.x==b.x && a.y<b.y); }

bool order()
{
 vector<point> A;
 A.push_back(center);
 A.push_back(tmp1);
 A.push_back(tmp2);
 sort(A.begin(),A.end(),cm);
 
 if(A[0]!=center && A[2]!=center) return 0;
 return 1;
}

bool checkAngles(guard t1,guard t2)
{
 double angle1=(cross(t1.a,t1.b,t2.a)/d(t1.a,t1.b))/d(t1.b,t2.a)*180/M_PI;
 double angle2=(cross(t1.a,t1.b,t2.b)/d(t1.a,t1.b))/d(t1.b,t2.b)*180/M_PI;
 return angle1<angle2;    
}

int main()
{bool answ=1;
 int i,size;
 guard toPush;
 double res,angle;
 int r;
 
 scanf("%d %d",&center.x,&center.y);
 
 scanf("%d %d %d %d",&tmp1.x,&tmp1.y,&tmp2.x,&tmp2.y);
 if(cross(tmp1,center,tmp2)==0 && order()) { cout<<100<<endl; goto end;}
 
 if(cross(tmp1,center,tmp2)>=0) A.push_back(guard(tmp1,tmp2));
 else {
      A.push_back(guard(tmp1,point(center.x-(tmp1.x-center.x),center.y-(tmp1.y-center.y)) ) );
      A.push_back(guard(point(center.x-(tmp1.x-center.x),center.y-(tmp1.y-center.y)),tmp2));
      }
 
 scanf("%d %d %d %d",&tmp1.x,&tmp1.y,&tmp2.x,&tmp2.y);
 if(cross(tmp1,center,tmp2)==0 && order()) { cout<<100<<endl; goto end;}
 
 if(cross(tmp1,center,tmp2)>=0) A.push_back(guard(tmp1,tmp2));
 else {
      A.push_back(guard(tmp1,point(center.x-(tmp1.x-center.x),center.y-(tmp1.y-center.y)) ) );
      A.push_back(guard(point(center.x-(tmp1.x-center.x),center.y-(tmp1.y-center.y)),tmp2));
      }
 
 scanf("%d %d %d %d",&tmp1.x,&tmp1.y,&tmp2.x,&tmp2.y);
 if(cross(tmp1,center,tmp2)==0 && order()) { cout<<100<<endl; goto end;}
 
 if(cross(tmp1,center,tmp2)>=0) A.push_back(guard(tmp1,tmp2));
 else {
      A.push_back(guard(tmp1,point(center.x-(tmp1.x-center.x),center.y-(tmp1.y-center.y)) ) );
      A.push_back(guard(point(center.x-(tmp1.x-center.x),center.y-(tmp1.y-center.y)),tmp2));
      }
 
 sort(A.begin(),A.end(),comp);

 while(answ && A.size()>1)
 {
  answ=0; size=A.size();
  for(i=0;i<size;i++)
   {
    if(cross(A[i].a,A[i].b,A[(i+1)%size].a)>=0 && cross(A[i].a,A[i].b,A[(i+1)%size].b)>=0 && checkAngles(A[i],A[i+1]))
                                                                                           { A.erase(A.begin()+(i+1)%size);
                                                                                             answ=1;                                                                                            answ=1;
                                                                                             break;
                                                                                             }
    if(cross(A[i].a,A[i].b,A[(i+1)%size].a)>=0 && cross(A[i].a,A[i].b,A[(i+1)%size].b)< 0) { toPush=guard(A[i].a,A[(i+1)%size].b);
                                                                                             A.erase(A.begin()+i);
                                                                                             A.erase(A.begin()+(i)%(size-1));
                                                                                             A.push_back(toPush);
                                                                                             sort(A.begin(),A.end(),comp);
                                                                                             answ=1;
                                                                                             break;
                                                                                             }                                               
    }                  
 }           
 size=A.size();
 for(int i=0;i<size;i++)
    {//A[i].show();
     angle=(cross(A[i].a,center,A[i].b)/d(A[i].a,center))/d(A[i].b,center)*180/M_PI;
     if(angle<=0) res+=angle+360; 
     else res+=angle;
    }   
 res/=360.0;
 res*=100;
 if((res-(int)res)>=0.5) res=1;
 res+=(int)res;
 r=(int)res>100?100:(int)res;
 cout<<r<<endl;
 
 end:
 
 return 0;   
}
