
/*
TASK:aminosoup
LANG:C++
*/

#include <cstdlib>
#include <iostream>
using namespace std;

const int MAXM = 6;
const int MOD = 602214179;

int dp[2][1 << MAXM];

int solve(int N, int M)
{
    memset(dp, 0, sizeof(dp));
    int cur = 0;
    int nxt = 1;
    dp[0][0] = 1;
    for (int i = 1; i <= N; ++i)
    {
        for (int j = 1; j <= M; ++j)
        {
            memset(dp[nxt], 0, sizeof(dp) / 2);
            for (int m = 0; m < (1 << M); ++m)
                if (dp[cur][m] > 0)
                {
                    if ((m & 1) > 0)
                    {
                        dp[nxt][m >> 1] += dp[cur][m];
                        if (dp[nxt][m >> 1] >= MOD)
                            dp[nxt][m >> 1] -= MOD;
                    }
                    else
                    {
                        if (j + 1 <= M && ((m & 2) == 0))
                        {
                            dp[nxt][(m >> 1) | 1] += dp[cur][m];
                            if (dp[nxt][(m >> 1) | 1] >= MOD)
                                dp[nxt][(m >> 1) | 1] -= MOD;
                        }
                        if (i + 1 <= N)
                        {
                            dp[nxt][(m >> 1) | (1 << (M - 1))] += dp[cur][m];
                            if (dp[nxt][(m >> 1) | (1 << (M - 1))] >= MOD)
                                dp[nxt][(m >> 1) | (1 << (M - 1))] -= MOD;
                        }
                    }
                }
            nxt ^= 1;
            cur ^= 1;
        }  
    }
    
    return dp[cur][0];
}

struct matrix
{
    int n;
    long long a[16][16];
    
    matrix(int n)
    {
        this->n = n;
        memset(a, 0, sizeof(a));
    }
    
    long long &operator()(int x, int y)
    {
        return a[x][y];
    }
};

    
matrix operator +(matrix a, matrix b)
{
    matrix c(a.n);
    int n = a.n;
    for (int i = 0; i < n; ++i)
       for (int j = 0; j < n; ++j)
          c(i, j) = (a(i, j) + b(i, j)) % MOD;
   return c;
}
    
matrix operator *(matrix a, matrix b)
{
    matrix c(a.n);
    int n = a.n;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j)
        {
            long long z = 0;
            for (int k = 0; k < n; ++k)
                z = (z + a(i, k) * b(k, j)) % MOD;
            z %= MOD;
            z += MOD;
            z %= MOD;
            c(i, j) = z;
        }
    return c;
}

matrix operator ^(matrix a, long long p)
{
    int n = a.n;
    matrix c(a.n);
    for (int i = 0; i < n; ++i)
        c(i, i) = 1;
    while (p > 0)
    {
        if ((p & 1) > 0)
            c = c * a;
        a = a * a;
        p >>= 1;
    }
    return c;
}

int fib(long long n)
{
    matrix f(2);
    f(0, 0) = 1, f(0, 1) = 1;
    f(1, 0) = 1, f(1, 1) = 0;
    f = f ^ n;
    return (int) f(0, 0);
}

int f[16];

int other(long long n)
{
    if ((n * 3) % 2 != 0)
        return 0;
    f[1] = solve(2, 3);
    f[2] = solve(4, 3);
    f[3] = solve(6, 3);
    f[4] = solve(8, 3);
    if (n / 2 <= 4)
        return f[n / 2];
    matrix m(2);
    m(0, 0) = 4, m(0, 1) = MOD - 1;
    m(1, 0) = 1, m(1, 1) = 0;
    m = m ^ ((n - 4) / 2);
    long long res = ((m(0, 0) * f[2] + m(0, 1) * f[1]) % MOD + MOD) % MOD;
    return res;
    for (int i = 0; i < 2; ++i, cout << endl)
        for (int j = 0; j < 2; ++j)
            cout << m(i, j) << " ";
    for (int i = 5; i <= (n + 1) / 2; ++i)
        f[i & 15] = ((4LL * f[(i - 1) & 15] - f[(i - 2) & 15]) % MOD + MOD) % MOD;
    return f[(n / 2) & 15];
}

int main()
{
    long long N, M;
    cin >> N >> M;
    
    if ((N * M) % 2 == 1)
        cout << 0 << endl;
    else if (M == 1)
        cout << 1 << endl;
    else if (M == 2)
        cout << fib(N) << endl;
    else if (M == 3)
        cout << other(N) << endl;
    else
        cout << solve(N,  M) << endl;
    
//    cout << solve(N, M) << endl;
//    cout << endl;
//    for (int i = 2; i <= 100; ++i)
//        cout << solve(i, 4) << endl;
    
    return 0;
}
