
/*
TASK:gen
LANG:C++
*/

#include <map>
#include <cmath>
#include <ctime>
#include <queue>
#include <iostream>
using namespace std;

struct ratio
{
    long long p;
    long long q;
    
    ratio(long long p, long long q)
    {
        long long g = __gcd(p, q);
        this->p = p / g;
        this->q = q / g;
    }
    
    inline bool operator <(const ratio &rhs) const
    {
        if (p != rhs.p)
            return p < rhs.p;
        return q < rhs.q;
    }
};

inline ratio doL(ratio &x)
{
    return ratio(2 * x.p + x.q, x.q);
}
inline ratio doR(ratio &x)
{
    return ratio(x.p, x.p + 2 * x.q);
}


void test()
{
    ratio x(2, 3);
    string a = "LRL";
    string b = a;
    sort(b.begin(), b.end());
    
    for (int i = 0; i < (1 << 10); ++i)
    {
        ratio Z = x;
        for (int j = 0; j < 10; ++j)
            if (((i >> j) & 1) > 0)
                Z = doL(Z);
            else
                Z = doR(Z);
        if (Z.p == x.p && Z.q == x.q)
            cout << "POINTLESS " << i << endl;
        cout << i << " " << Z.p << " " << Z.q << endl;
    }
    return;
    ratio A(x.p, x.q); 
    for (int i = 0; i < (int) a.size(); ++i)
        if (a[i] == 'L')
            A = doL(A);
        else
            A = doR(A);
    
    ratio B(x.p, x.q);
    for (int i = 0; i < (int) a.size(); ++i)
        if (b[i] == 'L')
            B = doL(B);
        else
            B = doR(B);
    cout << A.p << " " << A.q << endl;
    cout << B.p << " " << B.q << endl;
}

int main()
{
    ratio src(1, 1);
    cin >> src.p >> src.q;
    clock_t start = clock();
    queue <ratio> q;
    map <ratio, int> dp;
    q.push(src);
    int iter = 0;
    while (!q.empty())
    {
        int d = 0;
        ratio cur = q.front();
        q.pop();
        if (dp.count(cur))
            d = dp[cur];
        ratio L = doL(cur);
        if (!dp.count(L))
        {
            dp[L] = d + 1;
            q.push(L);
            if (L.p == src.p && L.q == src.q)
            {
                cout << d + 1 << endl;
                return 0;
            }
        }
        ratio R = doR(cur);
        if (!dp.count(R))
        {
            dp[R] = d + 1;
            q.push(R);
            if (R.p == src.p && R.q == src.q)
            {
                cout << d + 1 << endl;
                return 0;
            }
        }
        ++iter;
        if (iter % 1000 == 0)
        {
            if ((0.0 + clock() - start) / (double) CLOCKS_PER_SEC > 0.2)
                break;
        }
    }
    cout << 0 << endl;
    return 0;
}
