
/*
TASK:guard
LANG:C++
*/

#include <cmath>
#include <vector>
#include <iostream>
#include <algorithm>
using namespace std;

double angle(double x, double y)
{
    double a = atan2(y, x);
    a *= (180.0 / M_PI);
    if (a < 0.0)
        a += 360.0;
    return a;
}

int random(int a, int b)
{
    return (rand() * 65536 + rand()) % (b - a + 1) + a;
}

void stupid(vector <pair <double, double> > intv)
{
    int p = 0;
    int q = 0;
    for (int i = 0; i < 1000000; ++i)
    {
        double a = random(0, 1000000000) / 1000000000.0;
        a *= 360.0;
        ++q;
        for (int j = 0; j < (int) intv.size(); ++j)
            if (intv[j].first <= a && a <= intv[j].second)
            {
                ++p;
                break;
            }
    }
    cout << ((0.0 + p) / q) * 100.0 << endl;
}

int main()
{
    double cx, cy;
    cin >> cx >> cy;
    vector <double> x(6), y(6);
    for (int i = 0; i < 6; ++i)
    {
        cin >> x[i] >> y[i];
        x[i] -= cx, y[i] -= cy;
    }
    
    vector <pair <double, double> > intv;
    
    for (int i = 0; i < 3; ++i)
    {
        double s = angle(x[2 * i], y[2 * i]);
        double e = angle(x[2 * i + 1], y[2 * i + 1]);
        if (s < e)
            intv.push_back(make_pair(s, e));
        else
        {
            intv.push_back(make_pair(s, 360.0));
            intv.push_back(make_pair(0.0, e));
        }
    }
    
    sort(intv.begin(), intv.end());
    double res = 0.0;
    double end = 0.0;
    for (int i = 0; i < (int) intv.size(); ++i)
    {
        if (end > intv[i].second)
            continue;
        if (intv[i].first > end)
        {
            res += intv[i].second - intv[i].first;
            end = intv[i].second;
        }
        else
        {
            res += intv[i].second - end;
            end = intv[i].second;
        }
    }
    res /= 360.0;
    res *= 100.0;
    cout << round(res + 1e-13) << endl;
//    stupid(intv);
    return 0;
}
