/*
TASK:gen
LANG:C++
*/

#include <iostream>
#include <cstdio>
#include <queue>

using namespace std;

typedef long long int intB;

struct gen
{
    intB p, q; 
    bool operator== (const gen &temp) const
    {
        if (this->p==temp.p && this->q==temp.q)
            return true;
        else
            return false;
    }
};

int answer;
gen start;

intB NOK (intB a, intB b)
{
    intB temp;
    
    while (a > 0)
    {
        temp=a;
        a=b%a;
        b=temp;
    }
    
    return b;
}

gen left(gen temp)
{
    temp.p<<=1;
    temp.p+=temp.q;
    intB dif=NOK(temp.p, temp.q);
    temp.p/=dif;
    temp.q/=dif;
    
    return temp;
}

gen right(gen temp)
{
    temp.q=(2*temp.q+temp.p);
    intB dif=NOK(temp.p, temp.q);
    temp.p/=dif;
    temp.q/=dif;
    
    return temp;
}

void bfs()
{
    gen next;
    queue < gen > Q;
    
    Q.push(start);
    while(!Q.empty())
    {
        ++answer;
        if (answer == 21)
        {
            answer=0;
            return;
        }
        int size=Q.size();
        for (int i=0; i<size; ++i)
        {
            gen at=Q.front();
            Q.pop();
            next=left(at);
            if (next == start)
                return;
            if (next.p>0 && next.q>0)
                Q.push(next);
            next=right(at);
            if (next == start)
                return;
            if (next.p>0 && next.q>0)
                Q.push(next);
        }
    }
}

inline void input()
{ scanf("%d%d", &start.p, &start.q); }

int main()
{
    input();
    bfs();
    printf("%d\n", answer);
return 0;
}
