/*
TASK:guard
LANG:C++
*/

#include <iostream>
#include <cstdio>
#include <cmath>

using namespace std;

struct guard
{
   bool pos;
   int x, y;
   double angle;
   bool operator< (const guard &temp) const
   {
        return (this->angle < temp.angle);
   }
};

int X, Y;
double my_pi, visible, percent;
guard A[4];

void solve()
{
    my_pi=acos(-1);
    for (int i=0; i<6; ++i)
    {
        A[i].x-=X;
        A[i].y-=Y;
        A[i].angle=atan2(A[i].y, A[i].x);
        if (A[i].angle < 0)
            A[i].angle+=(2*my_pi);
    }
    X=0;
    Y=0;
    for (int i=0; i<3; ++i)
    {
        if (A[2*i].angle > A[2*i+1].angle)
        {
            double dif=(2*my_pi)-A[2*i].angle;
            A[2*i+1].angle+=(A[2*i].angle+dif);
        }
    }
    sort(A, A+6);
    double START=A[0].angle;
    for (int i=1; i<6; ++i)
    {
        if (A[i].angle > START+(2*my_pi))
            A[i].angle=START+(2*my_pi);
    }
    int cnt=1;
    double begin, end;
    begin=A[0].angle;
    for (int i=1; i<6; ++i)
    {
        if (A[i].pos)
        {
            ++cnt;
            if (cnt == 1)
                begin=A[i].angle;
        }
        else
            --cnt;
        if (!cnt)
            visible+=(A[i].angle-begin);
    }
    
    my_pi*=2;
    percent=visible/my_pi;
    percent*=100;
    printf("%.0lf\n", percent);
}

inline void input()
{
    scanf("%d%d", &X, &Y);
    for (int i=0; i<3; ++i)
    {
        scanf("%d%d", &A[2*i].x, &A[2*i].y);
        A[2*i].pos=1;
        scanf("%d%d", &A[2*i+1].x, &A[2*i+1].y);
        A[2*i+1].pos=0;
    }    
}

int main()
{
    input();
    solve();
return 0;
}
