/*
TASK:aminosoup
LANG:C++
*/

#include <algorithm>
#include <vector>
#include <ext/numeric>

typedef long long LL;
typedef std :: vector<LL> VI;
typedef std :: vector<VI> VVI;

#define f(i, n)					for(int i = 0; i < int(n); i ++)
#define sz(a)					int(a.size())

const LL MOD = 602214179LL;

VVI operator * (const VVI & a, const VVI & b)
{
int N = sz(a);
VVI ret(N, VI(N, 0LL));
	
	if(sz(a) == 0) return b;
	if(sz(b) == 0) return a;
	
	f(i, N) f(j, N) f(k, N) ret[i][j] = (ret[i][j] + a[i][k] * b[k][j]) % MOD;
	
	return ret;
}


LL N, M, ans;
VVI v;


void Read()
{
	scanf("%I64d %I64d", & N, & M);
}

void rec(const int start_a, int a, int b)
{
	if(a == ((1 << M) - 1))
	{
		v[b][start_a] ++;
		
		return;
	}
	
	f(i, M) if(!(a & (1 << i)))
	{
		if(i + 1 < M && !(a & (1 << (i + 1))))
		{
			rec(start_a, a | (1 << i) | (1 << (i + 1)), b);
		}
		
		rec(start_a, a | (1 << i), b | (1 << i));
		
		return;
	}
}

void Solve()
{
	v = VVI(1 << M, VI(1 << M, 0LL));
	
	f(i, 1 << M) rec(i, i, 0);
	
	v = __gnu_cxx :: power(v, N);
	
	ans = v[0][0];
}

void Write()
{
	printf("%d\n", int(ans % MOD));
}

int main()
{
	Read();
	
	Solve();
	
	Write();
	
	return 0;
}
