/*
TASK:gen
LANG:C++
*/

#include <algorithm>
#include <set>

#define gcd(a, b)				std :: __gcd(a, b)
#define n						first
#define d						second

typedef long long LL;
typedef std :: pair<LL, LL> PLL;

typedef struct q_type
{
	PLL a;
	int lev;
	
	q_type(const PLL & _a = PLL(0, 0), const int & _lev = 0) : a(_a), lev(_lev) {}
};

const int MAX_Q = 1 << 17;

PLL start;
q_type Q[MAX_Q];
std :: set<PLL> used;

void Read()
{
	scanf("%I64d %I64d", & start.n, & start.d);
}

PLL oprosti(PLL a)
{
LL temp = gcd(a.n, a.d);
	
	a.n /= temp;
	a.d /= temp;
	
	return a;
}

void Solve()
{
PLL temp;
LL sum;
	
	Q[0] = q_type(start, 0);
	
	for(int i = 0, top = 1; i < top; i ++)
	{
		sum = Q[i].a.n + Q[i].a.d;
		
		Q[i].a.n += sum;
		temp = oprosti(Q[i].a);
		if(used.find(temp) == used.end())
		{
			if(MAX_Q <= top + 1)
			{
				printf("0\n");
				return;
			}
			
			Q[top ++] = q_type(temp, Q[i].lev + 1);
			used.insert(temp);
			
			if(temp == start)
			{
				printf("%d\n", Q[i].lev + 1);
				return;
			}
		}
		Q[i].a.n -= sum;
		
		Q[i].a.d += sum;
		temp = oprosti(Q[i].a);
		if(used.find(temp) == used.end())
		{
			if(MAX_Q <= top + 1)
			{
				printf("0\n");
				return;
			}
			
			Q[top ++] = q_type(temp, Q[i].lev + 1);
			used.insert(temp);
			
			if(temp == start)
			{
				printf("%d\n", Q[i].lev + 1);
				return;
			}
		}
		Q[i].a.d -= sum;
	}
	
	printf("0\n");
}

int main()
{
	Read();
	
	Solve();
	
//	wait;
	
	return 0;
}
