/*
TASK:guard
LANG:C++
*/

#include <iostream>
#include <complex>
using namespace std;

typedef complex<double> point;
typedef pair<double, int> PDI;

const int MAX_N = 1 << 10;
const double EPS = 1e-9;
const double INF = 1e50;
const double PI = acos(-1.0);

#define X						real()
#define Y						imag()

int N;
PDI a[MAX_N];
double ans;

double degree(const double & radians)
{
	return ((180.0 * radians) / PI);
}

bool cmp(const PDI & a, const PDI & b)
{
	if(fabs(a.first - b.first) < EPS) return (b.second < a.second);
	
	return (a.first < b.first);
}

void process(const point & A, const point & B)
{
double a1 = arg(A);
double a2 = arg(B);
		
	if(a1 < 0.0) a1 += 2.0 * PI;
	if(a2 < 0.0) a2 += 2.0 * PI;
	
	if(a2 < a1)
	{
		a[N ++] = PDI(a1, + 1);
		a[N ++] = PDI(2.0 * PI, - 1);
		
		a[N ++] = PDI(0.0, + 1);
		a[N ++] = PDI(a2, - 1);
	}
	else
	{
		a[N ++] = PDI(a1, + 1);
		a[N ++] = PDI(a2, - 1);
	}
}

void Read()
{
point O, A, B;
	
	cin >> O.X >> O.Y;
	
	cin >> A.X >> A.Y >> B.X >> B.Y;
	
	process(A - O, B - O);
	
	cin >> A.X >> A.Y >> B.X >> B.Y;
	
	process(A - O, B - O);
	
	cin >> A.X >> A.Y >> B.X >> B.Y;
	
	process(A - O, B - O);
}

void Solve()
{
	sort(a, a + N, cmp);
	
	double last = INF, all = 0.0;
	int t = 0;
	
	for(int i = 0; i < N; i ++)
	{
		t += a[i].second;
		
		if(0 < t)
		{
			last = min(last, a[i].first);
		}
		else
		{
			all += a[i].first - last;
			
			last = INF;
		}
	}
	
	ans = all / (2.0 * PI);
	ans *= 100.0;
}

void Write()
{
	printf("%d\n", int(ans + 0.5));
}

int main()
{
	Read();
	
	Solve();
	
	Write();
	
	return 0;
}
