/*
TASK: aminosoup
LANG: C++
*/

#include <iostream>
#include <vector>
#include <ext/numeric>

typedef std :: vector<int> vi;
typedef std :: vector<vi> vvi;

const int MOD = 602214179;

long long N, M;

vvi operator* (const vvi &a, const vvi &b)
{
	vvi res(a.size(), vi(b[0].size(), 0));
	for(int i = 0; i < a.size(); i ++)
		for(int j = 0; j < b[0].size(); j ++)
			for(int k = 0; k < b.size(); k ++)
			{
				long long cur = (long long)a[i][k] * (long long) b[k][j];
				res[i][j] = (res[i][j] + cur % MOD) % MOD;
			}
	return res;
}

int rec(vvi a, int p, int q)
{
	if(p == N)	return 1;
	if(q >= M)
	{
		p += q / M;
		q = 0;
	}
	while( p < N && a[p][q] == 1)
	{
		q ++;
		if(q == M)	q = 0, p ++;
	}
	if(p == N)	return 1;
	int res = 0;
	if( p + 1 < N && a[p + 1][q] == 0 )	
	{
		a[p][q] = a[p + 1][q] = 1;
		res += rec(a, p, q + 1);
		a[p][q] = a[p + 1][q] = 0;
	}
	if( q + 1 < M && a[p][q + 1] == 0)
	{
		a[p][q] = a[p][q + 1] = 1;
		res += rec(a, p, q + 2);
		a[p][q] = a[p][q + 1] = 1;
	}
	return res;
}

int main()
{
	std :: cin >> N >> M;
	if(M > N)	std :: swap(M, N);
	if( (M & 1LL) && (N & 1LL) )
	{
		std :: cout << "0\n";
		return 0;
	}
	if(M == 1)
	{
		std :: cout << 1 - (N % 2LL) << "\n";
		return 0;
	}
	if(M == 2)
	{
		vvi a(2, vi(2));
		a[0][0] = 1; a[0][1] = 1;
		a[1][0] = 1; a[1][1] = 0;
		vvi res = __gnu_cxx :: power(a, N);
		std :: cout << res[0][0] << "\n";
		return 0;
	} 
	if(M == 3)
	{
		vvi a(3, vi(3));
		N /= 2;
		a[0][0] = 3; a[0][1] = 3; a[0][2] = -1;
		a[1][0] = 1; a[1][1] = 0; a[1][2] = 0;
		a[2][0] = 0; a[2][1] = 1; a[2][2] = 0;
		vvi res = __gnu_cxx :: power(a, N);
		std :: cout << res[0][0] - res[2][0] << "\n";
/*		for(int i = 0; i < 3; i ++)
		{
			for(int j = 0; j < 3; j ++)
				std :: cout << res[i][j] << " ";
			std :: cout << "\n";
		} */
		return 0;
	}
	std :: cout << rec(vvi(N, vi(M, 0)), 0, 0) << "\n";
    return 0;
}
