/*
TASK: guard
LANG: C++
*/

#include <cstdio>
#include <cmath>
#include <algorithm>

struct point
{
	int x, y;
};

struct event
{
	double ang;
	int type;
	event(double _ang = 0, int _type = 0): ang(_ang), type(_type){};
};

bool operator< (const event &a, const event &b)
{
	return a.ang < b.ang;
}

point O, g[3][2];
double ang[3][2];
event e[50];
int top = 0;
int main()
{
	scanf("%d %d", &O.x, &O.y);
	for(int i = 0; i < 3; i ++)
	{
		for(int j = 0; j < 2; j ++)
		{
			scanf("%d %d", &g[i][j].x, &g[i][j].y);	
			g[i][j].x -= O.x, g[i][j].y -= O.y;
			ang[i][j] = atan2(g[i][j].y, g[i][j].x);
			if(ang[i][j] < 0)	ang[i][j] += 2*M_PI;
		}
		if( ang[i][1] - ang[i][0] > -1e-9 )
		{
			e[top ++] = event(ang[i][0], 1);
			e[top ++] = event(ang[i][1], -1);
		}
		else
		{
			e[top ++] = event(ang[i][0], 1);
			e[top ++] = event(2*M_PI, -1);
			e[top ++] = event(0., 1);
			e[top ++] = event(ang[i][1], -1);
		}
	}
	std :: sort(e, e + top);
	double a = 0;
	int cnt = 0;
	double prev = 0;
	for(int i = 0; i < top; i ++)
	{
		if(cnt)	a += e[i].ang - prev;
		cnt += e[i].type;
		prev = e[i].ang;
	}
	printf("%d\n", int(100 * a / (2 * M_PI) + .5));
    return 0;
}
