/*
TASK:aminosoup
LANG: C++
*/
#include <iostream>
#include <map>
#include <cstdlib>
using namespace std;

const int mod=602214179;
typedef long long int lii;
typedef unsigned short prof;
lii m, n;
prof mp;
map<lii, lii> P[128][128];
int ok[128][128];

inline int getbit(int a, int n) { int mask=1<<n; return a&mask?1:0; }
inline void setbit(int& a, int n, int v) { int mask=1<<n; a=v?(a|mask):(a&mask); }
inline prof bnot(prof a)
{
  int res=0;
  for(int i=0; i<m; i++) setbit(res, i, getbit(a, i));
  return res;
}
lii d(prof l, prof r, lii i)
{
  if(i==2) return (ok[l][r]?1:0);
  if(i==1) return (l==r?1:0);
  if(P[l][r][i]!=0) 
  {
    if(P[l][r][i]==-1) return 0;
    return P[l][r][i];
  }
  lii res=0; prof k, p;
  for(k=0; k<mp; k++)
    if(i%2==0)
    { res = ( res + d(l, k, i/2+1)*d(k, r, i/2)%mod )%mod; }
    else res = ( res + d(l, k, i/2+1)*d(k, r, i/2+1)%mod )%mod;
  P[l][r][i]=res;
  if(P[l][r][i]==0) P[l][r][i]=-1;
  //cout<<" - "<<l<<' '<<r<<' '<<i<<' '<<P[l][r][i]<<' '<<ok[l][r]<<' '<<res<<endl;
  return res;
}

int is(prof k, int v)
{
  for(int i=0; i<m; i++)
  {
    if(getbit(k, i)==v)
    {
      ++i;
      if(i==m || getbit(k, i)!=v)return 0;
    }
  }
  return 1;
}

int main()
{
  cin>>n>>m;
  mp=1<<m;
  
  prof i, j, k, t;
  for(i=0; i<mp; i++)
    for(j=0; j<mp; j++)
    {
      t=i|j;
      for(k=0; k<m; k++) if( getbit(j, k) && getbit(i, k) ) { ok[i][j]=0; goto nextt; }
      if(is(t, 0)) ok[i][j]=1;
      else ok[i][j]=0;
      nextt: ;
    }
  lii res=d(0, 0, n+1);
  /*
  for(i=0; i<mp; i++) if(is(i, 1))
    for(j=0; j<mp; j++) if(is(j, 0))
      res=(res+d(i, j, n))%mod;
  */
  cout<<res<<endl;
  return 0;
}
