/*
LANG: C++
TASK: aminosoup
*/

#include <cstdio>

#define MOD 602214179

typedef unsigned long long ull;

ull n, m;

bool map[1024][8];
int res = 0;

void rec() {
	int xe, ye;
	for(xe = 0, ye = 0; map[xe][ye];) {
		++xe;
		if(xe == n) {
			xe = 0;
			++ye;
			if(ye == m) {
				++res;
				return;
			}
		}
	}
	if(xe < n-1 && !map[xe+1][ye]) {
		map[xe][ye] = map[xe+1][ye] = 1;
		rec();
		map[xe][ye] = map[xe+1][ye] = 0;
	}
	if(ye < m-1 && !map[xe][ye+1]) {
		map[xe][ye] = map[xe][ye+1] = 1;
		rec();
		map[xe][ye] = map[xe][ye+1] = 0;
	}
}

int find(int _n, int _m) {
	n = _n; m = _m;
	res = 0;
	rec();
	return res;
}

ull prec[20][20] = {
{0,0,0,0,0,0,0,0,0,0,0,0,0},
{0,0,1,0,1,0,1,0,1,0,1,0,1},
{0,1,2,3,5,8,13,21,34,55,89,144,233},
{0,0,3,0,11,0,41,0,153,0,571,0,2131},
{0,1,5,11,36,95,281,781,2245,6336,18061,51205},
{0,0,8,0,95,0,1183,0,14824,0,185921},
{0,1,13,41,281,1183,6728,31529,167089,817991}
};

int main() {
	scanf("%llu%llu", &n, &m);
	if(n%2 && m%2) {
		printf("0\n");
		return 0;
	}
	if(m == 1) {
		printf("0\n");
		return 0;
	}
	if(m == 2) {
		ull a = 1, b = 1, c = 1;
		for(int i = 1; i < n; ++i) {
			c = (a+b)%MOD;
			a = b;
			b = c;
		}
		printf("%llu", c);
		return 0;
	}
	if(n < 20 && m < 20 && prec[n][m]) {
		printf("%llu\n", prec[n][m]);
		return 0;
	}
	printf("%d\n", find(n, m));
	return 0;
}
