/*
TASK: gen
LANG: C++
*/

#include <cstdio>
#include <cstdlib>
#include <climits>
#include <queue>
#include <set>
#include <ctime>
#include <map>

#define LIMIT 10000000

#define set_has(s, k) (s.find(k) != s.end())

using namespace std;

typedef int t;

t gcd(t a, t b) {
	return b == 0 ? a : gcd(b, a%b);
}

struct fr {
	t n, dn;
	fr() { }
	fr(t _n, t _dn) : n(_n), dn(_dn) { }
	inline void cancel() {
		t d = gcd(n, dn);
		n /= d;
		dn /= d;
	}
	inline bool operator == (const fr& a) const {
		return n == a.n && dn == a.dn;
	}
	inline bool operator < (const fr& a) const {
		if(n < a.n) return true;
		if(n == a.n && dn < a.dn) return true;
		return false;
	}
	void print() {
		printf("%d / %d\n", n, dn);
	}
};

inline fr L(fr &f) {
	fr res = fr(2*f.n+f.dn, f.dn);
	res.cancel();
	return res;
}
inline fr R(fr &f) {
	fr res = fr(f.n, f.n+2*f.dn);
	res.cancel();
	return res;
}

#define QS 2097152
struct mqueue {
	fr mem[QS];
	int s, e;
	mqueue() { s = 0; e = 0; }
	bool empty() { return s == e; }
	inline fr& front() {
		return mem[s];
	}
	inline void pop() {
		s = (s+1)%QS;
	}
	inline void push(const fr& f) {
		mem[e] = f;
		e = (e+1)%QS;
	}
};

mqueue bfsq[2]; int cq = 0, ms = 0, ticks = 0;
void bfs(fr start) {
	int level = 1;
	fr cur, n;
	
	bfsq[cq].push(L(start));
	
	bfsq[cq].push(R(start));
	
	while(!bfsq[cq].empty() || !bfsq[cq^1].empty()) {
		if(bfsq[cq].empty()) { cq ^= 1; ++level; }
		
		cur = bfsq[cq].front();
		bfsq[cq].pop();
		
		if(cur == start) {
			printf("%d\n", level);
			exit(0);
		}
		
		n = L(cur);
		if(n.n <= LIMIT && n.dn <= LIMIT){
			bfsq[cq^1].push(n);
		}
		
		n = R(cur);
		if(n.n <= LIMIT && n.dn <= LIMIT) {
			bfsq[cq^1].push(n);
		}
	}
	printf("0\n");
}

int main() {
	t a, b;
	scanf("%d%d", &a, &b);
	if((a+b)%2 == 0) {
		printf("0\n");
		return 0;
	}
	bfs(fr(a, b));
	return 0;
}
