/*
TASK: guard
LANG: C++
*/

#include <cstdio>
#include <cmath>
#include <vector>
#include <utility>
#include <algorithm>

using namespace std;

struct point {
	double x, y;
	point() : x(0), y(0) { }
	point(double _x, double _y) : x(_x), y(_y) { }
	void sub(point &p) { x -= p.x; y -= p.y; }
};

double matan2(double y, double x) {
	double res = 2*M_PI + atan2(y, x);
	if(res >= 2*M_PI) res -= 2*M_PI;
	return res;
}

typedef pair<short, double> psd;

bool cmp(psd a, psd b) {
	if(fabs(a.second - b.second) <= 0.00001)
		return a.first > b.first;
	return a.second < b.second;
}

int main() {
	point ware, ga, gb;
	double a1, a2;
	scanf("%lf%lf", &ware.x, &ware.y);
	vector<psd> events;
	for(int i = 0; i < 3; ++i) {
		scanf("%lf%lf", &ga.x, &ga.y);
		scanf("%lf%lf", &gb.x, &gb.y);
		a1 = matan2(ga.y, ga.x);
		a2 = matan2(gb.y, gb.x);
		if(a1 <= a2) {
			events.push_back(psd(1, a1));
			events.push_back(psd(-1, a2));
		} else {
			events.push_back(psd(1, a2));
			events.push_back(psd(-1, M_PI*2));
			
			events.push_back(psd(1, 0));
			events.push_back(psd(-1, a1));
		}
	}
	sort(events.begin(), events.end(), cmp);
	int status = 0;
	double prev;
	double sum = 0;
	for(int i = 0; i < events.size(); ++i) {
		if(events[i].first == 1) {
			if(status == 0) {
				prev = events[i].second;
			}
			++status;
		} else {
			if(status == 1) {
				sum += events[i].second - prev;
			}
			--status;
		}
	}
	printf("%d\n", (int)(round(sum / M_PI / 2 *100+0.0001)));
	return 0;
}
