/*
TASK: gen
LANG: C++
*/
#include <cstdio>
#include <queue>
#include <map>

using namespace std;

int gcd(int a, int b) {
	if(a % b == 0)
		return b;
	return gcd(b, a%b);
}

struct fract {
	int p, q;
	
	fract(){}
	fract(int _p, int _q) : p(_p), q(_q){}
	bool operator== (fract a) {
		return (a.p == p) && (a.q == q);
	}
	void defract() {
		int x = gcd(p, q);
		p /= x;
		q /= x;
	}
};


bool operator< (fract a, fract b) {
	return ((double)a.p/a.q < (double)b.p/b.q);
}

fract x, fr, f;
queue <fract> q[2];
int r = 0, w = 1;
map <fract, bool> used;
int lev = 1;
int c;

int main() {
	scanf("%d%d", &x.p, &x.q);
	c = x.p + x.q;
	
	q[0].push(x);
	
	while(true) {
		if(q[r].empty()) {
			if(q[w].empty()) {
				break;
			}
			r ^= 1;
			w ^= 1;
			++lev;
		}
		fr = q[r].front(), f = fract((fr.p << 1) + fr.q, fr.q);
		//printf("%lld %lld\n", fr.p, fr.q);
		f.defract();
		if(!used[f]) {
			if(f == x) {
				printf("%d\n", lev);
				return 0;
			}
			if(f.q + f.p == c) {
				q[w].push(f);
				used[f] = 1;
			}
		}
		f = fract(fr.p, fr.p + (fr.q << 1));
		f.defract();
		if(!used[f]) {
			if(f == x) {
				printf("%d\n", lev);
				return 0;
			}
			if(f.q + f.p == c) {
				q[w].push(f);
				used[f] = 1;
			}
		}
		
		q[r].pop();
	}
	
	printf("0\n");

	return 0;
}
