/*
TASK: aminosoup
LANG: C++
*/
#include <cstdio>

const int MAXM = 6;
const int MOD = 602214179;

typedef long long ll;

ll n;
int m;
int a[1 << MAXM][1 << MAXM];
int b[1 << MAXM][1 << MAXM];

int s[1 << MAXM] , snew[1 << MAXM];
int f[1 << MAXM][1 << MAXM];

void read() {
	scanf ( "%lld%d" , &n , &m );
}

inline void add ( int &x , int y ) {
	x += y;
	if ( x > MOD ) x -= MOD;
}

inline int mul ( int x , int y ) {
	return (int)(((ll)x * (ll)y) % (ll)MOD);
}

void init() {
	int i , j , k;
	
	f[ (1 << m) - 1][0] = 1;

	for (i = (1 << m) - 2; i >= 0; i--)
		for (j = 0; j < (1 << m); j++) {
			for (k = 0; k < m; k++)
				if ( !(i & (1 << k)) )
					break;
					
			if ( j & (1 << k) )
				add ( f[i][j] , f[ i ^ (1 << k) ][ j ^ (1 << k) ] );
			if ( k < m - 1 && !(i & (1 << (k + 1))) )
				add ( f[i][j] , f[ i ^ (1 << k) ^ (1 << (k + 1)) ][j] );
		}
}

void slow() {
	int i , j , k;
	s[0] = 1;
	
	for (i = 0; i < (1 << m); i++)
		for (j = 0; j < (1 << m); j++)
			a[i][j] = f[i][j];
	
	while ( n -- ) {
		for (i = 0; i < (1 << m); i++)
			for (j = 0; j < (1 << m); j++) {
				b[i][j] = 0;
				
				for (k = 0; k < (1 << m); k++)
					add ( b[i][j] , mul ( a[i][k] , f[k][j] ) );
			}
			
		for (i = 0; i < (1 << m); i++)
			for (j = 0; j < (1 << m); j++)
				a[i][j] = b[i][j];
		
		for (i = 0; i < (1 << m); i++) snew[i] = 0;
		
		for (i = 0; i < (1 << m); i++)
			for (j = 0; j < (1 << m); j++)
				add ( snew[j] , mul ( s[i] , f[i][j] ) );
				
		for (i = 0; i < (1 << m); i++)
			s[i] = snew[i];
	}
	
	for (i = 0; i < (1 << m); i++) {
		for (j = 0; j < (1 << m); j++)
			printf ( "%d " , a[i][j] );
			
		printf ( "\n" );
	}
	
	printf ( "%d\n" , snew[ (1 << m) - 1 ] );
}

void get() {
	int i , j;
	
	for (i = 0; i < (1 << m); i++)
		for (j = 0; j < (1 << m); j++)
			a[i][j] = b[i][j];
}

void solve() {
	int i , j , k;
	ll d;
	
	n += 2;
	for (d = 1; ; d <<= 1LL)
		if ( (n ^ d) < d ) 
			break;
			
	for (i = 0; i < (1 << m); i++)
		for (j = 0; j < (1 << m); j++)
			a[i][j] = f[i][j];
			
	while ( d > 0 ) {
		if ( n & d && (n ^ d) > d ) {
			for (i = 0; i < (1 << m); i++)
				for (j = 0; j < (1 << m); j++)
					b[i][j] = 0;
					
			for (i = 0; i < (1 << m); i++)
				for (j = 0; j < (1 << m); j++)
					for (k = 0; k < (1 << m); k++)
						add ( b[i][j] , mul ( a[i][k] , (ll)f[k][j] ) );
				
			get();
		}
		
		if ( d == 1 ) break ;
		for (i = 0; i < (1 << m); i++)
				for (j = 0; j < (1 << m); j++)
					b[i][j] = 0;
					
		for (i = 0; i < (1 << m); i++)
			for (j = 0; j < (1 << m); j++)
				for (k = 0; k < (1 << m); k++)
					add ( b[i][j] , mul ( a[i][k] , (ll)a[k][j] ) );
		
		get();
		
		d >>= 1LL;
	}
		
	printf ( "%d\n" , a[ (1 << m) - 1 ][ (1 << m) - 1 ] ); 
}

int main() {
	read();
	init();
//	slow();
	solve();
	
	return 0;
}
