/*
TASK: gen
LANG: c++
*/

#include <iostream>
#include <cmath>
using namespace std;
struct frac{
	long long  num;
	long long denom;

};
frac start;
int MaxSteps = 18;
long long gcd(long long a,long long  b){
	return (b == 0 ? a : gcd(b,a%b));
}
/*
long long abs(long long _X){
	if(_X < 0 )
		return -_X;
	return _X;
}*/
bool operator==(frac &a,frac &b){
	if(a.num == b.num && a.denom == b.denom){
		return true;
	}else{
		return false;
	}
}

frac makeL(frac x){
	frac r;
	r.num = (2*x.num + x.denom);
	r.denom = x.denom;
	long long d = gcd(r.num, r.denom);
	r.num /=d;
	r.denom /= d;
	return r;
}

frac makeR(frac  x){
	frac r;
	r.num = x.num;
	r.denom = x.num + 2*x.denom;
	long long  d = gcd(r.num, r.denom);
	r.num /=d;
	r.denom /= d;
	return r;
}

ostream &operator<<(ostream &os, frac &b){
	long long d = gcd(b.num,b.denom);
	return os << b.num/d <<'/'<<b.denom/d;
}

frac inverse(frac a){
	swap(a.num,a.denom);
	return a;
}

frac abs(frac a){
	a.num = abs(a.num);
	a.denom = abs(a.denom);
	return a;
}

frac operator-(frac &a,frac &b){
	frac r;
	r.num = a.num * b.denom - b.num * a.denom ;
	r.denom = a.denom * b.denom;
	long long d = gcd(r.num, r.denom);
	r.num /=d;
	r.denom /= d;
	return r;

}

bool operator<(frac &a,frac &b){
	if(a.num * b.denom < b.num * a.denom){
		return true;
	}else{
		return false;
	}
}
void makestep(frac a,int step = 0){
	if(step >= MaxSteps){
		return;
	}
	if(step > 0 && a == start){
		MaxSteps=step;
		return;
	}
	frac L = makeL(a);
	frac R = makeR(a);
	if( a.denom != start.denom ){
		makestep(L,step + 1);
	}
	if( a.num != start.num ){
		makestep(R,step + 1);
	}
}

int main(void){
	frac t;
	cin >> t.num >> t.denom;
	if(t.num > t.denom ){
		swap(t.num,t.denom);
	}
//	cout << t << endl;
	start = inverse(t);	
	makestep(t);
	cout << 2*MaxSteps << endl;
	//cout << makeL(start) << endl;
	return 0;
}
