/*
TASK: guard
LANG: C++
*/
#include <cmath>
#include <cstdio>
#include <algorithm>

using namespace std;

const int NUM = 3<<1;
const double L = 2*M_PI;

typedef struct {
        int x, y;
        } wtf;

typedef struct {
        double f;
        int num;
        } PHI;

wtf mas[NUM];

int xo, yo;
int cnt[NUM+1];
PHI phi[NUM+1];

void init (void) {
     scanf("%d%d", &xo, &yo);
     for (int i = 0; i < NUM; ++i)
         scanf("%d%d", &mas[i].x, &mas[i].y);
     }

int D (int xa, int ya, int xb, int yb, int xc, int yc) {
    int ret;
    ret = (xa*yb + ya*xc + xb*yc);
    ret -= (xa*yc + yb*xc + ya*xb);
    return ret;
}

double __phi (double fi, int xa, int ya, int xb, int yb, int xc, int yc) {
       int det = D(xa,ya,xb,yb,xc,yc);
       if (det<0) return L-fi;
       if (det>0) return fi;
       }

double _phi (int x, int y) {
       double fi;
       int a = 200*200, b, c, dx, dy;
       if (x==xo) if (y>yo) return M_PI_2;
                  else return 3*M_PI_2;
       if (y==yo) if (x>xo) return 0.0;
          else return M_PI;
       
       dx = xo-x; dy = yo-y; b = dx*dx + dy*dy;
       dx = 200-x; dy = y; c = dx*dx + dy*dy;
       fi = (a+b-c)/2.0; fi /= (double)sqrt(a*b);
       fi = acos(fi);
       //printf("a=%d b=%d c=%d\n", a, b, c);
       fi = __phi(fi,xo,yo,200,0,x,y);
       
       return fi;
}

bool cmp (PHI a, PHI b) {
     return a.f<=b.f;
     }

void solve (void) {
     for (int i = 0; i < NUM; ++i) {
         phi[i].f = _phi(mas[i].x,mas[i].y);
         phi[i].num = i;
         //printf("%lf\n", 180.0*phi[i].f/M_PI);
         }
     
     sort(phi,phi+NUM,cmp);
     phi[NUM]=phi[0];
     /*
     for (int i = 0; i <= NUM; ++i)
         printf("%.2lf %d\n", 180.0*phi[i].f/M_PI, phi[i].num);
     */
     int k, j, t;
     for (int i = 0; i < NUM; ++i) {
         if (phi[i].num%2) continue;
         k = phi[i].num+1;
         for (j = i; j <= NUM; ++j) {
             if (phi[j].num == k) {
                            t = j-1;
                            for (; phi[j].f==phi[t].f; ++j) cnt[j]++;
                            break;
                            }
             cnt[j]++;
             }
         if (phi[j].num != k)
            for (j=0; j < i; ++j) {
                if (phi[j].num == k) {
                               t = j-1;
                               for (; phi[j].f==phi[t].f; ++j) cnt[j]++;
                               break;
                               }
                cnt[j]++;
                }
         }
     
     double p = L;
     //printf("%d\n", cnt[0]);
     for (int i = 1; i < NUM; ++i) {
         //printf("%d\n", cnt[i]);
         if (!cnt[i]) p-=(phi[i].f-phi[i-1].f);
         }
     p = p/L; p*=100;
     
     int ans=(int)p;
     if (p-(int)p==0.5) ans++;
     printf("%d\n", ans);
     }

int main()
{
    init();
    solve();
    
return 0;
}
