/*
LANG: C++
TASK: aminosoup
*/
#include <iostream>
#define MOD 602214179
using namespace std;

long long N;
int M;
int three[7] = {1, 3, 9, 27, 81, 243, 243*3};
int size0[1<<6][1<<6], size1[1<<6][1<<6];
int DP[100][1<<6][1<<6];

bool bit(int m, int i)
{
    return m&(1<<i);
}
bool check(int m)
{
     for (int i = 0; i < M; i++)
      if (bit(m, i)==0)
      {
          if (i == M-1 || bit(m,i+1)) return 0;
          i++;
      }
     return 1;
}

int getNexts(int mask1, int* path)
{
     int sz = 0;
     for (int mask = 0; mask < (1<<M); mask++)
     {
         int m = 0;
         
         bool flag = 1;
         for (int i = 0; i < M; i++)
          if (bit(mask1, i))
          {
               if (bit(mask, i)) { flag = 0; break; }
          }
          else
          {
               if (bit(mask, i))
               {
                    if (i==M-1 || bit(mask, i+1) || bit(mask1, i + 1)) { flag = 0; break; }
                    i++;
               }
               else
               {
                    m ^= (1<<i);
               }
          }
         if (flag) path[sz++] = m;
     }
     return sz;
}

int Size0(int mask1, int mask2)
{
         if (size0[mask1][mask2] != -1) return size0[mask1][mask2];
         
         int ans = 0;
         for (int mask = 0; mask < (1<<M); mask++) 
         {
             int m1 = mask1, m2 = mask2, flag = 1;
             for (int i = 0; i < M; i++) 
              if (bit(m1, i)) 
              { 
                   if (bit(mask, i)) {flag = 0; break;} 
                   continue; 
              }
              else 
              {
                   if (bit(mask, i)==0) 
                   {
                        if (  bit(m1, i) || i == M-1 || bit(m1, i+1)
                              || bit(mask, i+1)) {flag = 0; break; }
                        i++;
                   }
                   else
                   {
                       if (bit(m2, i)) { flag = 0; break; }
                       m2 |= 1<<i;
                   }
              }
              
            ans += flag && check(m2);
         }
         
         return size0[mask1][mask2] = ans;    
}

int Size1(int mask1, int mask2)
{
          if (size1[mask1][mask2] != -1) return size1[mask1][mask2];
              
          int ans = 0;
          for (int q = 0; q < three[M]; q++)
          {
              
              int midmask = q;
              int flag = 1, m1 = mask1, m2 = mask2;
              for (int i = 0; i < M; i++)
              {
                  int t = midmask%3; midmask /= 3;
                  if (t == 0) 
                  {
                        if (midmask%3 != 0 || i == M-1) { flag = 0; break; }
                        midmask /= 3;
                        i++;
                  }
                  if (t == 1) if (bit(m1, i)) { flag = 0; break; }
                              else m1 |= 1<<i;
                  if (t == 2) if (bit(m2, i)) { flag = 0; break; }
                              else m2 |= 1<<i;
              }   
              ans += (flag && check(m1) && check(m2));
          }
          return size1[mask1][mask2] = ans;
}

int f (long long size, int mask1, int mask2, int lvl)
{
    
    //if (lvl == 98) cout << mask1 << " " << mask2 << endl;
    if (DP[lvl][mask1][mask2] != -1) return DP[lvl][mask1][mask2];
    
    if (size == 0)
     return Size0(mask1, mask2);
     
    if (size == 1)
     return Size1(mask1, mask2);
    
    int path[1<<6];
     
    int sz;
    if (size%2)
     sz = getNexts(mask2, path), size--;
    else
     sz = 1, path[0] = mask2;
    
    int savemask2 = mask2;
    int ans = 0;
    for (int i = 0; i < sz; i++)
    {
        mask2 = path[i];
        
        for (int mask = 0; mask < (1<<M); mask++)
         ans = ((long long)ans + (long long)f(size/2 - 1, mask1, mask, lvl-1)*
                f(size/2 - 1, mask, mask2, lvl-1))%MOD;
    }
    return DP[lvl][mask1][savemask2] = ans;
}
int main()
{
    memset(DP, -1, sizeof(DP));
    memset(size0, -1, sizeof(size0));
    memset(size1, -1, sizeof(size1));
    
    cin >> N >> M;
    cout << f(N-2, 0, 0, 99) << endl;
    //system("pause");
    return 0;   
}
