/*
TASK:cube
LANG:C++
*/
#include <iostream>
#include <queue>
#include <stack>
#include <string>
#define FIG 1
#define STR 2
#define END 3
#define BND 4
#define FRONT 1
#define BACK 2
#define LEFT 3
#define RIGHT 4
#define TOP 5
#define BOTTOM 6
using namespace std;

struct coord { int x, y; };
int a[10][10]; //reverse
bool used[9][9];
coord prev[9][9];
int sx, sy, ex, ey;
int otpr, otzd, otlv, otds, otdo, otgo;

void init_map()
 {
  for(int i=0; i<=8; i++) a[i][0]=a[0][i]=a[i][9]=a[9][i]=BND;
 }

class cube
 {
  public:
  int frontside;
  int backside;
  int topside;
  int bottomside;
  int leftside;
  int rightside;
  cube() { frontside=FRONT; backside=BACK; topside=TOP; bottomside=BOTTOM; leftside=LEFT; rightside=RIGHT; }
  void rotate(string how);
 };
void cube::rotate(string how)
 {
  if(how=="ix+1")
   {
    cube tmp;
    tmp.bottomside=backside;
    tmp.backside=topside;
    tmp.topside=frontside;
    tmp.frontside=bottomside;
    bottomside=tmp.bottomside;
    backside=tmp.backside;
    topside=tmp.topside;
    frontside=tmp.frontside;
   }
  if(how=="ix-1")
   {
    cube tmp;
    tmp.bottomside=frontside;
    tmp.frontside=topside;
    tmp.topside=backside;
    tmp.backside=bottomside;
    frontside=tmp.frontside;
    topside=tmp.topside;
    backside=tmp.backside;
    bottomside=tmp.bottomside;
   }
  if(how=="iy+1")
   {
    cube tmp;
    tmp.bottomside=rightside;
    tmp.rightside=topside;
    tmp.topside=leftside;
    tmp.leftside=bottomside;
    rightside=tmp.rightside;
    topside=tmp.topside;
    leftside=tmp.leftside;
    bottomside=tmp.bottomside;
   }
  if(how=="iy-1")
   {
    cube tmp;
    tmp.bottomside=leftside;
    tmp.leftside=topside;
    tmp.topside=rightside;
    tmp.rightside=bottomside;
    leftside=tmp.leftside;
    topside=tmp.topside;
    rightside=tmp.rightside;
    bottomside=tmp.bottomside;
   }
 }


int transf(string how, cube &cub)
 {
  cub.rotate(how);
  if(cub.bottomside==BOTTOM) return otdo;
  if(cub.bottomside==TOP) return otgo;
  if(cub.bottomside==FRONT) return otpr;
  if(cub.bottomside==BACK) return otzd;
  if(cub.bottomside==LEFT) return otlv;
  if(cub.bottomside==RIGHT) return otds;
 }

void d_matrix()
 {
  //init_map();
  queue <int> x, y;
  used[sx][sy]=1;
  x.push(sx); y.push(sy);
  int ix, iy;
  coord t;
  while(!x.empty())
   {
    ix=x.front(); iy=y.front();
    t.x=ix; t.y=iy;
    if(ix==ex && iy==ey) break;
    if(a[ix+1][iy]!=FIG && !used[ix+1][iy] && ix+1<=8) { x.push(ix+1); y.push(iy); used[ix+1][iy]=1; prev[ix+1][iy]=t; }
    if(a[ix-1][iy]!=FIG && !used[ix-1][iy] && ix-1>=1) { x.push(ix-1); y.push(iy); used[ix-1][iy]=1; prev[ix-1][iy]=t; }
    if(a[ix][iy+1]!=FIG && !used[ix][iy+1] && iy+1<=8) { x.push(ix); y.push(iy+1); used[ix][iy+1]=1; prev[ix][iy+1]=t; }
    if(a[ix][iy-1]!=FIG && !used[ix][iy-1] && iy-1>=0) { x.push(ix); y.push(iy-1); used[ix][iy-1]=1; prev[ix][iy-1]=t; }
    x.pop(); y.pop();
   }
  //system("pause");
  stack <int> revx, revy;
  ix=ex; iy=ey; int ox, oy;
  /*cout<<ix<<" "<<iy<<endl;
  cout<<prev[ix][iy].x<<" "<<prev[ix][iy].y<<endl;
  cout<<prev[prev[ix][iy].x][prev[ix][iy].y].x<<" "<<prev[prev[ix][iy].x][prev[ix][iy].y].y<<endl;
  int x1=prev[prev[ix][iy].x][prev[ix][iy].y].x;
  int y1=prev[prev[ix][iy].x][prev[ix][iy].y].y;
  cout<<prev[x1][y1].x<<" "<<prev[x1][y1].y<<endl;
  int ox1=prev[x1][y1].x;
  int oy1=prev[x1][y1].y;
  cout<<ox1<<" "<<oy1<<endl;
  cout<<prev[ox1][oy1].x<<" "<<prev[ox1][oy1].y<<endl;
  cout<<used[5][3]<<endl;
  system("pause");*/
  while(ix!=sx || iy!=sy)
   {
    revx.push(ix);
    revy.push(iy);
    ox=ix; oy=iy;
    ix=prev[ox][oy].x;
    iy=prev[ox][oy].y;
   }
  int jx, jy;
  ix=revx.top(); iy=revy.top();
  revx.pop(); revy.pop();
  int sum=0;
  sum+=otdo;
  cube cub;
  while(!revx.empty())
   {
    jx=revx.top();
    jy=revy.top();
    if(jx==ix-1) sum+=transf("ix-1", cub);
    else if(jx==ix+1) sum+=transf("ix+1", cub);
    else if(jy==iy-1) sum+=transf("iy-1", cub);
    else if(jy==iy+1) sum+=transf("iy+1", cub);
    ix=jx; iy=jy;
    revx.pop(); revy.pop();
   }
  cout<<sum<<endl;
    
 }

void tr(char &c)
 {
  switch(c)
   {
    case 1: c=8; break;
    case 2: c=7; break;
    case 3: c=6; break;
    case 4: c=5; break;
    case 5: c=4; break;
    case 6: c=3; break;
    case 7: c=2; break;
    case 8: c=1;
   }
 }

int main()
 {
  char c; int t, n;
  cin>>c>>t;
  c-='a';
  c++;
  tr(c);
  a[t][(int)c]=STR;
  sx=t; sy=c;
  cin>>c>>t;
  c-='a';
  c++;
  tr(c);
  a[t][(int)c]=END;
  cin>>otpr>>otzd>>otgo>>otds>>otdo>>otlv;
  ex=t; ey=c; //x-row,y-column
  cin>>n;
  for(int i=1; i<=n; i++)
   {
    cin>>c>>t;
    c-='a';
    c++;
    a[t][(int)c]=FIG;
   }
  d_matrix();
    
  return 0;
 }
