/*
TASK:cube
LANG:C++
*/
#include <iostream>
#include <queue>
using namespace std;

struct point
{
       int x,y;
};

struct cube
{
       int front,back,up,right,down,left;
};

cube rot(cube x,int pos)
{
     cube k;
     if(pos==1)
     {
               k.front=x.front;
               k.back=x.back;
               k.up=x.left;
               k.right=x.up;
               k.down=x.right;
               k.left=x.down;
               
               return k;
     }
     if(pos==2)
     {
               k.front=x.front;
               k.back=x.back;
               k.up=x.right;
               k.right=x.down;
               k.down=x.left;
               k.left=x.up;
               
               return k;
     }
     if(pos==3)
     {
               k.front=x.down;
               k.back=x.up;
               k.up=x.front;
               k.right=x.right;
               k.down=x.back;
               k.left=x.left;
               
               return k;
     }
     if(pos==4)
     {
               k.front=x.up;
               k.back=x.down;
               k.up=x.back;
               k.right=x.right;
               k.down=x.front;
               k.left=x.left;
               
               return k;
     }
}

struct el
{
       cube cub;
       point p;
} push;

int d[8][8];
int level[8][8];
int m[8][8];

void bfs(cube k,int x,int y)
{
     push.cub=k;
     push.p.x=x; push.p.y=y;
     queue<el> q;
     q.push(push);
     
     while(!q.empty())
     {
                      int lvl=level[q.front().p.x][q.front().p.y];
                      cube c;
                      int a,b;
                      
                      c=q.front().cub;
                      a=q.front().p.x; b=q.front().p.y;
                      c=rot(c,1); b++;
                      if(b<8)
                      {
                             if(m[a][b]!=1) {
                             if(level[a][b]) { d[a][b]=min(d[a][b],d[q.front().p.x][q.front().p.y]+c.down); }
                             else
                             {
                                 level[a][b]=lvl+1;
                                 d[a][b]=d[q.front().p.x][q.front().p.y]+c.down;
                                 push.cub=c;
                                 push.p.x=a; push.p.y=b;
                                 q.push(push);
                             } }
                      }
                      
                      c=q.front().cub;
                      a=q.front().p.x; b=q.front().p.y;
                      c=rot(c,2); b--;
                      if(b>=0)
                      {
                             if(m[a][b]!=1) {
                             if(level[a][b]) { d[a][b]=min(d[a][b],d[q.front().p.x][q.front().p.y]+c.down); }
                             else
                             {
                                 level[a][b]=lvl+1;
                                 d[a][b]=d[q.front().p.x][q.front().p.y]+c.down;
                                 push.cub=c;
                                 push.p.x=a; push.p.y=b;
                                 q.push(push);
                             } }
                      }
                      
                      c=q.front().cub;
                      a=q.front().p.x; b=q.front().p.y;
                      c=rot(c,3); a--;
                      if(a>=0)
                      {
                             if(m[a][b]!=1) {
                             if(level[a][b]) { d[a][b]=min(d[a][b],d[q.front().p.x][q.front().p.y]+c.down); }
                             else
                             {
                                 level[a][b]=lvl+1;
                                 d[a][b]=d[q.front().p.x][q.front().p.y]+c.down;
                                 push.cub=c;
                                 push.p.x=a; push.p.y=b;
                                 q.push(push);
                             } }
                      }
                      
                      c=q.front().cub;
                      a=q.front().p.x; b=q.front().p.y;
                      c=rot(c,4); a++;
                      if(a<8)
                      {
                             if(m[a][b]!=1) {
                             if(level[a][b]) { d[a][b]=min(d[a][b],d[q.front().p.x][q.front().p.y]+c.down); }
                             else
                             {
                                 level[a][b]=lvl+1;
                                 d[a][b]=d[q.front().p.x][q.front().p.y]+c.down;
                                 push.cub=c;
                                 push.p.x=a; push.p.y=b;
                                 q.push(push);
                             } }
                      }
                      
                      q.pop();
     }
}

int main()
{
    int fx,fy;
    int sx,sy;
    cube c;
    string s;
    cin >> s; sx=8-(s[1]-'0'); sy=s[0]-'a';
    cin >> s; fx=8-(s[1]-'0'); fy=s[0]-'a';
    cin >> c.front >> c.back >> c.up >> c.right >> c.down >> c.left;
    int n;
    cin >> n;
    for(int i=0;i<n;i++)
    {
            cin.get();
            cin >> s;
            int x,y;
            x=8-(s[1]-'0'); y=s[0]-'a';
            m[x][y]=1;
    }
    
    level[sx][sy]=1;
    bfs(c,sx,sy);
    
    cout << d[fx][fy] << endl;
    
    return 0;
}
