#include <stdio.h>
#include <algorithm>
using namespace std;

struct Vertex
{
       int l, r;
       int longestleft, longestright;
       int maxlongest;
       int tleft, tright;
       
       int leftchild, rightchild; 
       bool flag;
       
       int size() { return r - l + 1; }
} nodes[200000];
int cnt = 0;
int N;

int construct(int l, int r)
{
    int save = cnt++;
    Vertex* t = &nodes[save];
    t->l = l, t->r = r;
    t->longestleft = t->longestright = 1;
    t->maxlongest = 1;
    t->tleft = t->tright = 0;
    t->flag = 0;
    
    if (l != r)
    {
          t->leftchild = construct(l, (l+r)/2);
          t->rightchild = construct((l+r)/2+1, r);
    }
    else
    {
          t->leftchild = -1;
          t->rightchild = -1;
    }
    return save;
}

void change(int, int, int);

void reduce(int k)
{
     Vertex* t = &nodes[k];
     if (t->flag == 0) return;
     
     change(t->l, (t->l+t->r)/2, t->leftchild);
     change((t->l+t->r)/2+1, t->r, t->rightchild);
     t->flag = 0;
}

void change(int l, int r, int k)
{
    Vertex* t = &nodes[k];
    if (t->r < l || t->l > r) return;
    
    if (t->l >= l && t->r <= r) 
    {
             t->flag ^= 1;
             t->tleft ^= 1;
             t->tright ^= 1;
    }   
    else
    {
             reduce(k);
             
             change(l, r, t->leftchild);
             change(l, r, t->rightchild);
             
             Vertex *tl = &nodes[t->leftchild], *tr = &nodes[t->rightchild];
             t->maxlongest = 1;
             
             t->tleft = tl->tleft;
             t->tright = tr->tright;
             
             if (tl->longestleft == tl->size() && tl->tright != tr->tleft) t->longestleft = tl->size() + tr->longestleft;
             else t->longestleft = tl->longestleft;
             
             if (tr->longestright == tr->size() && tl->tright != tr->tleft) t->longestright = tr->size() + tl->longestright;
             else t->longestright = tr->longestright;
             
             t->maxlongest = max(tl->maxlongest, tr->maxlongest);
             if (tl->tright != tr->tleft) t->maxlongest = max(t->maxlongest, tl->longestright + tr->longestleft);
             t->maxlongest = max(t->maxlongest, max(t->longestleft, t->longestright));
             t->maxlongest = max(t->maxlongest, max(tl->maxlongest, tr->maxlongest));
    }
}

void print(int k)
{
     Vertex *t = &nodes[k];
     printf("********\n\nends: %d %d\n", t->l, t->r);
     printf("type: %d %d\n", t->tleft, t->tright);
     printf("sides len: %d %d\n", t->longestleft, t->longestright);
     printf("maxlongest: %d\n", t->maxlongest);
     printf("flag: %d\n", t->flag);
     
     if (t->leftchild != -1) print(t->leftchild), print(t->rightchild);
     return;
}

int query()
{
    return nodes[0].maxlongest;
}

int main()
{
    
    int Q;
    scanf("%d%d\n", &N, &Q);
    construct(0, N-1);
    //print(0);
    for (int i = 0; i < Q; i++)
    {
        char a;
        scanf("%c", &a);
        //printf("%c\n", a);
        if (a == 'c')
        {
              int l, r;
              scanf("%d%d\n", &l, &r);
              change(l, r, 0);
        }
        else { printf("%d\n", query()); scanf("\n"); }
    }
    //printf("%d\n", query());
    //print(0);
    
    return 0;
}
