#include <cstdio>
#include <algorithm>
#include <set>
using namespace std;

const int MAX_N = 100001;

int m, n;
pair<int,int> A[2*MAX_N];	// pair<coordinate, time> for every beginning and ending points;
set<int> S;					// set of currently crossing segment by the sweep line ordered by installation time:
bool H[MAX_N];				// is the segment hidden by other OS
int ans;

void input ()
{
	int i, k=0;

	scanf("%d%d", &m, &n);

	for (i=1; i<=n; i++) {
		scanf ("%d", &A[k].first);
		A[k++].second = -i;					// negative installation time for the beginning points
		scanf ("%d", &A[k].first);
		A[k++].second = i;
	}
}

void solve ()
{
	int i, t;

	sort(A, A+2*n);							// by coordinates (if equal coordinates - the beginning point first):
											// the sweep-line is moving in this order
	S.insert(0);							// fictive segment - the sweep-line is always crossing at least it
	
	for (i=0; i<2*n; i++) {
		t = A[i].second;					// the number/time of the current segment
		if (t<0) {							// if A[i] is a beginning point
			H[ min(*S.rbegin(),-t) ] = 1;	// either (the current segment is hiding the newest one)
											//     or (the current segment comes hidden by a newer)
			S.insert(-t); 
		} else {
			ans += (H[t]==0);				// if we reached the ending point and it is not hidden
			S.erase(t);
		}
	}
}

int main()
{
	input ();
	solve ();

	printf("%d\n", ans);

	return 0;
}
