import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Map;
import java.util.StringTokenizer;

/**
 * CTU Open Contest 2008
 * Solution for the problem: CONTEST.
 * October, 2008
 *
 * @author Martin Kacer
 */
public class contest {
	static final String ACN_NOTEX = "0666/8";
	static final String ACN_DEPO = "1234/5";
	static final String ACN_FULL = "9876/5";
	static final String ACN_IBANK = "4444/4";
	static final String ACN_EMPTY = "1111/5";
	static final int VAL_MAX = 10000 * 100 * 1100;
	static final int VAL_EMPTY = 314;

	static abstract class Command {abstract boolean go();}
	int last = 1000;

	Map<String,Command> cmd = new HashMap<String,Command>();
	{
		cmd.put("create:", new Command() { boolean go() {
			String r = restLine();
			if (r.charAt(0) == 'o') {
				System.out.println("create " + (last++) + "/1");
			} else {
				System.out.println("create " + ACN_DEPO);
			}
			return true;
		}});
		cmd.put("deposit", new Command() { boolean go() {
			int v = fromString(nextToken());
			String r = restLine();
			System.out.println("deposit "
					+ (r.charAt(0) == 'o' ? ACN_DEPO : ACN_NOTEX)
					+ ' ' + makeString(v));
			return true;
		}});
		cmd.put("withdraw", new Command() { boolean go() {
			int v = fromString(nextToken());
			String r = restLine();
			System.out.println("withdraw "
					+ (r.charAt(0) == 'o' ? ACN_FULL :
					r.charAt(0) == 'i' ? ACN_EMPTY : ACN_NOTEX)
					+ ' ' + makeString(v));
			return true;
		}});
		cmd.put("transfer", new Command() { boolean go() {
			int v = fromString(nextToken());
			String r = restLine();
			System.out.println("transfer "
					+ (r.charAt(0) == 's' ? ACN_FULL + ' ' + ACN_FULL
					: r.charAt(0) == 'o' ? ACN_FULL + ' ' + ACN_DEPO
					: r.charAt(0) == 'n' ? ACN_NOTEX + ' ' + ACN_DEPO
					: r.charAt(2) == 't' ? ACN_FULL + ' ' + ACN_IBANK
					: ACN_EMPTY + ' ' + ACN_DEPO)
					+ ' ' + makeString(v));
			return true;
		}});
		cmd.put("end", new Command() { boolean go() {
			System.out.println("end");
			System.out.println();
			return false;
		}});
	}

	boolean run() throws Exception {
		Command c = cmd.get(nextToken());
		if (c == null) return false;
		last = 1000;
		System.out.println("4");
		System.out.println(ACN_DEPO + ' ' + makeString(VAL_EMPTY));
		System.out.println(ACN_FULL + ' ' + makeString(VAL_MAX));
		System.out.println(ACN_IBANK + ' ' + makeString(VAL_EMPTY));
		System.out.println(ACN_EMPTY + ' ' + makeString(0));
		for (;;) {
			if (!c.go()) return true;
			c = cmd.get(nextToken());
		}
	}

	int fromString(String s) {
		return Integer.parseInt(s.replaceAll("[.:]", ""));
	}

	String makeString(int a) {
		int x = a%100;
		return a/100 + (x < 10 ? ".0" : ".") + x;
	}

	public static void main(String[] args) throws Exception {
		contest inst = new contest();
		while (inst.run()) {}
		System.out.println(-1);
	}

	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));

	String nextToken() {
		try {
			while (!st.hasMoreTokens()) st = new StringTokenizer(input.readLine());
		} catch (IOException ex) {
			throw new RuntimeException(ex);
		}
		return st.nextToken();
	}

	String restLine() {
		String s = st.nextToken();
		while (st.hasMoreTokens()) s += ' ' + st.nextToken();
		return s;
	}

	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
}
