import java.io.*;
import java.lang.Math;

/*
 * CTU Open Contest 2008
 * Solution: DECLARE
 * Jan Stoklasa, Oct 2008  
 */   

class declare
{

	public static void main(String argv[]) throws IOException
	{
	    BufferedReader stdin=new BufferedReader(new InputStreamReader(System.in));	
	    String s1,s2;
	    while((s1=stdin.readLine())!=null &&
		  (s2=stdin.readLine())!=null &&
		  s1.trim()!=".")
		{
		    solve(s1,s2);
		}
	}

    /*
    static String [] test(int N)
    {
	java.util.Random r=new java.util.Random();
	String words[]=new String[N];
	for(int i=0;i<N;i++)
	    {
		words[i]=Integer.toString(r.nextInt(1000));
	    }	
	return words;
    }
    */


        private static void solve(String line1,String line2)
        {
	    String words1[]=line1.split(" ");
	    String words2[]=line2.split(" ");
	
	    int M=words1.length-1;  //ignore trailing dot
	    int N=words2.length-1;

	    // sup[i][j] - length of optimal supersequence of (words1[i],..,words1[M]) and (words2[j],..,words2[N])
	    int sup[][] = new int[M+1][N+1];

	    for(int i=0;i<=M;i++)		
	    {
		sup[i][N]=M-i;
	    }
	    for(int j=0;j<=N;j++)
	    {
		sup[M][j]=N-j;
	    }
	    for(int i=M-1;i>=0;i--)
		for(int j=N-1;j>=0;j--)
		    {
			if(words1[i].equals(words2[j]))
			    {
				sup[i][j]=sup[i+1][j+1]+1;
			    }
			else
			    {
				sup[i][j]=Math.min(sup[i+1][j],sup[i][j+1])+1;
			    }
		    }

	

	    int i=0,j=0;
	    while(i<M&&j<N)
		{
		    if(words1[i].equals(words2[j]))
			{
			    System.out.print(words1[i]+" ");
			    i++;j++;
			}
		    else if(sup[i+1][j]<sup[i][j+1])
			{
			     System.out.print(words1[i]+" ");
			     i++;
			}
		    else if(sup[i+1][j]>sup[i][j+1])
			{
			     System.out.print(words2[j]+" ");
			     j++;
			}
		     // sup[i-1][j]==sup[i][j-1], lexicographical ordering
		    else if(words1[i].compareTo(words2[j])<0)
		        {
			      System.out.print(words1[i]+" ");
			      i++;
			}
		    else if(words1[i].compareTo(words2[j])>0)
			 {
			      System.out.print(words2[j]+" ");
			      j++;
			 }
		}

	    // print rest of sequence
	    if(i==M)
		{
		    for(j=j;j<N;j++)
			{
			    System.out.print(words2[j]+" ");
			}
		}
	    else if(j==N)
		{
		    for(i=i;i<M;i++)
			{
			    System.out.print(words1[i]+" ");
			}
		}

	    System.out.println(".");
	}
}
