import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

/**
 * CTU Open Contest 2008
 * Solution for the problem: EXCHANGE.
 * October, 2008
 *
 * @author Martin Kacer
 */
public class exchange {
	static final int MAX = 10000;
	int n;
	String[] agent = new String[MAX];
	int[] price = new int[MAX];
	boolean[] sell = new boolean[MAX];

	boolean run() throws Exception {
		if ((n = nextInt()) == 0) return false;
		System.out.println(nextToken());
		for (int i = 0; i < n; ++i) {
			agent[i] = nextToken();
			sell[i] = nextToken().charAt(0) == 's';
			price[i] = Integer.parseInt(nextToken().replaceAll("[.]", ""));
		}
		for (int i = 0; i < n; ++i) {
			boolean no = true;
			System.out.print(agent[i] + ':');
			for (int j = 0; j < n; ++j) if (i != j)
				if (match(i,j)) {
					System.out.print(' ' + agent[j]);
					no = false;
				}
			if (no) System.out.print(" NO-ONE");
			System.out.println();
		}
		return true;
	}

	boolean match(int i, int j) {
		return (sell[i] && !sell[j] && price[i] <= price[j])
				|| (sell[j] && !sell[i] && price[j] <= price[i]);
	}

	public static void main(String[] args) throws Exception {
		exchange inst = new exchange();
		while (inst.run()) {}
	}

	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));

	String nextToken() throws Exception {
		while (!st.hasMoreTokens()) st = new StringTokenizer(input.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
}
