import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

/**
 * CTU Open Contest 2008
 * Solution for the problem: FENCE.
 * October, 2008
 *
 * @author Martin Kacer
 */
public class fence {
	static final int MAX = 20;
	static final double EPS = 1E-9;
	int n;
	int[] x = new int[MAX], y = new int[MAX];
	int[] v = new int[MAX], d = new int[MAX];

	boolean run() throws Exception {
		if ((n = nextInt()) == 0) return false;
		for (int i = 0; i < n; ++i) {
			x[i] = nextInt(); y[i] = nextInt();
			v[i] = nextInt(); d[i] = nextInt();
		}
		int max = (1<<n);
		int best = Integer.MAX_VALUE;
		for (int m = 0; m < max; ++m) { // bit=1 (cut) or bit=0 (left)
			int val = 0, len = 0;
			for (int i = 0; i < n; ++i) if (((1<<i) & m) != 0) {
				val += v[i]; len += d[i];
			}
			if (val < best && checkmask(m) < len+EPS) best = val;
		}
		System.out.println("The lost value is " + best + '.');
		return true;
	}

	double checkmask(int m) {
		double len = 0.0;
		for (int i = 0; i < n; ++i) if (((1<<i) & m) == 0)
			for (int j = 0; j < n; ++j) if (i != j && ((1<<j) & m) == 0) {
				if (checktree(x[i], y[i], x[j], y[j], m & ~((1<<i)|(1<<j))))
					len += dist(x[j]-x[i], y[j]-y[i]);
			}
		return len;
	}

	boolean checktree(int x1, int y1, int x2, int y2, int m) {
		for (int i = 0; i < n; ++i) if (((1<<i) & m) == 0) {
			int prod = (x[i]-x1) * (y2-y1) - (x2-x1) * (y[i]-y1);
			if (prod > 0) continue;
			if (prod < 0) return false;
			int a = x1, b = x[i], c = x2;
			if (a == b) {a = y1; b = y[i]; c = y2;}
			if ((a < b && b < c) || (a > b && b > c)) return false;
		}
		return true;
	}

	double dist(int x, int y) {
		return Math.sqrt(x*x + y*y);
	}

	public static void main(String[] args) throws Exception {
		fence inst = new fence();
		while (inst.run()) {}
	}

	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));

	String nextToken() throws Exception {
		while (!st.hasMoreTokens()) st = new StringTokenizer(input.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
}
