#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>

#define MAXN 1000000

/*
 * CTU Open Contest 2008
 * Solution: GAMBLING
 * Josef Cibulka, Oct 2008  
 */   


int n;
int dist;
int arc_len;
int price[MAXN+2];
int arc_sum[MAXN+2];
/* arc_sum[i] ... sum of prices on arc starting at i */

int mina1[MAXN+2];
int mina2[MAXN+2];
/* mina1[i] (mina2[1]) ... sum of prices on the smallest arc covering i 
 * and the left (right) neighbor of the globally smallest arc */

int main(void)
{
	int i,j,tmp,tmpmin;
	int dist;
	int best;
	int min_asum;
	
	while(1)
	{
		scanf("%d ", &n);
		if(n==0) break;
		for(i=0;i<n;i++) scanf(" %d ", &price[i]);
		arc_len = (n-1)/2;
		dist = arc_len/2;
		
		tmp = 0;
		for(i=0; i<arc_len; i++) tmp+=price[i];
		min_asum = -1;
		for(i=0; i<n; i++)
		{
			arc_sum[i] = tmp;
			if(min_asum==-1 || tmp<min_asum) min_asum = tmp;
			tmp-=price[i]; tmp+=price[(i+arc_len)%n];
		}

		best = -1;

		for(i=0;i<n;i++) if(arc_sum[i]==min_asum)
		{
			tmpmin = -1;
			for(j=i+arc_len;j>i;j--)
			{
				if(tmpmin==-1 || arc_sum[j%n]<tmpmin) tmpmin = arc_sum[j%n];
				mina1[(j+arc_len-1)%n] = tmpmin;
			}
			tmpmin = -1;
			for(j=i+arc_len+1;j<n+i;j++)
			{
				if(tmpmin==-1 || arc_sum[j%n]<tmpmin) tmpmin = arc_sum[j%n];
				mina2[j%n] = tmpmin;
			}
			for(j=i+arc_len+1; j<i+n;j++)
			{
				tmp = arc_sum[i] + mina1[(j-1)%n] + mina2[j%n];
				if(best==-1 || tmp<best) best = tmp;
			}
			break;
		}
		printf("%d\n", best);
	}
		
	return 0;
}

