/*
 * CTU Open 2009
 * Sample Solution: Letter Lies
 * Josef Cibulka
 */   


#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#define MAX(a,b) (((a)>(b))?(a):(b))
#define MAXN 1000
#define MAXM 1000000
#define BASE 1000000000

typedef struct my_long
{
	int len;
	int data[MAXN+2];
} my_long;

int n,m,l;
int ea[MAXM+2], eb[MAXM+2];
struct my_long pcnt[2][MAXN+2];

void ml_add(struct my_long *ml_to, struct my_long *ml_from)
{
	int i,tmp;
	int prev;
	
	tmp = MAX(ml_to->len, ml_from->len);
	for(i=ml_to->len;i<tmp; i++) ml_to->data[i]=0;
	for(i=ml_from->len;i<tmp; i++) ml_from->data[i]=0;
	
	prev = 0;
	for(i=0;i<tmp; i++) 
	{
		ml_to->data[i] += prev+ml_from->data[i];
		prev=0;
		if(ml_to->data[i]>=BASE) {prev++; ml_to->data[i] -= BASE;}
	}
	ml_to->len = tmp;
	if(prev>0)
	{
		ml_to->data[tmp] = prev;
		ml_to->len++;
	}
}

void print_ml(struct my_long *ml)
{
	int i;

	if(ml->len==0 || (ml->len==1 && ml->data[0] == 0)) 
	{ 
		printf("impossible\n"); return; 
	}
	
	assert(ml->data[ml->len-1] > 0);
	printf("%d", ml->data[ml->len-1]);
	
	for(i=ml->len-2;i>=0;i--)
	{
		printf("%09d",ml->data[i]);
	}
	printf("\n");
}

int main(void)
{
	int i,j,tmp;
	int begcnt, endcnt;

	while(1)
	{
		scanf("%d %d %d %d ", &n, &l, &begcnt, &endcnt);
		if(n==0) break;
		m=0;

		/* vertices 1-n are original ones, 0 and n+1 are artificial for beginning and end */
		for(i=0;i<n;i++) 
		{
			scanf(" %*d %d ", &tmp);
			for(j=0;j<tmp;j++)
			{
				scanf(" %d ", eb+m);
				ea[m++] = i+1;
			}
		}
		for(i=0;i<begcnt;i++)
		{
			scanf(" %d ", eb+m);
			ea[m++]=0;
		}
		for(i=0;i<endcnt;i++)
		{
			scanf(" %d ", ea+m);
			eb[m++]=n+1;
		}
		n = n+2;
		l = l+2;
		
		if(l>n) { printf("impossible\n"); continue; }
		
		for(i=0;i<n;i++) pcnt[1][i].len = 0;
		pcnt[1][0].len = 1;
		pcnt[1][0].data[0] = 1;

		for(i=2;i<=l;i++)
		{
			for(j=0;j<n;j++) pcnt[i&1][j].len = 0;
			for(j=0;j<m;j++) 
			{
				ml_add(&pcnt[i&1][eb[j]], &pcnt[1-(i&1)][ea[j]]);
			}
		}
		print_ml(&pcnt[l&1][n-1]);
	}
	return 0;
}
