/*
 * CTU Open 2009
 * Sample Solution: Letter Lies
 * Martin Kacer
 */   


import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;
import java.util.StringTokenizer;

public class ll {
class Node {
	int degree = 0;
	List<Node> pred = new ArrayList<Node>();
	List<Node> succ = new ArrayList<Node>();
	BigDecimal[] numb;
}

	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	public static void main(String[] args) throws Exception {
		ll inst = new ll();
		while (inst.run()) /* nothing */;
	}
	String nextToken() throws Exception {
		while (!st.hasMoreTokens()) st = new StringTokenizer(input.readLine());
		return st.nextToken();
	}
	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}

	static final int MAXN = 1000;
	static final int MAXL = 1000;
	Queue<Node> roots = new LinkedList<Node>();
	Node[] graph;
	int bb[] = new int[MAXN], ff[] = new int[MAXN];

	boolean run() throws Exception {
		int n = nextInt(), len = nextInt() - 1, b = nextInt(), f = nextInt();
		if (n == 0) return false;
		graph = new Node[n];
		for (int i = 0; i < graph.length; ++i)
			graph[i] = new Node();
		for (int i = 0; i < graph.length; ++i) {
			if (nextInt() != i+1) throw new IllegalStateException();
			int d = nextInt();
			while (d-- > 0) {
				int x = nextInt() - 1;
				graph[i].succ.add(graph[x]);
				graph[x].pred.add(graph[i]);
				graph[x].degree++;
			}
		}
		for (int i = 0; i < b; ++i) bb[i] = nextInt() - 1;
		for (int i = 0; i < f; ++i) ff[i] = nextInt() - 1;
		if (len > MAXN) {System.out.println("impossible"); return true;}
		for (int i = 0; i < n; ++i) {
			graph[i].numb = new BigDecimal[len+1];
			graph[i].numb[0] = BigDecimal.ZERO;
		}
		for (int i = 0; i < b; ++i) {
			graph[bb[i]].numb[0] = BigDecimal.ONE;
		}
		roots.clear();
		for (int i = 0; i < graph.length; ++i)
			if (graph[i].degree == 0) roots.add(graph[i]);
		while (!roots.isEmpty()) {
			Node x = roots.poll();
				for (int i = 1; i <= len; ++i) {
				BigDecimal cnt = BigDecimal.ZERO;
				for (Node p : x.pred) {
					cnt = cnt.add(p.numb[i-1]);
				}
				x.numb[i] = cnt;
			}
			for (Node s : x.succ)
				if (--s.degree == 0) roots.add(s);
		}
		BigDecimal res = BigDecimal.ZERO;
		for (int i = 0; i < f; ++i) {
			res = res.add(graph[ff[i]].numb[len]);
		}
		if (res.compareTo(BigDecimal.ZERO) > 0) {
			System.out.println(res);
		} else System.out.println("impossible");
		return true;
	}
}
