/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#define maxc 225
#define baza 10
#define writestring "%d"
#define fwd 5

typedef int BigNum[maxc];

int compare(BigNum, BigNum);
void add(BigNum, BigNum, BigNum);
void sub(BigNum, BigNum, BigNum);
void multbig(BigNum, BigNum, BigNum);
void divx(int, BigNum, BigNum, int*);

BigNum naux1, naux2, N, NN, li, ls, mid, x, unu;
char s[maxc];

int main()
{
int i, l, re, T, r, P, lastc;

freopen("puteri.in", "r", stdin);
freopen("puteri.out", "w", stdout);

scanf("%d", &T);

memset(unu, 0, sizeof(unu));
unu[0] = unu[1] = 1;

while (T--)
  {
    memset(N, 0, sizeof(N));
    for (scanf("%s %d", s, &P), N[0] = l = strlen(s), i = 0; i < l; i++)
      N[l-i] = s[i]-'0';

    memset(li, 0, sizeof(li));
    li[0] = li[1] = 1;
    memset(ls, 0, sizeof(ls));
    ls[0] = ((N[0] + 1) / P) + 3;
    ls[ls[0]] = 1;

    lastc = -1;
    while (compare(li, ls) <= 0)
      {
        add(li, ls, naux1);
        divx(2, naux1, mid, &r);

        memset(NN, 0, sizeof(NN));
        NN[0] = NN[1] = 1;
        for (i = 1; i <= P; i++)
          {
            multbig(mid, NN, naux1);
            memmove(NN, naux1, sizeof(BigNum));
          }

        if ((r = compare(NN, N)) <= 0)
          {
            lastc = r;
            memmove(x, mid, sizeof(BigNum));
            add(mid, unu, li);
          }
        else
          {
            sub(mid, unu, ls);
          }
      }

    printf("%d", x[x[0]]);
    for (i = x[0] - 1; i > 0; i--)
      printf(writestring, x[i]);
    printf("\n");

    if (lastc != 0)
      fprintf(stderr, "eroare\n");
  }

return 0;
}

/* 1 if n1 > n2 ; -1 if n1 < n2 ; 0 if n1 == n2 */
int compare(BigNum n1, BigNum n2)
{
int i, res;

if (n1[0] > n2[0]) return 1;
if (n1[0] < n2[0]) return -1;

for (res = 0, i = n1[0]; i >= 1; i--)
  if (n1[i] > n2[i])
    {
      res=1;
      break;
    }
  else
  if (n1[i] < n2[i])
    {
      res=-1;
      break;
    }

return res;
}

void add(BigNum n1, BigNum n2, BigNum rez)
{
int i, ndigits = n1[0];

if (n2[0] > ndigits)
  ndigits = n2[0];

memset(rez, 0, sizeof(BigNum));
for (i = 1; i <= ndigits; i++)
  rez[i] = n1[i]+n2[i];

for (i = 1 ;i <= (ndigits+fwd); i++)
  if (rez[i] >= baza)
    {
      rez[i+1] += (rez[i]/baza);
      rez[i] %= baza;
    }

for (i = (ndigits+fwd); i >= 1; i--)
  if (rez[i] > 0)
    {
      rez[0] = i;
      break;
    }

if (!rez[0])
  rez[0] = 1;
}

void sub(BigNum n1, BigNum n2, BigNum res)
{
int i, ndigits = n1[0];

memset(res, 0, sizeof(BigNum));
for (i = 1; i <= ndigits; i++)
  res[i] = n1[i] - n2[i];

for (i = 1; i <= ndigits; i++)
  while (res[i] < 0)
    {
      res[i] += baza;
      res[i+1]--;
    }

for (res[0] = 1, i = ndigits; i >= 1; i--)
  if (res[i])
    {
      res[0] = i;
      break;
    }

if (!res[0])
  res[0] = 1;
}

void multbig(BigNum n1, BigNum n2, BigNum rez)
{
int i, j, ndigits = n1[0]+n2[0]-1;

memset(rez, 0, sizeof(BigNum));
for (i = 1; i <= n1[0]; i++)
  for (j = 1; j <= n2[0]; j++)
    rez[i+j-1] += (n1[i]*n2[j]);

for (i = 1; i <= (ndigits+fwd); i++)
  if (rez[i] >= baza)
    {
      rez[i+1] += (rez[i]/baza);
      rez[i] %= baza;
    }

for (i = (ndigits+fwd); i >= 1; i--)
  if (rez[i] > 0)
    {
      rez[0] = i;
      break;
    }

if (!rez[0])
  rez[0] = 1;
}

void divx(int x, BigNum n, BigNum cat, int* rest)
{
int i, j, ndigits = 0, v;

memset(cat, 0, sizeof(BigNum));
v = 0, i = n[0];
while (v < x && i)
  {
    v = v*baza+n[i];
    i--;
  }

ndigits = 1, cat[1] = v/x, v=v%x;

for (; i; i--)
  {
    v = v*baza+n[i];
    cat[++ndigits] = v/x;
    v %= x;
  }
*rest = v;

for (v = ndigits>>1, i = 1; i <= v; i++)
  {
    j = cat[i];
    cat[i] = cat[ndigits-i+1];
    cat[ndigits-i+1]=j;
  }

cat[0] = ndigits;
}

