#include <stdio.h>
#include <string.h>

#define NMAX 10

char cb[NMAX][NMAX];
int att[NMAX][NMAX];
int i, j, k, N, nQ, nmax;
long int npos;

int dl[4] = {0, +1, +1, +1};
int dc[4] = {+1, +1, 0, -1};

void attack(int l, int c, int v)
{
int k, ln, cn;

for (k = 0; k < 4; k++)
  {
    ln = l + dl[k];
    cn = c + dc[k];

    while (ln > 0 && ln <= N && cn > 0 && cn <= N)
      {
        if (cb[ln][cn] == '#')
          break;

        att[ln][cn] += v;

        ln += dl[k];
        cn += dc[k];
      }
  }
}

void bkt(int l, int c)
{
if (c > N)
  {
    bkt(l+1, 1);
    return;
  }

if (l > N)
  return;

if (att[l][c] || cb[l][c] == '#')
  {
    bkt(l, c+1);
    return;
  }

/* aseaza regina */
attack(l, c, +1);
nQ++;

if (nQ > nmax)
  nmax = nQ, npos = 1;
else
if (nQ == nmax)
  npos++;

bkt(l, c+1);

/* scoate regina */
nQ--;
attack(l, c, -1);

bkt(l, c+1);
}

int main()
{
int T;

freopen("regine.in", "r", stdin);
freopen("regine.out", "w", stdout);

scanf("%d", &T);
while (T--)
  {
    scanf("%d", &N);

    memset(cb, 0, sizeof(cb));
    for (i = 1; i <= N; i++)
      for (j = 1; j <= N; j++)
        scanf(" %c", &cb[i][j]);

    nmax = nQ = 0;
    npos = 1;

    memset(att, 0, sizeof(att));
    bkt(1, 1);

    printf("%d %ld\n", nmax, npos);
  }

return 0;
}