#include <stdio.h>
#include <string.h>

#define NMAX 52
#define INF 10001

int edge[NMAX][NMAX], Dmin[NMAX][NMAX], Dcur[NMAX][NMAX];
int D[NMAX*NMAX], c1[NMAX*NMAX], c2[NMAX*NMAX];
int Daux[NMAX*NMAX], c1aux[NMAX*NMAX], c2aux[NMAX*NMAX];
int i, j, k, l, m, N, M, ok;
int d1, d2;

void sort(int li, int ls)
{
if (ls > li)
  {
    sort(li, (li + ls) >> 1);
    sort(((li + ls) >> 1) + 1, ls);

    k = li - 1;
    i = li;
    m = (li + ls) >> 1;
    j = m + 1;

    while (i <= m && j <= ls)
      {
        k++;

        if (D[i] <= D[j])
          {
            Daux[k] = D[i];
            c1aux[k] = c1[i];
            c2aux[k] = c2[i];
            i++;
          }
        else
          {
            Daux[k] = D[j];
            c1aux[k] = c1[j];
            c2aux[k] = c2[j];
            j++;
          }
      }

    if (i <= m)
      {
        for (j = i; j <= m; j++)
          {
            k++;
            Daux[k] = D[j];
            c1aux[k] = c1[j];
            c2aux[k] = c2[j];
          }
      }
    else
      {
        for (i = j; i <= ls; i++)
          {
            k++;
            Daux[k] = D[i];
            c1aux[k] = c1[i];
            c2aux[k] = c2[i];
          }
      }

    for (k = li; k <= ls; k++)
      {
        D[k] = Daux[k];
        c1[k] = c1aux[k];
        c2[k] = c2aux[k];
      }
  }
}

int main()
{
int T;

freopen("roy.in", "r", stdin);
freopen("roy.out", "w", stdout);

scanf("%d", &T);
while (T--)
  {
    scanf("%d %d", &N, &M);
    memset(edge, 0, sizeof(edge));

    for (k = 1; k <= M; k++)
      {
        scanf("%d %d", &i, &j);
        edge[i][j] = edge[j][i] = 1;
      }

    for (i = 1; i <= N; i++)
      for (j = 1; j <= N; j++)
        {
          scanf("%d", &Dmin[i][j]);

          if (j != i)
            Dcur[i][j] = INF;
          else
            Dcur[i][i] = 0;
        }

    // sorteaza distantele minime
    M = 0;
    for (i = 1; i < N; i++)
      for (j = i + 1; j <= N; j++)
        {
          D[++M] = Dmin[i][j];
          c1[M] = i, c2[M] = j;
        }

    sort(1, M);

    ok = 1;
    for (k = 1; k <= M; k++)
      {
        i = c1[k];
        j = c2[k];

        if ((Dcur[i][j] < Dmin[i][j]) ||
           (Dcur[i][j] > Dmin[i][j] && !edge[i][j]))
          {
            ok = 0;
            break;
          }

        if (Dcur[i][j] > Dmin[i][j] && edge[i][j])
          {
            Dcur[i][j] = Dcur[j][i] = Dmin[i][j];

            for (l = 1; l <= N; l++)
              for (m = 1; m <= N; m++)
                {
                  if (Dcur[l][i] < Dcur[l][j])
                    d1 = Dcur[l][i];
                  else
                    d1 = Dcur[l][j];

                  if (Dcur[m][i] < Dcur[m][j])
                    d2 = Dcur[m][i];
                  else
                    d2 = Dcur[m][j];

                  if (d1 + d2 + Dmin[i][j] < Dcur[l][m])
                    Dcur[l][m] = d1 + d2 + Dmin[i][j];
                }
          }
      }

    if (ok)
      printf("DA\n");
    else
      printf("NU\n");
  }

return 0;
}