#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <set>

using namespace std;

#define NMAX 1010
#define INF 666666666
#define BIGINT double
#define format "%.0lf"

#define NORTH 0
#define EAST 1
#define SOUTH 2
#define WEST 3

typedef pair<int, pair< pair<int, int> , char> > heap_elem;

int drow[4] = { -1, 0, +1, 0 };
int dcol[4] = { 0, +1, 0, -1 }; 

int s[NMAX][NMAX], srow[NMAX][NMAX], scol[NMAX][NMAX];
unsigned char edge[NMAX][NMAX][4];
int serow[NMAX][NMAX], secol[NMAX][NMAX];
int dmin[NMAX][NMAX][3];
BIGINT ntours[NMAX][NMAX][3], nt; 
int i, j, k, l, M, N, Mnext, t, hsize;
char ss[3];

set<heap_elem> heap;
set<heap_elem>::iterator it;
heap_elem he;

void update(int t, int i1, int j1, int k1, int i2, int j2, int k2)
{
	if (t < dmin[i2][j2][k2])
	{
		he.first = dmin[i2][j2][k2];
		he.second.first.first = i2;
		he.second.first.second = j2;
		he.second.second = k2;

		it = heap.lower_bound(he);

		if (it != heap.end())
		{
			if ((*it).second.first.first == i2 && (*it).second.first.second == j2 &&
				(*it).second.second == k2)
			{
				heap.erase(it);
				hsize--;
			}
		}

		dmin[i2][j2][k2] = t;
		ntours[i2][j2][k2] = ntours[i1][j1][k1];

		he.first = dmin[i2][j2][k2];
		he.second.first.first = i2;
		he.second.first.second = j2;
		he.second.second = k2;

		heap.insert(he);
		hsize++;
	}
	else
	if (t == dmin[i2][j2][k2])
		ntours[i2][j2][k2] += ntours[i1][j1][k1];
}

int main()
{
	freopen("B.in", "r", stdin);
	freopen("B.out", "w", stdout);

	if (scanf("%d", &Mnext) == 0)
		return 0;

	while (scanf("%d", &N) == 1)
	{
		M = Mnext;

		for (i = 0; i < M; i++)
			for (j = 0; j < N; j++)
				for (k = 0; k < 4; k++)
					edge[i][j][k] = 1;

		// citirea

		i = j = 0;
		scanf("%d", &k);

		while (i < M)
		{
			s[i][j] = k;

			do
			{
				k = -1;

				ss[0] = '0';
				ss[1] = 0;

				scanf("%s", ss);

				if (ss[0] == 'x')
					edge[i][j][EAST] = edge[i][j + 1][WEST] = 0;
				else
				if (ss[0] == 'y')
					edge[i][j][SOUTH] = edge[i + 1][j][NORTH] = 0;
				else
					k = atoi(ss);
			}
			while (k == -1);

			j++;
			if (j == N)
				j = 0, i++;
		}

		Mnext = k;

		// precalculare srow

		for (i = 0; i < M; i++)
		{
			srow[i][0] = 0;
			serow[i][0] = 0;

			for (j = 1; j < N; j++)
			{
				srow[i][j] = srow[i][j - 1] + abs(s[i][j] - s[i][j - 1]);
				serow[i][j] = serow[i][j - 1] + edge[i][j][WEST];
			}
		}

		// precalculare scol

		for (j = 0; j < N; j++)
		{
			scol[0][j] = 0;
			secol[0][j] = 0;

			for (i = 1; i < M; i++)
			{
				scol[i][j] = scol[i - 1][j] + abs(s[i][j] - s[i - 1][j]);
				secol[i][j] = secol[i - 1][j] + edge[i][j][NORTH];
			}
		}

		// Dijkstra cu heap-uri

		for (i = 0; i < M; i++)
			for (j = 0; j < N; j++)
				for (k = 0; k < 3; k++)
					dmin[i][j][k] = INF,
					ntours[i][j][k] = 0;

		dmin[0][0][1] = s[0][0];
		ntours[0][0][1] = 1;

		heap.clear();

		he.first = dmin[0][0][1];
		he.second.first.first = 0;
		he.second.first.second = 0;
		he.second.second = 1;

		heap.insert(he);
		hsize = 1;

		for (j = 1; j < N; j++)
			if (serow[0][j] == j)
			{
				dmin[0][j][1] = s[0][0] + srow[0][j];
				ntours[0][j][1] = 1;

				he.first = dmin[0][j][1];
				he.second.first.first = 0;
				he.second.first.second = j;
				he.second.second = 1;

				heap.insert(he);
				hsize++;
			}

		for (i = 1; i < M; i++)
			if (secol[i][0] == i)
			{
				dmin[i][0][1] = s[0][0] + scol[i][0];
				ntours[i][0][1] = 1;

				he.first = dmin[i][0][1];
				he.second.first.first = i;
				he.second.first.second = 0;
				he.second.second = 1;

				heap.insert(he);
				hsize++;
			}

		while (hsize > 0)
		{
			he.first = -INF;
			it = heap.upper_bound(he);
		
			i = (*it).second.first.first;
			j = (*it).second.first.second;
			k = (*it).second.second;

			heap.erase(it);
			hsize--;

			if (i < M - 1)
			{
				if (k == 0 && edge[i][0][SOUTH] && serow[i + 1][j] == j && j > 0)
				{
					t = dmin[i][j][k] + abs(s[i + 1][0] - s[i][0]) + srow[i + 1][j]; 
				
					update(t, i, j, k, i + 1, j, 1);
				}
				else
				if (k == 1 && edge[i][j][SOUTH] && serow[i + 1][j] == j && j > 0)
				{
					t = dmin[i][j][k] + abs(s[i + 1][j] - s[i][j]) + srow[i + 1][j];

					update(t, i, j, k, i + 1, j, 0);
				}
			}

			if (j < N - 1)
			{
				if (k == 1 && edge[i][j][EAST] && secol[i][j + 1] == i && i > 0)
				{
					t = dmin[i][j][k] + abs(s[i][j] - s[i][j + 1]) + scol[i][j + 1];

					update(t, i, j, k, i, j + 1, 2);
				}
				else
				if (k == 2 && edge[0][j][EAST] && secol[i][j + 1] == i && i > 0)
				{
					t = dmin[i][j][k] + abs(s[0][j] - s[0][j + 1]) + scol[i][j + 1];

					update(t, i, j, k, i, j + 1, 1);
				}
			}
		}

		if (dmin[M - 1][N - 1][0] < INF)
			dmin[M - 1][N - 1][0] += s[M - 1][0];

		if (dmin[M - 1][N - 1][1] < INF)
			dmin[M - 1][N - 1][1] += s[M - 1][N - 1];

		if (dmin[M - 1][N - 1][2] < INF)
			dmin[M - 1][N - 1][2] += s[0][N - 1];

		// afisare

		k = dmin[M - 1][N - 1][0];
		nt = ntours[M - 1][N - 1][0];

		if (dmin[M - 1][N - 1][1] == k)
			nt += ntours[M - 1][N - 1][1];
		else
		if (dmin[M - 1][N - 1][1] < k)
		{
			k = dmin[M - 1][N - 1][1];
			nt = ntours[M - 1][N - 1][1];
		}

		if (dmin[M - 1][N - 1][2] == k)
			nt += ntours[M - 1][N - 1][2];
		else
		if (dmin[M - 1][N - 1][2] < k)
		{
			k = dmin[M - 1][N - 1][2];
			nt = ntours[M - 1][N - 1][2];
		}

		if (k == INF)
			printf("No solution\n");
		else
		{
			printf(format, nt);
			printf(" tours, traveling a minimum of %d total floors\n", k);
		}

		fprintf(stderr, "%d %d : %d\n", M, N, k);
	}

	return 0;
}