#include <stdio.h>
#include <math.h>

#include <algorithm>
#include <vector>

using namespace std;

#define NMAX 41111
#define eps 1e-5

vector<pair<double, int> > v;

double x[NMAX], y[NMAX], R[NMAX];
double lx, llx, d;
int dom[NMAX];
int i, j, k, l, N;

int main()
{
    freopen("D.in", "r", stdin);
	freopen("D.out", "w", stdout);

    while (scanf("%d", &N) == 1)
	{
		v.clear();

    for (i = 0; i < N; i++)
    {
        dom[i] = 0;
        scanf("%lf %lf %lf", &R[i], &x[i], &y[i]);
        v.push_back(make_pair(x[i] - R[i], i));
    }

    sort(v.begin(), v.end());

    lx = v[0].first - 1.0;
    k = -1;
    for (i = 0; i < N; i++)
    {
        llx = v[i].first + 2.0 * R[v[i].second];
        if (llx > lx && fabs(llx - lx) > eps)
           dom[v[i].second] = 0, lx = llx, k = v[i].second;
        else
        {
            l = v[i].second;

            d = (x[k] - x[l]) * (x[k] - x[l]) +
                (y[k] - y[l]) * (y[k] - y[l]);

            if (d < R[k] * R[k] || fabs(d - R[k] * R[k]) < eps)
               dom[l] = 1;
        }
    }

    v.clear();
    for (i = 0; i < N; i++)
        v.push_back(make_pair(y[i] - R[i], i));

    sort(v.begin(), v.end());

    lx = v[0].first - 1.0;
    k = -1;
    for (i = 0; i < N; i++)
    {
        llx = v[i].first + 2.0 * R[v[i].second];
        if (llx > lx && fabs(llx - lx) > eps)
           dom[v[i].second] = 0, lx = llx, k = v[i].second;
        else
        {
                l = v[i].second;

            d = (x[k] - x[l]) * (x[k] - x[l]) +
                (y[k] - y[l]) * (y[k] - y[l]);

            if (d < R[k] * R[k] || fabs(d - R[k] * R[k]) < eps)
               dom[l] = 1;
        }
    }

    v.clear();
    for (i = 0; i < N; i++)
    {
        v.push_back(make_pair(R[i] * R[i], i));
    }
    
    sort(v.begin(), v.end());
    
    for (i = N - 1; i >= 0; i--)
        if (!dom[v[i].second])
        {
            k = v[i].second;
            
            dom[k] = 0;
            for (j = N - 1; j > i; j--)
            {
                l = v[j].second;

                d = (x[k] - x[l]) * (x[k] - x[l]) +
                    (y[k] - y[l]) * (y[k] - y[l]);

                if (d < v[j].first)
                {
                    dom[k] = 1;
                    break;
                }
            }
        }

    k = 0;
    for (i = 0; i < N; i++)
        if (!dom[i])
           k++;

    printf("%d\n", k);
    for (i = 0; i < N; i++)
        if (!dom[i])
        {
         printf("%d", i + 1);
         k--;
         if (k)
            printf(" ");
        }
    printf("\n");

	fprintf(stderr, "%d\n", N);
	}
}
