#include <stdio.h>
#include <string.h>
#include <math.h>

#include <set>
#include <vector>
#include <algorithm>

using namespace std;

#define NMAX 41111
#define eps 1e-7

set<pair<double, int> > intv;
vector<pair<double, int> > v;

double R[NMAX], xc[NMAX], yc[NMAX], yint[NMAX];
int dominat[NMAX], inside[NMAX];
int i, j, k, N;

void do_stuff(double xx, int nod)
{
	set<pair<double, int> >::iterator it, itx;
	double z1, z2, t1, t2, d;
	int y;

	if (!inside[nod]) // trebuie introdus
	{
		t1 = yc[nod] - R[nod];
		t2 = yc[nod] + R[nod];

		it = intv.lower_bound(make_pair(t1, nod));

		if (it != intv.begin())
			it--;

		while (it != intv.end())
		{		
			z1 = (*it).first;
			y = (*it).second;
			z2 = 2 * yc[y] - z1;

			if (z1 > t2)
			{
				it = intv.end();
				break;
			}

			if (z2 < t1)
			{
				it++;
				continue;
			}

			d = sqrt((xc[nod] - xc[y]) * (xc[nod] - xc[y]) +
				     (yc[nod] - yc[y]) * (yc[nod] - yc[y]));

			if (d + R[nod] < R[y])
			{
				dominat[nod] = 1;
				inside[nod] = 2;
				break;
			}
			else
			if (d + R[y] < R[nod])
			{
				dominat[y] = 1;
				inside[y] = 2;

				itx = it;
				itx++;

				intv.erase(*it);

				it = itx;
			}
			else
			{
				// update la "y"

				itx = it;
				itx++;

				intv.erase(*it);

				yint[y] = yc[y] - sqrt(R[y] * R[y] - (xx - xc[y]) * (xx - xc[y]));
				intv.insert(make_pair(yint[y], y));

				it = itx;
			}
		}

		if (it == intv.end())
		{
			intv.insert(make_pair(yc[nod] - R[nod], nod));
			yint[nod] = yc[nod] - R[nod];
			inside[nod] = 1;
		}
	}
	else
	if (inside[nod] == 1)
	{
		it = intv.lower_bound(make_pair(yint[nod], nod));
		
		while ((*it).second != nod)
			it--;

		intv.erase(*it);

		inside[nod] = 2;
	}
}

int main()
{
	freopen("D.in", "r", stdin);
	freopen("D.out", "w", stdout);

	while (scanf("%d", &N) == 1)
	{
		for (i = 1; i <= N; i++)
			scanf("%lf %lf %lf", &R[i], &xc[i], &yc[i]);

		memset(dominat, 0, sizeof(dominat));

		// trecerea 1

		v.clear();

		for (i = 1; i <= N; i++)
		{
			v.push_back(make_pair(xc[i], i));
			v.push_back(make_pair(xc[i] + R[i], i));
		}
		
		sort(v.begin(), v.end());

		intv.clear();
		memset(inside, 0, sizeof(inside));

		for (k = 0; k < 2 * N; k++)
			do_stuff(v[k].first, v[k].second);

		// trecerea 2

		v.clear();

		for (i = 1; i <= N; i++)
		{
			v.push_back(make_pair(xc[i], i));
			v.push_back(make_pair(xc[i] - R[i], i));
		}
		
		sort(v.begin(), v.end());

		intv.clear();
		memset(inside, 0, sizeof(inside));

		for (k = 2 * N - 1; k >= 0; k--)
			do_stuff(v[k].first, v[k].second);

		k = 0;

		for (i = 1; i <= N; i++)
			if (!dominat[i])
				k++;

		printf("%d\n", k);

		j = 1;
		for (i = 1; i <= N; i++)
			if (!dominat[i])
			{			
				if (!j)
					printf(" ");

				printf("%d", i);
			
				j = 0;
			}

		printf("\n");

		//fflush(stdout);
		//fprintf(stderr, "%d\n", N);
	}

	return 0;
}