#include <stdio.h>
#include <math.h>

#define eps 1e-10

int r, a, s;
double R, alfa, S, d, d1, u, pi;

double dist2d(double xa, double ya, double xb, double yb)
{
	return sqrt((xa - xb) * (xa - xb) + (ya - yb) * (ya - yb));
}

double my_fmod(double A, double B)
{
	double i, x, z;

	x = floor(A / B);

	for (i = x - 1; i <= x + 1; i++)
	{
		z = A - B * i;

		if ((z > 0 || fabs(z) < eps) && (z < B))
			return z;
	}
}

int main()
{
	int T;

	pi = 2.0 * acos(0.0);

	freopen("I.in", "r", stdin);
	freopen("I.out", "w", stdout);

	scanf("%d", &T);

	while (T--)
	{
		scanf("%d %d %d", &r, &a, &s);

		R = r;
		alfa = a;
		alfa = alfa * pi / 180.0;

		d = dist2d(R * cos(alfa), R * sin(alfa), R, 0);
		
		S = s;
		//d1 = fmod(S, d);
		d1 = my_fmod(S, d);
		u = 0.5 * (pi - alfa);

		// Teorema lui Pitagora generalizata
		d = sqrt(R * R + d1 * d1 - 2.0 * R * d1 * cos(u));

		printf("Distance to origin = %.3lf.\n", d);
	}

	return 0;
}